#  GLPK.jl

[![Build Status](https://github.com/jump-dev/GLPK.jl/workflows/CI/badge.svg?branch=master)](https://github.com/jump-dev/GLPK.jl/actions?query=workflow%3ACI)
[![codecov](https://codecov.io/gh/jump-dev/GLPK.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/jump-dev/GLPK.jl)

[GLPK.jl](https://github.com/jump-dev/GLPK.jl) is a wrapper for the [GNU Linear Programming Kit library](https://www.gnu.org/software/glpk).

The wrapper has two components:

 * a thin wrapper around the complete C API
 * an interface to [MathOptInterface](https://github.com/jump-dev/MathOptInterface.jl)

## Affiliation

This wrapper is maintained by the JuMP community and is not an GNU project.

## License

`GLPK.jl` is licensed under the [GPL v3 license](https://github.com/jump-dev/GLPK.jl/blob/master/LICENSE.md).

## Installation

Install GLPK using `Pkg.add`:
```julia
import Pkg
Pkg.add("GLPK")
```

In addition to installing the GLPK.jl package, this will also download and
install the GLPK binaries. You do not need to install GLPK separately.

To use a custom binary, read the [Custom solver binaries](https://jump.dev/JuMP.jl/stable/developers/custom_solver_binaries/)
section of the JuMP documentation.

## Use with JuMP

To use GLPK with JuMP, use `GLPK.Optimizer`:
```julia
using JuMP, GLPK
model = Model(GLPK.Optimizer)
set_attribute(model, "tm_lim", 60 * 1_000)
set_attribute(model, "msg_lev", GLPK.GLP_MSG_OFF)
```

If the model is primal or dual infeasible, GLPK will attempt to find a
certificate of infeasibility. This can be expensive, particularly if you do not
intend to use the certificate. If this is the case, use:
```julia
model = Model(() -> GLPK.Optimizer(; want_infeasibility_certificates = false))
```

## MathOptInterface API

The GLPK optimizer supports the following constraints and attributes.

List of supported objective functions:

 * [`MOI.ObjectiveFunction{MOI.ScalarAffineFunction{Float64}}`](@ref)

List of supported variable types:

 * [`MOI.Reals`](@ref)

List of supported constraint types:

 * [`MOI.ScalarAffineFunction{Float64}`](@ref) in [`MOI.EqualTo{Float64}`](@ref)
 * [`MOI.ScalarAffineFunction{Float64}`](@ref) in [`MOI.GreaterThan{Float64}`](@ref)
 * [`MOI.ScalarAffineFunction{Float64}`](@ref) in [`MOI.LessThan{Float64}`](@ref)
 * [`MOI.VariableIndex`](@ref) in [`MOI.EqualTo{Float64}`](@ref)
 * [`MOI.VariableIndex`](@ref) in [`MOI.GreaterThan{Float64}`](@ref)
 * [`MOI.VariableIndex`](@ref) in [`MOI.Integer`](@ref)
 * [`MOI.VariableIndex`](@ref) in [`MOI.Interval{Float64}`](@ref)
 * [`MOI.VariableIndex`](@ref) in [`MOI.LessThan{Float64}`](@ref)
 * [`MOI.VariableIndex`](@ref) in [`MOI.ZeroOne`](@ref)

List of supported model attributes:

 * [`MOI.HeuristicCallback()`](@ref)
 * [`MOI.LazyConstraintCallback()`](@ref)
 * [`MOI.Name()`](@ref)
 * [`MOI.ObjectiveSense()`](@ref)
 * [`MOI.UserCutCallback()`](@ref)

## Options

Options for GLPK are comprehensively documented in the [PDF documentation](https://github.com/jump-dev/GLPK.jl/files/11143880/glpk.pdf),
but they are hard to find.

 * Options when solving a linear program are defined in Section 2.8.1
 * Options when solving a mixed-integer program are defined in Section 2.10.5

However, the following options are likely to be the most useful:

| Parameter      | Example            | Explanation                            |
| -------------- | ------------------ | -------------------------------------- |
| `msg_lev`      | `GLPK.GLP_MSG_ALL` | Message level for terminal output      |
| `presolve`     | `GLPK.GLP_ON`      | Turn presolve on or off                |
| `tol_int`      | `1e-5`             | Absolute tolerance for integer feasibility |
| `tol_obj`      | `1e-7`             | Relative objective tolerance for mixed-integer programs |

## Callbacks

Here is an example using GLPK's solver-specific callbacks.

```julia
using JuMP, GLPK, Test

model = Model(GLPK.Optimizer)
@variable(model, 0 <= x <= 2.5, Int)
@variable(model, 0 <= y <= 2.5, Int)
@objective(model, Max, y)
reasons = UInt8[]
function my_callback_function(cb_data)
    reason = GLPK.glp_ios_reason(cb_data.tree)
    push!(reasons, reason)
    if reason != GLPK.GLP_IROWGEN
        return
    end
    x_val = callback_value(cb_data, x)
    y_val = callback_value(cb_data, y)
    if y_val - x_val > 1 + 1e-6
        con = @build_constraint(y - x <= 1)
        MOI.submit(model, MOI.LazyConstraint(cb_data), con)
    elseif y_val + x_val > 3 + 1e-6
        con = @build_constraint(y - x <= 1)
        MOI.submit(model, MOI.LazyConstraint(cb_data), con)
    end
end
MOI.set(model, GLPK.CallbackFunction(), my_callback_function)
optimize!(model)
@test termination_status(model) == MOI.OPTIMAL
@test primal_status(model) == MOI.FEASIBLE_POINT
@test value(x) == 1
@test value(y) == 2
@show reasons
```

## C API

The C API can be accessed via `GLPK.glp_XXX` functions, where the names and
arguments are identical to the C API. See the `/tests` folder for inspiration.

## Thread safety

GLPK is not thread-safe and should not be used with multithreading.

# Copyright (c) 2012 GLPK.jl contributors
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the Licence, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# ==============================================================================
#    Generic Callbacks in GLPK
# ==============================================================================

"""
    CallbackFunction()

Set a generic GLPK callback function.
"""
struct CallbackFunction <: MOI.AbstractCallback end

MOI.supports(::Optimizer, ::CallbackFunction) = true

function MOI.set(model::Optimizer, ::CallbackFunction, callback::Function)
    model.has_generic_callback = true
    _set_callback(model, (cb_data) -> begin
        model.callback_state = _CB_GENERIC
        try
            callback(cb_data)
        finally
            model.callback_state = _CB_NONE
        end
    end)
    return
end

# ==============================================================================
#    MOI callbacks
# ==============================================================================

function _default_moi_callback(model::Optimizer)
    return (cb_data) -> begin
        reason = glp_ios_reason(cb_data.tree)
        if reason == GLP_IROWGEN && model.lazy_callback !== nothing
            model.callback_state = _CB_LAZY
            model.lazy_callback(cb_data)
        elseif reason == GLP_ICUTGEN && model.user_cut_callback !== nothing
            model.callback_state = _CB_USER_CUT
            model.user_cut_callback(cb_data)
        elseif reason == GLP_IHEUR && model.heuristic_callback !== nothing
            model.callback_state = _CB_HEURISTIC
            model.heuristic_callback(cb_data)
        end
        return
    end
end

function MOI.get(
    model::Optimizer,
    attr::MOI.CallbackVariablePrimal{CallbackData},
    x::MOI.VariableIndex,
)
    subproblem = glp_ios_get_prob(attr.callback_data.tree)
    return glp_get_col_prim(subproblem, _info(model, x).column)
end

function MOI.get(model::Optimizer, attr::MOI.CallbackNodeStatus{CallbackData})
    reason = glp_ios_reason(attr.callback_data.tree)
    if reason == GLP_ISELECT
        return MOI.CALLBACK_NODE_STATUS_UNKNOWN
    elseif reason == GLP_IPREPRO
        return MOI.CALLBACK_NODE_STATUS_UNKNOWN
    elseif reason == GLP_IROWGEN
        # From the the GLPK documentation:
        #
        # The callback routine is called with the reason code GLP_IROWGEN if LP
        # relaxation of the current subproblem has just been solved to
        # optimality and its objective value is better than the best known
        # integer feasible solution.
        #
        # This can mean the solution is integer _or_ fractional, so we need to
        # check.
        subproblem = glp_ios_get_prob(attr.callback_data.tree)
        for info in values(model.variable_info)
            if info.type == _CONTINUOUS
                continue
            end
            x = glp_get_col_prim(subproblem, info.column)
            if abs(x - round(Int, x)) > 1e-7
                return MOI.CALLBACK_NODE_STATUS_FRACTIONAL
            end
        end
        return MOI.CALLBACK_NODE_STATUS_INTEGER
    elseif reason == GLP_IHEUR
        return MOI.CALLBACK_NODE_STATUS_FRACTIONAL
    elseif reason == GLP_ICUTGEN
        return MOI.CALLBACK_NODE_STATUS_FRACTIONAL
    elseif reason == GLP_IBRANCH
        return MOI.CALLBACK_NODE_STATUS_FRACTIONAL
    else
        @assert reason == GLP_IBINGO
        return MOI.CALLBACK_NODE_STATUS_INTEGER
    end
end

# ==============================================================================
#    MOI.LazyConstraint
# ==============================================================================

MOI.supports(::Optimizer, ::MOI.LazyConstraintCallback) = true

MOI.supports(::Optimizer, ::MOI.LazyConstraint{CallbackData}) = true

function MOI.set(model::Optimizer, ::MOI.LazyConstraintCallback, cb::Function)
    model.lazy_callback = cb
    return
end

function MOI.submit(
    model::Optimizer,
    cb::MOI.LazyConstraint{CallbackData},
    f::MOI.ScalarAffineFunction{Float64},
    s::Union{
        MOI.LessThan{Float64},
        MOI.GreaterThan{Float64},
        MOI.EqualTo{Float64},
    },
)
    if model.callback_state == _CB_USER_CUT
        throw(MOI.InvalidCallbackUsage(MOI.UserCutCallback(), cb))
    elseif model.callback_state == _CB_HEURISTIC
        throw(MOI.InvalidCallbackUsage(MOI.HeuristicCallback(), cb))
    end
    key = CleverDicts.add_item(model.affine_constraint_info, _ConstraintInfo(s))
    model.affine_constraint_info[key].row = length(model.affine_constraint_info)
    indices, coefficients = _indices_and_coefficients(model, f)
    sense, rhs = _sense_and_rhs(s)
    inner = glp_ios_get_prob(cb.callback_data.tree)
    _add_affine_constraint(
        inner,
        indices,
        coefficients,
        sense,
        rhs - f.constant,
    )
    return
end

# ==============================================================================
#    MOI.UserCutCallback
# ==============================================================================

MOI.supports(::Optimizer, ::MOI.UserCutCallback) = true
MOI.supports(::Optimizer, ::MOI.UserCut{CallbackData}) = true

function MOI.set(model::Optimizer, ::MOI.UserCutCallback, cb::Function)
    model.user_cut_callback = cb
    return
end

function MOI.submit(
    model::Optimizer,
    cb::MOI.UserCut{CallbackData},
    f::MOI.ScalarAffineFunction{Float64},
    s::Union{MOI.LessThan{Float64},MOI.GreaterThan{Float64}},
)
    if model.callback_state == _CB_LAZY
        throw(MOI.InvalidCallbackUsage(MOI.LazyConstraintCallback(), cb))
    elseif model.callback_state == _CB_HEURISTIC
        throw(MOI.InvalidCallbackUsage(MOI.HeuristicCallback(), cb))
    end
    indices, coefficients = _indices_and_coefficients(model, f)
    sense, rhs = _sense_and_rhs(s)
    bound_type = sense == Cchar('G') ? GLP_LO : GLP_UP
    glp_ios_add_row(
        cb.callback_data.tree,
        "",
        101,
        0,
        Cint(length(indices)),
        offset(indices),
        offset(coefficients),
        bound_type,
        rhs,
    )
    return
end

# ==============================================================================
#    MOI.HeuristicCallback
# ==============================================================================

MOI.supports(::Optimizer, ::MOI.HeuristicCallback) = true
MOI.supports(::Optimizer, ::MOI.HeuristicSolution{CallbackData}) = true

function MOI.set(model::Optimizer, ::MOI.HeuristicCallback, cb::Function)
    model.heuristic_callback = cb
    return
end

function MOI.submit(
    model::Optimizer,
    cb::MOI.HeuristicSolution{CallbackData},
    variables::Vector{MOI.VariableIndex},
    values::MOI.Vector{Float64},
)
    if model.callback_state == _CB_LAZY
        throw(MOI.InvalidCallbackUsage(MOI.LazyConstraintCallback(), cb))
    elseif model.callback_state == _CB_USER_CUT
        throw(MOI.InvalidCallbackUsage(MOI.UserCutCallback(), cb))
    end
    solution = fill(NaN, MOI.get(model, MOI.NumberOfVariables()))
    for (var, value) in zip(variables, values)
        solution[_info(model, var).column] = value
    end
    ret = glp_ios_heur_sol(cb.callback_data.tree, offset(solution))
    return ret == 0 ? MOI.HEURISTIC_SOLUTION_ACCEPTED :
           MOI.HEURISTIC_SOLUTION_REJECTED
end

# Copyright (c) 2012 GLPK.jl contributors
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the Licence, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

import Clang
import GLPK_jll

GEN_DIR = joinpath(dirname(@__DIR__), "src", "gen")

const COMMON = joinpath(GEN_DIR, "libglpk_common.jl")

wc = Clang.init(
    headers = [
        joinpath(GLPK_jll.artifact_dir, "include", "glpk.h"),
    ],
    output_file = joinpath(GEN_DIR, "libglpk_api.jl"),
    common_file = COMMON,
    header_wrapped = (root, current) -> root == current,
    header_library = x -> "libglpk",
    clang_diagnostics = true,
)

run(wc)

function manual_corrections()
    file = read(COMMON, String)
    for correction in [
        "tail::Ptr{glp_vertex}" => "tail::Ptr",
        "head::Ptr{glp_vertex}" => "head::Ptr",
        "struct " => "mutable struct ",
    ]
        file = replace(file, correction)
    end

    function new_functions(name, constr)
        s = constr ? "\n    $(name)() = new()\nend" : "\nend"
        return """
        $(s)

        Base.cconvert(::Type{Ptr{$(name)}}, x::$(name)) = x
        function Base.unsafe_convert(::Type{Ptr{$(name)}}, x::$(name))
            return convert(Ptr{$(name)}, pointer_from_objref(x))
        end"""
    end
    for (s_type, constr) in [
        "glp_bfcp" => false,
        "glp_smcp" => true,
        "glp_iptcp" => true,
        "glp_iocp" => true,
        "glp_attr" => false,
        "glp_mpscp" => true,
        "glp_cpxcp" => true,
        "glp_arc" => false,
        "glp_vertex" => false,
        "glp_graph" => false,
    ]
        r = Regex("(mutable struct $(s_type).+?end)", "s")
        str = replace(match(r, file)[1], "\nend" => new_functions(s_type, constr))
        file = replace(file, r => str)
    end
    write(COMMON, file)
end
manual_corrections()

rm(joinpath(GEN_DIR, "LibTemplate.jl"))

# Copyright (c) 2012 GLPK.jl contributors
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the Licence, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

module TestCallbacks

using GLPK
using Random
using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if !startswith("$(name)", "test_")
            continue
        elseif startswith("$(name)", "test_no_cache_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        else
            @testset "$(name)_cache" begin
                getfield(@__MODULE__, name)(true)
            end
            @testset "$(name)_no_cache" begin
                getfield(@__MODULE__, name)(false)
            end
        end
    end
    return
end

function _callback_simple_model(cache)
    model = if cache
        m = MOI.Utilities.CachingOptimizer(
            MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
            GLPK.Optimizer(),
        )
        MOI.Utilities.reset_optimizer(m)
        m
    else
        GLPK.Optimizer()
    end
    MOI.set(model, MOI.Silent(), true)
    MOI.Utilities.loadfromstring!(
        model,
        """
    variables: x, y
    maxobjective: 1.0 * y
    c1: x in Integer()
    c2: y in Integer()
    c3: x in Interval(0.0, 2.5)
    c4: y in Interval(0.0, 2.5)
""",
    )
    x = MOI.get(model, MOI.VariableIndex, "x")
    y = MOI.get(model, MOI.VariableIndex, "y")
    return model, x, y
end

function _callback_knapsack_model(cache)
    model = if cache
        m = MOI.Utilities.CachingOptimizer(
            MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
            GLPK.Optimizer(),
        )
        MOI.Utilities.reset_optimizer(m)
        m
    else
        GLPK.Optimizer()
    end
    MOI.set(model, MOI.Silent(), true)
    N = 30
    x = MOI.add_variables(model, N)
    MOI.add_constraints(model, x, MOI.ZeroOne())
    Random.seed!(1)
    item_weights, item_values = rand(N), rand(N)
    MOI.add_constraint(
        model,
        MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.(item_weights, x), 0.0),
        MOI.LessThan(10.0),
    )
    MOI.set(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{Float64}}(),
        MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.(item_values, x), 0.0),
    )
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    return model, x, item_weights
end

function test_lazy_constraint(cache)
    model, x, y = _callback_simple_model(cache)
    lazy_called = false
    MOI.set(
        model,
        MOI.LazyConstraintCallback(),
        (cb_data) -> begin
            lazy_called = true
            x_val = MOI.get(model, MOI.CallbackVariablePrimal(cb_data), x)
            y_val = MOI.get(model, MOI.CallbackVariablePrimal(cb_data), y)
            @test MOI.supports(model, MOI.LazyConstraint(cb_data))
            status = MOI.get(model, MOI.CallbackNodeStatus(cb_data))
            if [x_val, y_val] ≈ round.(Int, [x_val, y_val])
                atol = 1e-7
                @test status == MOI.CALLBACK_NODE_STATUS_INTEGER
            else
                @test status == MOI.CALLBACK_NODE_STATUS_FRACTIONAL
            end
            if y_val - x_val > 1 + 1e-6
                MOI.submit(
                    model,
                    MOI.LazyConstraint(cb_data),
                    MOI.ScalarAffineFunction{Float64}(
                        MOI.ScalarAffineTerm.([-1.0, 1.0], [x, y]),
                        0.0,
                    ),
                    MOI.LessThan{Float64}(1.0),
                )
            elseif y_val + x_val > 3 + 1e-6
                MOI.submit(
                    model,
                    MOI.LazyConstraint(cb_data),
                    MOI.ScalarAffineFunction{Float64}(
                        MOI.ScalarAffineTerm.([1.0, 1.0], [x, y]),
                        0.0,
                    ),
                    MOI.LessThan{Float64}(3.0),
                )
            end
        end,
    )
    @test MOI.supports(model, MOI.LazyConstraintCallback())
    MOI.optimize!(model)
    @test lazy_called
    @test MOI.get(model, MOI.VariablePrimal(), x) == 1
    @test MOI.get(model, MOI.VariablePrimal(), y) == 2
end

function test_lazy_constraint_optimize_in_progress(cache)
    model, x, y = _callback_simple_model(cache)
    MOI.set(
        model,
        MOI.LazyConstraintCallback(),
        (cb_data) -> begin
            @test_throws(
                MOI.OptimizeInProgress(MOI.VariablePrimal()),
                MOI.get(model, MOI.VariablePrimal(), x)
            )
            @test_throws(
                MOI.OptimizeInProgress(MOI.ObjectiveValue()),
                MOI.get(model, MOI.ObjectiveValue())
            )
            @test_throws(
                MOI.OptimizeInProgress(MOI.ObjectiveBound()),
                MOI.get(model, MOI.ObjectiveBound())
            )
        end,
    )
    return MOI.optimize!(model)
end

function test_no_cache_LazyConstraint_UserCut()
    model, x, y = _callback_simple_model(false)
    MOI.set(
        model,
        MOI.LazyConstraintCallback(),
        (cb_data) -> begin
            MOI.submit(
                model,
                MOI.UserCut(cb_data),
                MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(1.0, x)], 0.0),
                MOI.LessThan(2.0),
            )
        end,
    )
    @test_throws(
        MOI.InvalidCallbackUsage(
            MOI.LazyConstraintCallback(),
            MOI.UserCut(model.callback_data),
        ),
        MOI.optimize!(model)
    )
end

function test_no_cache_LazyConstraint_HeuristicSolution()
    model, x, y = _callback_simple_model(false)
    MOI.set(
        model,
        MOI.LazyConstraintCallback(),
        (cb_data) -> begin
            MOI.submit(model, MOI.HeuristicSolution(cb_data), [x, y], [1.0, 2.0])
        end,
    )
    @test_throws(
        MOI.InvalidCallbackUsage(
            MOI.LazyConstraintCallback(),
            MOI.HeuristicSolution(model.callback_data),
        ),
        MOI.optimize!(model)
    )
end

function test_UserCut(cache)
    model, x, item_weights = _callback_knapsack_model(cache)
    user_cut_submitted = false
    MOI.set(
        model,
        MOI.UserCutCallback(),
        (cb_data) -> begin
            terms = MOI.ScalarAffineTerm{Float64}[]
            accumulated = 0.0
            for (i, xi) in enumerate(x)
                if MOI.get(model, MOI.CallbackVariablePrimal(cb_data), xi) > 0.0
                    push!(terms, MOI.ScalarAffineTerm(1.0, xi))
                    accumulated += item_weights[i]
                end
            end
            @test MOI.supports(model, MOI.UserCut(cb_data))
            status = MOI.get(model, MOI.CallbackNodeStatus(cb_data))
            @test status == MOI.CALLBACK_NODE_STATUS_FRACTIONAL
            if accumulated > 10.0
                MOI.submit(
                    model,
                    MOI.UserCut(cb_data),
                    MOI.ScalarAffineFunction{Float64}(terms, 0.0),
                    MOI.LessThan{Float64}(length(terms) - 1),
                )
                user_cut_submitted = true
            end
        end,
    )
    @test MOI.supports(model, MOI.UserCutCallback())
    MOI.optimize!(model)
    @test user_cut_submitted
end

function test_no_cache_UserCut_LazyConstraint()
    model, x, _ = _callback_knapsack_model(false)
    MOI.set(
        model,
        MOI.UserCutCallback(),
        (cb_data) -> begin
            MOI.submit(
                model,
                MOI.LazyConstraint(cb_data),
                MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.(1.0, x), 0.0),
                MOI.LessThan(5.0),
            )
        end,
    )
    @test_throws(
        MOI.InvalidCallbackUsage(
            MOI.UserCutCallback(),
            MOI.LazyConstraint(model.callback_data),
        ),
        MOI.optimize!(model)
    )
end

function test_no_cache_UserCut_HeuristicSolution()
    model, x, _ = _callback_knapsack_model(false)
    MOI.set(
        model,
        MOI.UserCutCallback(),
        (cb_data) -> begin
            MOI.submit(
                model,
                MOI.HeuristicSolution(cb_data),
                x,
                fill(0.0, length(x)),
            )
        end,
    )
    @test_throws(
        MOI.InvalidCallbackUsage(
            MOI.UserCutCallback(),
            MOI.HeuristicSolution(model.callback_data),
        ),
        MOI.optimize!(model)
    )
end

function test_Heuristic(cache)
    model, x, _ = _callback_knapsack_model(cache)
    solution_accepted = false
    solution_rejected = false
    MOI.set(
        model,
        MOI.HeuristicCallback(),
        (cb_data) -> begin
            x_vals = MOI.get.(model, MOI.CallbackVariablePrimal(cb_data), x)
            @test MOI.supports(model, MOI.HeuristicSolution(cb_data))
            if MOI.submit(
                model,
                MOI.HeuristicSolution(cb_data),
                x,
                floor.(x_vals),
            ) == MOI.HEURISTIC_SOLUTION_ACCEPTED
                solution_accepted = true
            end
            if MOI.submit(
                model,
                MOI.HeuristicSolution(cb_data),
                [x[1]],
                [1.0],
            ) == MOI.HEURISTIC_SOLUTION_REJECTED
                solution_rejected = true
            end
            status = MOI.get(model, MOI.CallbackNodeStatus(cb_data))
            @test status == MOI.CALLBACK_NODE_STATUS_FRACTIONAL
        end,
    )
    @test MOI.supports(model, MOI.HeuristicCallback())
    MOI.optimize!(model)
    @test solution_accepted
    @test solution_rejected
end

function test_no_cache_Heuristic_LazyConstraint()
    model, x, _ = _callback_knapsack_model(false)
    MOI.set(
        model,
        MOI.HeuristicCallback(),
        (cb_data) -> begin
            MOI.submit(
                model,
                MOI.LazyConstraint(cb_data),
                MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.(1.0, x), 0.0),
                MOI.LessThan(5.0),
            )
        end,
    )
    @test_throws(
        MOI.InvalidCallbackUsage(
            MOI.HeuristicCallback(),
            MOI.LazyConstraint(model.callback_data),
        ),
        MOI.optimize!(model)
    )
end

function test_no_cache_Heuristic_UserCut()
    model, x, _ = _callback_knapsack_model(false)
    MOI.set(
        model,
        MOI.HeuristicCallback(),
        (cb_data) -> begin
            MOI.submit(
                model,
                MOI.UserCut(cb_data),
                MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.(1.0, x), 0.0),
                MOI.LessThan(5.0),
            )
        end,
    )
    @test_throws(
        MOI.InvalidCallbackUsage(
            MOI.HeuristicCallback(),
            MOI.UserCut(model.callback_data),
        ),
        MOI.optimize!(model)
    )
end

function test_CallbackFunction_OptimizeInProgress(cache)
    model, x, y = _callback_simple_model(cache)
    MOI.set(
        model,
        GLPK.CallbackFunction(),
        (cb_data) -> begin
            @test_throws(
                MOI.OptimizeInProgress(MOI.VariablePrimal()),
                MOI.get(model, MOI.VariablePrimal(), x)
            )
            @test_throws(
                MOI.OptimizeInProgress(MOI.ObjectiveValue()),
                MOI.get(model, MOI.ObjectiveValue())
            )
            @test_throws(
                MOI.OptimizeInProgress(MOI.ObjectiveBound()),
                MOI.get(model, MOI.ObjectiveBound())
            )
        end,
    )
    @test MOI.supports(model, GLPK.CallbackFunction())
    return MOI.optimize!(model)
end

function test_CallbackFunction_LazyConstraint(cache)
    model, x, y = _callback_simple_model(cache)
    cb_calls = Int32[]
    function callback_function(cb_data)
        reason = GLPK.glp_ios_reason(cb_data.tree)
        push!(cb_calls, reason)
        if reason != GLPK.GLP_IROWGEN
            return
        end
        x_val = MOI.get(model, MOI.CallbackVariablePrimal(cb_data), x)
        y_val = MOI.get(model, MOI.CallbackVariablePrimal(cb_data), y)
        status = MOI.get(model, MOI.CallbackNodeStatus(cb_data))
        if [x_val, y_val] ≈ round.(Int, [x_val, y_val])
            atol = 1e-7
            @test status == MOI.CALLBACK_NODE_STATUS_INTEGER
        else
            @test status == MOI.CALLBACK_NODE_STATUS_FRACTIONAL
        end
        if y_val - x_val > 1 + 1e-6
            MOI.submit(
                model,
                MOI.LazyConstraint(cb_data),
                MOI.ScalarAffineFunction{Float64}(
                    MOI.ScalarAffineTerm.([-1.0, 1.0], [x, y]),
                    0.0,
                ),
                MOI.LessThan{Float64}(1.0),
            )
        elseif y_val + x_val > 3 + 1e-6
            MOI.submit(
                model,
                MOI.LazyConstraint(cb_data),
                MOI.ScalarAffineFunction{Float64}(
                    MOI.ScalarAffineTerm.([1.0, 1.0], [x, y]),
                    0.0,
                ),
                MOI.LessThan{Float64}(3.0),
            )
        end
    end
    MOI.set(model, GLPK.CallbackFunction(), callback_function)
    MOI.optimize!(model)
    @test MOI.get(model, MOI.VariablePrimal(), x) == 1
    @test MOI.get(model, MOI.VariablePrimal(), y) == 2
    @test length(cb_calls) > 0
    @test GLPK.GLP_ISELECT in cb_calls
    @test GLPK.GLP_IPREPRO in cb_calls
    @test GLPK.GLP_IROWGEN in cb_calls
    @test GLPK.GLP_IBINGO in cb_calls
    @test !(GLPK.GLP_IHEUR in cb_calls)
end

function test_CallbackFunction_UserCut(cache)
    model, x, item_weights = _callback_knapsack_model(cache)
    user_cut_submitted = false
    cb_calls = Int32[]
    MOI.set(
        model,
        GLPK.CallbackFunction(),
        (cb_data) -> begin
            reason = GLPK.glp_ios_reason(cb_data.tree)
            push!(cb_calls, reason)
            if reason != GLPK.GLP_ICUTGEN
                status = MOI.get(model, MOI.CallbackNodeStatus(cb_data))
                @test status !== nothing
                return
            end
            terms = MOI.ScalarAffineTerm{Float64}[]
            accumulated = 0.0
            for (i, xi) in enumerate(x)
                if MOI.get(model, MOI.CallbackVariablePrimal(cb_data), xi) > 0.0
                    push!(terms, MOI.ScalarAffineTerm(1.0, xi))
                    accumulated += item_weights[i]
                end
            end
            if accumulated > 10.0
                MOI.submit(
                    model,
                    MOI.UserCut(cb_data),
                    MOI.ScalarAffineFunction{Float64}(terms, 0.0),
                    MOI.LessThan{Float64}(length(terms) - 1),
                )
                user_cut_submitted = true
            end
            status = MOI.get(model, MOI.CallbackNodeStatus(cb_data))
            @test status == MOI.CALLBACK_NODE_STATUS_FRACTIONAL
        end,
    )
    MOI.optimize!(model)
    @test user_cut_submitted
    @test GLPK.GLP_ICUTGEN in cb_calls
end

function test_CallbackFunction_HeuristicSolution(cache)
    model, x, _ = _callback_knapsack_model(cache)
    solution_accepted = false
    solution_rejected = false
    cb_calls = Int32[]
    MOI.set(
        model,
        GLPK.CallbackFunction(),
        (cb_data) -> begin
            reason = GLPK.glp_ios_reason(cb_data.tree)
            push!(cb_calls, reason)
            if reason != GLPK.GLP_IHEUR
                return
            end
            x_vals =
                MOI.get.(model, MOI.CallbackVariablePrimal(cb_data), x)
            if MOI.submit(
                model,
                MOI.HeuristicSolution(cb_data),
                x,
                floor.(x_vals),
            ) == MOI.HEURISTIC_SOLUTION_ACCEPTED
                solution_accepted = true
            end
            if MOI.submit(
                model,
                MOI.HeuristicSolution(cb_data),
                [x[1]],
                [1.0],
            ) == MOI.HEURISTIC_SOLUTION_REJECTED
                solution_rejected = true
            end
            status = MOI.get(model, MOI.CallbackNodeStatus(cb_data))
            @test status == MOI.CALLBACK_NODE_STATUS_FRACTIONAL
        end,
    )
    MOI.optimize!(model)
    @test solution_accepted
    @test solution_rejected
    @test GLPK.GLP_IHEUR in cb_calls
end

function test_broadcasting(cache)
    model, x, _ = _callback_knapsack_model(cache)
    f(cb_data, x) = MOI.get(model, MOI.CallbackVariablePrimal(cb_data), x)
    solutions = Vector{Float64}[]
    MOI.set(
        model,
        GLPK.CallbackFunction(),
        (cb_data) -> begin
            if GLPK.glp_ios_reason(cb_data.tree) == GLPK.GLP_IHEUR
                push!(solutions, f.(cb_data, x))
            end
        end,
    )
    MOI.optimize!(model)
    @test length(solutions) > 0
    @test length(solutions[1]) == length(x)
end

function test_issue_189(cache)
    model, x, _ = _callback_knapsack_model(cache)
    MOI.set(model, GLPK.CallbackFunction(), cb_data -> nothing)
    MOI.optimize!(model)
    @test isnan(MOI.get(model, MOI.DualObjectiveValue()))
    return
end

function test_no_cache_InterruptException()
    model = GLPK.Optimizer()
    MOI.set(model, MOI.Silent(), true)
    x = MOI.add_variable(model)
    MOI.add_constraint(model, 1.0 * x, MOI.GreaterThan(2.0))
    MOI.add_constraint(model, x, MOI.Integer())
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    f = 1.0 * x
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    interrupt_thrown = false
    function my_callback(cb_data)
        interrupt_thrown = true
        return throw(InterruptException())
    end
    MOI.set(model, GLPK.CallbackFunction(), my_callback)
    MOI.optimize!(model)
    @test interrupt_thrown
    @test MOI.get(model, MOI.TerminationStatus()) == MOI.INTERRUPTED
    return
end

end

TestCallbacks.runtests()

# Copyright (c) 2012 GLPK.jl contributors
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the Licence, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

import GLPK
import SparseArrays
using Test

# Test Basis Factorization stuff, plus
# miscellaneous functions

function var_is_basic(lp::Ptr, k::Integer)
    rows = GLPK.glp_get_num_rows(lp)
    if k <= rows
        return GLPK.glp_get_row_stat(lp, k) == GLPK.GLP_BS
    else
        return GLPK.glp_get_col_stat(lp, k - rows) == GLPK.GLP_BS
    end
end

function glpk_tst_4()
    prev_term_out = GLPK.glp_term_out(GLPK.GLP_OFF)

    datadir = joinpath(dirname(@__FILE__), "data")
    @assert isdir(datadir)

    mip = GLPK.glp_create_prob()
    tran = GLPK.glp_mpl_alloc_wksp()
    GLPK.glp_mpl_read_model(tran, joinpath(datadir, "sudoku.mod"), 1)
    GLPK.glp_mpl_read_data(tran, joinpath(datadir, "sudoku.dat"))
    GLPK.glp_mpl_generate(tran, C_NULL)
    GLPK.glp_mpl_build_prob(tran, mip)
    @test GLPK.glp_simplex(mip, C_NULL) == 0
    @test GLPK.glp_intopt(mip, C_NULL) == 0
    GLPK.glp_mpl_postsolve(tran, mip, GLPK.GLP_MIP)

    @test GLPK.glp_warm_up(mip) == 0

    @test GLPK.glp_factorize(mip) == 0

    @test GLPK.glp_bf_updated(mip) == 0

    bfp = GLPK.glp_bfcp(
        0,
        0,
        0,
        0.0,
        0,
        0,
        0.0,
        0.0,
        0,
        0.0,
        0,
        0,
        tuple(fill(0.0, 38)...),
    )
    GLPK.glp_get_bfcp(mip, bfp)
    bfp.piv_tol = 0.5
    GLPK.glp_set_bfcp(mip, bfp)

    rows = GLPK.glp_get_num_rows(mip)
    cols = GLPK.glp_get_num_cols(mip)

    for i in 1:rows
        bh = GLPK.glp_get_bhead(mip, i)
        rb = GLPK.glp_get_row_bind(mip, i)
    end
    for i in 1:cols
        cb = GLPK.glp_get_col_bind(mip, i)
    end

    x = randn(rows)
    GLPK.glp_ftran(mip, x)
    GLPK.glp_btran(mip, x)

    GLPK.glp_adv_basis(mip, 0)
    @test GLPK.glp_factorize(mip) == 0

    for i in 1:rows+cols
        if !var_is_basic(mip, i)
            continue
        end

        ind = zeros(Cint, rows + cols)
        val = zeros(Cdouble, rows + cols)
        len = GLPK.glp_eval_tab_row(mip, i, GLPK.offset(ind), GLPK.offset(val))
        @test len <= length(ind)
    end

    for i in 1:rows+cols
        if var_is_basic(mip, i)
            continue
        end

        ind = zeros(Cint, rows + cols)
        val = zeros(Cdouble, rows + cols)
        len = GLPK.glp_eval_tab_col(mip, i, GLPK.offset(ind), GLPK.offset(val))
        @test len <= length(ind)
    end

    for i in 1:100
        ia, ja, val =
            SparseArrays.findnz(SparseArrays.sprand(Int(cols), 1, 0.5))
        indices = round.(Cint, ia)
        resize!(val, cols)
        resize!(indices, cols)
        GLPK.glp_transform_row(
            mip,
            length(ia),
            GLPK.offset(indices),
            GLPK.offset(val),
        )
    end

    for i in 1:100
        ia, ja, val =
            SparseArrays.findnz(SparseArrays.sprand(Int(rows), 1, 0.5))
        indices = round.(Cint, ia)
        resize!(val, rows)
        resize!(indices, rows)
        GLPK.glp_transform_col(
            mip,
            length(ia),
            GLPK.offset(indices),
            GLPK.offset(val),
        )
    end

    for i in 1:100
        ia, ja, val =
            SparseArrays.findnz(SparseArrays.sprand(Int(rows), 1, 0.5))
        dir = 2 * rand(Bool) - 1
        eps = 1e-9

        basic = map(x -> var_is_basic(mip, x), ia)

        ia = Cint.(ia[basic])
        val = val[basic]

        prt = GLPK.glp_prim_rtest(
            mip,
            length(ia),
            GLPK.offset(ia),
            GLPK.offset(val),
            dir,
            eps,
        )
    end

    for i in 1:100
        ia, ja, val =
            SparseArrays.findnz(SparseArrays.sprand(Int(cols), 1, 0.5))
        dir = 2 * rand(Bool) - 1
        eps = 1e-9

        nonbasic = map(x -> !var_is_basic(mip, x), ia)

        ia = Cint.(ia[nonbasic])
        val = val[nonbasic]

        drt = GLPK.glp_dual_rtest(
            mip,
            length(ia),
            GLPK.offset(ia),
            GLPK.offset(val),
            dir,
            eps,
        )
    end

    for i in 1:rows+cols
        if var_is_basic(mip, i)
            coef1 = Ref{Cdouble}()
            var1 = Ref{Cint}()
            value1 = Ref{Cdouble}()
            coef2 = Ref{Cdouble}()
            var2 = Ref{Cint}()
            value2 = Ref{Cdouble}()
            ac = GLPK.glp_analyze_coef(
                mip,
                i,
                coef1,
                var1,
                value1,
                coef2,
                var2,
                value2,
            )
        else
            limit1 = Ref{Cdouble}()
            var1 = Ref{Cint}()
            limit2 = Ref{Cdouble}()
            var2 = Ref{Cint}()
            ab = GLPK.glp_analyze_bound(mip, i, limit1, var1, limit2, var2)
        end
    end

    GLPK.glp_init_env()

    p = GLPK.glp_alloc(1, 100 * sizeof(Int))
    count, cpeak, total, tpeak =
        Ref{Cint}(), Ref{Cint}(), Ref{Cint}(), Ref{Cint}()
    GLPK.glp_mem_usage(count, cpeak, total, tpeak)
    GLPK.glp_free(p)
    mu = GLPK.glp_mem_usage(count, cpeak, total, tpeak)
    GLPK.glp_mem_limit(10000)

    p = GLPK.glp_alloc(100, sizeof(Int))
    mu = GLPK.glp_mem_usage(count, cpeak, total, tpeak)
    GLPK.glp_free(p)
    mu = GLPK.glp_mem_usage(count, cpeak, total, tpeak)

    # GLPK.glp_free_env()

    mktemp() do path, _
        return GLPK.glp_print_sol(mip, path)
    end

    mktemp() do path, _
        GLPK.glp_write_sol(mip, path)
        return GLPK.glp_read_sol(mip, path)
    end

    mktemp() do path, _
        return GLPK.glp_print_ipt(mip, path)
    end

    mktemp() do path, _
        GLPK.glp_write_ipt(mip, path)
        return GLPK.glp_read_ipt(mip, path)
    end

    mktemp() do path, _
        return GLPK.glp_print_mip(mip, path)
    end

    mktemp() do path, _
        GLPK.glp_write_mip(mip, path)
        return GLPK.glp_read_mip(mip, path)
    end

    mktemp() do path, _
        GLPK.glp_open_tee(path)
        return GLPK.glp_close_tee()
    end

    GLPK.glp_term_out(prev_term_out)
    GLPK.glp_mpl_free_wksp(tran)
    return GLPK.glp_delete_prob(mip)
end

glpk_tst_4()

# Copyright (c) 2012 GLPK.jl contributors
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the Licence, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# Automatically generated using Clang.jl


const GLP_MAJOR_VERSION = 5
const GLP_MINOR_VERSION = 0
const GLP_MIN = 1
const GLP_MAX = 2
const GLP_CV = 1
const GLP_IV = 2
const GLP_BV = 3
const GLP_FR = 1
const GLP_LO = 2
const GLP_UP = 3
const GLP_DB = 4
const GLP_FX = 5
const GLP_BS = 1
const GLP_NL = 2
const GLP_NU = 3
const GLP_NF = 4
const GLP_NS = 5
const GLP_SF_GM = 0x01
const GLP_SF_EQ = 0x10
const GLP_SF_2N = 0x20
const GLP_SF_SKIP = 0x40
const GLP_SF_AUTO = 0x80
const GLP_SOL = 1
const GLP_IPT = 2
const GLP_MIP = 3
const GLP_UNDEF = 1
const GLP_FEAS = 2
const GLP_INFEAS = 3
const GLP_NOFEAS = 4
const GLP_OPT = 5
const GLP_UNBND = 6
const GLP_BF_LUF = 0x00
const GLP_BF_BTF = 0x10
const GLP_BF_FT = 0x01
const GLP_BF_BG = 0x02
const GLP_BF_GR = 0x03
const GLP_MSG_OFF = 0
const GLP_MSG_ERR = 1
const GLP_MSG_ON = 2
const GLP_MSG_ALL = 3
const GLP_MSG_DBG = 4
const GLP_PRIMAL = 1
const GLP_DUALP = 2
const GLP_DUAL = 3
const GLP_PT_STD = 0x11
const GLP_PT_PSE = 0x22
const GLP_RT_STD = 0x11
const GLP_RT_HAR = 0x22
const GLP_RT_FLIP = 0x33
const GLP_USE_AT = 1
const GLP_USE_NT = 2
const GLP_ORD_NONE = 0
const GLP_ORD_QMD = 1
const GLP_ORD_AMD = 2
const GLP_ORD_SYMAMD = 3
const GLP_BR_FFV = 1
const GLP_BR_LFV = 2
const GLP_BR_MFV = 3
const GLP_BR_DTH = 4
const GLP_BR_PCH = 5
const GLP_BT_DFS = 1
const GLP_BT_BFS = 2
const GLP_BT_BLB = 3
const GLP_BT_BPH = 4
const GLP_PP_NONE = 0
const GLP_PP_ROOT = 1
const GLP_PP_ALL = 2
const GLP_RF_REG = 0
const GLP_RF_LAZY = 1
const GLP_RF_CUT = 2
const GLP_RF_GMI = 1
const GLP_RF_MIR = 2
const GLP_RF_COV = 3
const GLP_RF_CLQ = 4
const GLP_ON = 1
const GLP_OFF = 0
const GLP_IROWGEN = 0x01
const GLP_IBINGO = 0x02
const GLP_IHEUR = 0x03
const GLP_ICUTGEN = 0x04
const GLP_IBRANCH = 0x05
const GLP_ISELECT = 0x06
const GLP_IPREPRO = 0x07
const GLP_NO_BRNCH = 0
const GLP_DN_BRNCH = 1
const GLP_UP_BRNCH = 2
const GLP_EBADB = 0x01
const GLP_ESING = 0x02
const GLP_ECOND = 0x03
const GLP_EBOUND = 0x04
const GLP_EFAIL = 0x05
const GLP_EOBJLL = 0x06
const GLP_EOBJUL = 0x07
const GLP_EITLIM = 0x08
const GLP_ETMLIM = 0x09
const GLP_ENOPFS = 0x0a
const GLP_ENODFS = 0x0b
const GLP_EROOT = 0x0c
const GLP_ESTOP = 0x0d
const GLP_EMIPGAP = 0x0e
const GLP_ENOFEAS = Float32(0x00)
const GLP_ENOCVG = 0x10
const GLP_EINSTAB = 0x11
const GLP_EDATA = 0x12
const GLP_ERANGE = 0x13
const GLP_KKT_PE = 1
const GLP_KKT_PB = 2
const GLP_KKT_DE = 3
const GLP_KKT_DB = 4
const GLP_KKT_CS = 5
const GLP_MPS_DECK = 1
const GLP_MPS_FILE = 2

# Skipping MacroDefinition: glp_error glp_error_ ( __FILE__ , __LINE__ )
# Skipping MacroDefinition: glp_assert ( expr ) ( ( void ) ( ( expr ) || ( glp_assert_ ( # expr , __FILE__ , __LINE__ ) , 1 ) ) )
# Skipping MacroDefinition: glp_malloc ( size ) glp_alloc ( 1 , size )
# Skipping MacroDefinition: glp_calloc ( n , size ) glp_alloc ( n , size )

const GLP_ASN_MIN = 1
const GLP_ASN_MAX = 2
const GLP_ASN_MMP = 3
const glp_prob = Cvoid

mutable struct glp_bfcp
    msg_lev::Cint
    type::Cint
    lu_size::Cint
    piv_tol::Cdouble
    piv_lim::Cint
    suhl::Cint
    eps_tol::Cdouble
    max_gro::Cdouble
    nfs_max::Cint
    upd_tol::Cdouble
    nrs_max::Cint
    rs_size::Cint
    foo_bar::NTuple{38, Cdouble}
end

Base.cconvert(::Type{Ptr{glp_bfcp}}, x::glp_bfcp) = x
function Base.unsafe_convert(::Type{Ptr{glp_bfcp}}, x::glp_bfcp)
    return convert(Ptr{glp_bfcp}, pointer_from_objref(x))
end

mutable struct glp_smcp
    msg_lev::Cint
    meth::Cint
    pricing::Cint
    r_test::Cint
    tol_bnd::Cdouble
    tol_dj::Cdouble
    tol_piv::Cdouble
    obj_ll::Cdouble
    obj_ul::Cdouble
    it_lim::Cint
    tm_lim::Cint
    out_frq::Cint
    out_dly::Cint
    presolve::Cint
    excl::Cint
    shift::Cint
    aorn::Cint
    foo_bar::NTuple{33, Cdouble}
    glp_smcp() = new()
end

Base.cconvert(::Type{Ptr{glp_smcp}}, x::glp_smcp) = x
function Base.unsafe_convert(::Type{Ptr{glp_smcp}}, x::glp_smcp)
    return convert(Ptr{glp_smcp}, pointer_from_objref(x))
end

mutable struct glp_iptcp
    msg_lev::Cint
    ord_alg::Cint
    foo_bar::NTuple{48, Cdouble}
    glp_iptcp() = new()
end

Base.cconvert(::Type{Ptr{glp_iptcp}}, x::glp_iptcp) = x
function Base.unsafe_convert(::Type{Ptr{glp_iptcp}}, x::glp_iptcp)
    return convert(Ptr{glp_iptcp}, pointer_from_objref(x))
end

const glp_tree = Cvoid

mutable struct glp_iocp
    msg_lev::Cint
    br_tech::Cint
    bt_tech::Cint
    tol_int::Cdouble
    tol_obj::Cdouble
    tm_lim::Cint
    out_frq::Cint
    out_dly::Cint
    cb_func::Ptr{Cvoid}
    cb_info::Ptr{Cvoid}
    cb_size::Cint
    pp_tech::Cint
    mip_gap::Cdouble
    mir_cuts::Cint
    gmi_cuts::Cint
    cov_cuts::Cint
    clq_cuts::Cint
    presolve::Cint
    binarize::Cint
    fp_heur::Cint
    ps_heur::Cint
    ps_tm_lim::Cint
    sr_heur::Cint
    use_sol::Cint
    save_sol::Cstring
    alien::Cint
    flip::Cint
    foo_bar::NTuple{23, Cdouble}
    glp_iocp() = new()
end

Base.cconvert(::Type{Ptr{glp_iocp}}, x::glp_iocp) = x
function Base.unsafe_convert(::Type{Ptr{glp_iocp}}, x::glp_iocp)
    return convert(Ptr{glp_iocp}, pointer_from_objref(x))
end

mutable struct glp_attr
    level::Cint
    origin::Cint
    klass::Cint
    foo_bar::NTuple{7, Cdouble}
end

Base.cconvert(::Type{Ptr{glp_attr}}, x::glp_attr) = x
function Base.unsafe_convert(::Type{Ptr{glp_attr}}, x::glp_attr)
    return convert(Ptr{glp_attr}, pointer_from_objref(x))
end

mutable struct glp_mpscp
    blank::Cint
    obj_name::Cstring
    tol_mps::Cdouble
    foo_bar::NTuple{17, Cdouble}
    glp_mpscp() = new()
end

Base.cconvert(::Type{Ptr{glp_mpscp}}, x::glp_mpscp) = x
function Base.unsafe_convert(::Type{Ptr{glp_mpscp}}, x::glp_mpscp)
    return convert(Ptr{glp_mpscp}, pointer_from_objref(x))
end

mutable struct glp_cpxcp
    foo_bar::NTuple{20, Cdouble}
    glp_cpxcp() = new()
end

Base.cconvert(::Type{Ptr{glp_cpxcp}}, x::glp_cpxcp) = x
function Base.unsafe_convert(::Type{Ptr{glp_cpxcp}}, x::glp_cpxcp)
    return convert(Ptr{glp_cpxcp}, pointer_from_objref(x))
end

const glp_prep = Cvoid
const glp_tran = Cvoid
const glp_errfunc = Ptr{Cvoid}

mutable struct glp_arc
    tail::Ptr
    head::Ptr
    data::Ptr{Cvoid}
    temp::Ptr{Cvoid}
    t_prev::Ptr{glp_arc}
    t_next::Ptr{glp_arc}
    h_prev::Ptr{glp_arc}
    h_next::Ptr{glp_arc}
end

Base.cconvert(::Type{Ptr{glp_arc}}, x::glp_arc) = x
function Base.unsafe_convert(::Type{Ptr{glp_arc}}, x::glp_arc)
    return convert(Ptr{glp_arc}, pointer_from_objref(x))
end

mutable struct glp_vertex
    i::Cint
    name::Cstring
    entry::Ptr{Cvoid}
    data::Ptr{Cvoid}
    temp::Ptr{Cvoid}
    in::Ptr{glp_arc}
    out::Ptr{glp_arc}
end

Base.cconvert(::Type{Ptr{glp_vertex}}, x::glp_vertex) = x
function Base.unsafe_convert(::Type{Ptr{glp_vertex}}, x::glp_vertex)
    return convert(Ptr{glp_vertex}, pointer_from_objref(x))
end

mutable struct glp_graph
    pool::Ptr{Cvoid}
    name::Cstring
    nv_max::Cint
    nv::Cint
    na::Cint
    v::Ptr{Ptr{glp_vertex}}
    index::Ptr{Cvoid}
    v_size::Cint
    a_size::Cint
end

Base.cconvert(::Type{Ptr{glp_graph}}, x::glp_graph) = x
function Base.unsafe_convert(::Type{Ptr{glp_graph}}, x::glp_graph)
    return convert(Ptr{glp_graph}, pointer_from_objref(x))
end

# Copyright (c) 2012 GLPK.jl contributors
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the Licence, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

function _precompile_()
    ccall(:jl_generating_output, Cint, ()) == 1 || return nothing
    Base.precompile(Tuple{typeof(MathOptInterface.copy_to),Optimizer,MathOptInterface.Utilities.UniversalFallback{MathOptInterface.Utilities.Model{Float64}}})   # time: 0.1371813
    Base.precompile(Tuple{Type{Optimizer}})   # time: 0.08901196
    Base.precompile(MOI.set, (Optimizer, MOI.Silent, Bool))
    Base.precompile(MOI.add_variables, (Optimizer, Int))
    Base.precompile(MOI.add_variable, (Optimizer,))
    Base.precompile(MOI.delete, (Optimizer, MOI.VariableIndex))
    Base.precompile(MOI.get, (Optimizer, MOI.VariablePrimal, MOI.VariableIndex))

    Base.precompile(
        MOI.set,
        (Optimizer, MOI.ObjectiveSense, MOI.OptimizationSense),
    )
    Base.precompile(
        MOI.set,
        (
            Optimizer,
            MOI.ObjectiveFunction{MOI.ScalarAffineFunction{Float64}},
            MOI.ScalarAffineFunction{Float64},
        ),
    )

    functions = (MOI.ScalarAffineFunction{Float64}, MOI.VariableIndex)
    sets = (
        MOI.LessThan{Float64},
        MOI.GreaterThan{Float64},
        MOI.EqualTo{Float64},
        MOI.Interval{Float64},
    )
    for F in functions, S in sets
        Base.precompile(MOI.add_constraint, (Optimizer, F, S))
        Base.precompile(
            MOI.get,
            (Optimizer, MOI.ConstraintPrimal, MOI.ConstraintIndex{F,S}),
        )
        Base.precompile(
            MOI.get,
            (Optimizer, MOI.ConstraintDual, MOI.ConstraintIndex{F,S}),
        )
        Base.precompile(
            MOI.get,
            (Optimizer, MOI.ConstraintFunction, MOI.ConstraintIndex{F,S}),
        )
        Base.precompile(
            MOI.set,
            (Optimizer, MOI.ConstraintFunction, MOI.ConstraintIndex{F,S}, F),
        )
        Base.precompile(
            MOI.get,
            (Optimizer, MOI.ConstraintSet, MOI.ConstraintIndex{F,S}),
        )
        Base.precompile(
            MOI.set,
            (Optimizer, MOI.ConstraintSet, MOI.ConstraintIndex{F,S}, S),
        )
        Base.precompile(MOI.is_valid, (Optimizer, MOI.ConstraintIndex{F,S}))
        Base.precompile(MOI.delete, (Optimizer, MOI.ConstraintIndex{F,S}))
    end
    Base.precompile(
        MOI.add_constraint,
        (Optimizer, MOI.VariableIndex, MOI.ZeroOne),
    )
    Base.precompile(
        MOI.add_constraint,
        (Optimizer, MOI.VariableIndex, MOI.Integer),
    )
    Base.precompile(MOI.optimize!, (Optimizer,))

    for attr in (
        MOI.TerminationStatus,
        MOI.ObjectiveValue,
        MOI.PrimalStatus,
        MOI.DualStatus,
        MOI.CallbackNodeStatus{CallbackData},
    )
        Base.precompile(MOI.get, (Optimizer, attr))
    end

    for callback in (
        CallbackFunction,
        MOI.LazyConstraintCallback,
        MOI.UserCutCallback,
        MOI.HeuristicCallback,
    )
        Base.precompile(MOI.set, (Optimizer, callback, Function))
    end

    Base.precompile(
        MOI.submit,
        (
            Optimizer,
            MOI.HeuristicSolution{CallbackData},
            Vector{MOI.VariableIndex},
            Vector{Float64},
        ),
    )
    for S in sets
        Base.precompile(
            MOI.submit,
            (
                Optimizer,
                MOI.UserCut{CallbackData},
                MOI.ScalarAffineFunction{Float64},
                S,
            ),
        )
        Base.precompile(
            MOI.submit,
            (
                Optimizer,
                MOI.LazyConstraint{CallbackData},
                MOI.ScalarAffineFunction{Float64},
                S,
            ),
        )
    end
end

# Copyright (c) 2012 GLPK.jl contributors
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the Licence, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

using Test
import GLPK

function glpk_tst_5()
    datadir = joinpath(dirname(@__FILE__), "data")
    @assert isdir(datadir)

    prev_term_out = GLPK.glp_term_out(GLPK.GLP_OFF)

    lp = GLPK.glp_create_prob()

    cnffile = joinpath(datadir, "sat_tst.cnf")
    GLPK.glp_read_cnfsat(lp, cnffile)
    GLPK.glp_check_cnfsat(lp)
    cnfcopy = joinpath(datadir, "sat_tst-copy.cnf")
    try
        GLPK.glp_write_cnfsat(lp, cnfcopy)
    finally
        isfile(cnfcopy) && rm(cnfcopy)
    end
    if Sys.WORD_SIZE != sizeof(Csize_t) * 8
        # changed condition to:
        # if (sizeof(void *) != sizeof(size_t))
        expected_ret = GLPK.GLP_EFAIL
    else
        expected_ret = 0
    end
    @test GLPK.glp_minisat1(lp) == expected_ret

    @test GLPK.glp_intfeas1(lp, 0, 0) == expected_ret
    return GLPK.glp_delete_prob(lp)
end

glpk_tst_5()

# Copyright (c) 2012 GLPK.jl contributors
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the Licence, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# Julia wrapper for header: glpk.h
# Automatically generated using Clang.jl


function glp_create_prob()
    ccall((:glp_create_prob, libglpk), Ptr{glp_prob}, ())
end

function glp_set_prob_name(P, name)
    ccall((:glp_set_prob_name, libglpk), Cvoid, (Ptr{glp_prob}, Cstring), P, name)
end

function glp_set_obj_name(P, name)
    ccall((:glp_set_obj_name, libglpk), Cvoid, (Ptr{glp_prob}, Cstring), P, name)
end

function glp_set_obj_dir(P, dir)
    ccall((:glp_set_obj_dir, libglpk), Cvoid, (Ptr{glp_prob}, Cint), P, dir)
end

function glp_add_rows(P, nrs)
    ccall((:glp_add_rows, libglpk), Cint, (Ptr{glp_prob}, Cint), P, nrs)
end

function glp_add_cols(P, ncs)
    ccall((:glp_add_cols, libglpk), Cint, (Ptr{glp_prob}, Cint), P, ncs)
end

function glp_set_row_name(P, i, name)
    ccall((:glp_set_row_name, libglpk), Cvoid, (Ptr{glp_prob}, Cint, Cstring), P, i, name)
end

function glp_set_col_name(P, j, name)
    ccall((:glp_set_col_name, libglpk), Cvoid, (Ptr{glp_prob}, Cint, Cstring), P, j, name)
end

function glp_set_row_bnds(P, i, type, lb, ub)
    ccall((:glp_set_row_bnds, libglpk), Cvoid, (Ptr{glp_prob}, Cint, Cint, Cdouble, Cdouble), P, i, type, lb, ub)
end

function glp_set_col_bnds(P, j, type, lb, ub)
    ccall((:glp_set_col_bnds, libglpk), Cvoid, (Ptr{glp_prob}, Cint, Cint, Cdouble, Cdouble), P, j, type, lb, ub)
end

function glp_set_obj_coef(P, j, coef)
    ccall((:glp_set_obj_coef, libglpk), Cvoid, (Ptr{glp_prob}, Cint, Cdouble), P, j, coef)
end

function glp_set_mat_row(P, i, len, ind, val)
    ccall((:glp_set_mat_row, libglpk), Cvoid, (Ptr{glp_prob}, Cint, Cint, Ptr{Cint}, Ptr{Cdouble}), P, i, len, ind, val)
end

function glp_set_mat_col(P, j, len, ind, val)
    ccall((:glp_set_mat_col, libglpk), Cvoid, (Ptr{glp_prob}, Cint, Cint, Ptr{Cint}, Ptr{Cdouble}), P, j, len, ind, val)
end

function glp_load_matrix(P, ne, ia, ja, ar)
    ccall((:glp_load_matrix, libglpk), Cvoid, (Ptr{glp_prob}, Cint, Ptr{Cint}, Ptr{Cint}, Ptr{Cdouble}), P, ne, ia, ja, ar)
end

function glp_check_dup(m, n, ne, ia, ja)
    ccall((:glp_check_dup, libglpk), Cint, (Cint, Cint, Cint, Ptr{Cint}, Ptr{Cint}), m, n, ne, ia, ja)
end

function glp_sort_matrix(P)
    ccall((:glp_sort_matrix, libglpk), Cvoid, (Ptr{glp_prob},), P)
end

function glp_del_rows(P, nrs, num)
    ccall((:glp_del_rows, libglpk), Cvoid, (Ptr{glp_prob}, Cint, Ptr{Cint}), P, nrs, num)
end

function glp_del_cols(P, ncs, num)
    ccall((:glp_del_cols, libglpk), Cvoid, (Ptr{glp_prob}, Cint, Ptr{Cint}), P, ncs, num)
end

function glp_copy_prob(dest, prob, names)
    ccall((:glp_copy_prob, libglpk), Cvoid, (Ptr{glp_prob}, Ptr{glp_prob}, Cint), dest, prob, names)
end

function glp_erase_prob(P)
    ccall((:glp_erase_prob, libglpk), Cvoid, (Ptr{glp_prob},), P)
end

function glp_delete_prob(P)
    ccall((:glp_delete_prob, libglpk), Cvoid, (Ptr{glp_prob},), P)
end

function glp_get_prob_name(P)
    ccall((:glp_get_prob_name, libglpk), Cstring, (Ptr{glp_prob},), P)
end

function glp_get_obj_name(P)
    ccall((:glp_get_obj_name, libglpk), Cstring, (Ptr{glp_prob},), P)
end

function glp_get_obj_dir(P)
    ccall((:glp_get_obj_dir, libglpk), Cint, (Ptr{glp_prob},), P)
end

function glp_get_num_rows(P)
    ccall((:glp_get_num_rows, libglpk), Cint, (Ptr{glp_prob},), P)
end

function glp_get_num_cols(P)
    ccall((:glp_get_num_cols, libglpk), Cint, (Ptr{glp_prob},), P)
end

function glp_get_row_name(P, i)
    ccall((:glp_get_row_name, libglpk), Cstring, (Ptr{glp_prob}, Cint), P, i)
end

function glp_get_col_name(P, j)
    ccall((:glp_get_col_name, libglpk), Cstring, (Ptr{glp_prob}, Cint), P, j)
end

function glp_get_row_type(P, i)
    ccall((:glp_get_row_type, libglpk), Cint, (Ptr{glp_prob}, Cint), P, i)
end

function glp_get_row_lb(P, i)
    ccall((:glp_get_row_lb, libglpk), Cdouble, (Ptr{glp_prob}, Cint), P, i)
end

function glp_get_row_ub(P, i)
    ccall((:glp_get_row_ub, libglpk), Cdouble, (Ptr{glp_prob}, Cint), P, i)
end

function glp_get_col_type(P, j)
    ccall((:glp_get_col_type, libglpk), Cint, (Ptr{glp_prob}, Cint), P, j)
end

function glp_get_col_lb(P, j)
    ccall((:glp_get_col_lb, libglpk), Cdouble, (Ptr{glp_prob}, Cint), P, j)
end

function glp_get_col_ub(P, j)
    ccall((:glp_get_col_ub, libglpk), Cdouble, (Ptr{glp_prob}, Cint), P, j)
end

function glp_get_obj_coef(P, j)
    ccall((:glp_get_obj_coef, libglpk), Cdouble, (Ptr{glp_prob}, Cint), P, j)
end

function glp_get_num_nz(P)
    ccall((:glp_get_num_nz, libglpk), Cint, (Ptr{glp_prob},), P)
end

function glp_get_mat_row(P, i, ind, val)
    ccall((:glp_get_mat_row, libglpk), Cint, (Ptr{glp_prob}, Cint, Ptr{Cint}, Ptr{Cdouble}), P, i, ind, val)
end

function glp_get_mat_col(P, j, ind, val)
    ccall((:glp_get_mat_col, libglpk), Cint, (Ptr{glp_prob}, Cint, Ptr{Cint}, Ptr{Cdouble}), P, j, ind, val)
end

function glp_create_index(P)
    ccall((:glp_create_index, libglpk), Cvoid, (Ptr{glp_prob},), P)
end

function glp_find_row(P, name)
    ccall((:glp_find_row, libglpk), Cint, (Ptr{glp_prob}, Cstring), P, name)
end

function glp_find_col(P, name)
    ccall((:glp_find_col, libglpk), Cint, (Ptr{glp_prob}, Cstring), P, name)
end

function glp_delete_index(P)
    ccall((:glp_delete_index, libglpk), Cvoid, (Ptr{glp_prob},), P)
end

function glp_set_rii(P, i, rii)
    ccall((:glp_set_rii, libglpk), Cvoid, (Ptr{glp_prob}, Cint, Cdouble), P, i, rii)
end

function glp_set_sjj(P, j, sjj)
    ccall((:glp_set_sjj, libglpk), Cvoid, (Ptr{glp_prob}, Cint, Cdouble), P, j, sjj)
end

function glp_get_rii(P, i)
    ccall((:glp_get_rii, libglpk), Cdouble, (Ptr{glp_prob}, Cint), P, i)
end

function glp_get_sjj(P, j)
    ccall((:glp_get_sjj, libglpk), Cdouble, (Ptr{glp_prob}, Cint), P, j)
end

function glp_scale_prob(P, flags)
    ccall((:glp_scale_prob, libglpk), Cvoid, (Ptr{glp_prob}, Cint), P, flags)
end

function glp_unscale_prob(P)
    ccall((:glp_unscale_prob, libglpk), Cvoid, (Ptr{glp_prob},), P)
end

function glp_set_row_stat(P, i, stat)
    ccall((:glp_set_row_stat, libglpk), Cvoid, (Ptr{glp_prob}, Cint, Cint), P, i, stat)
end

function glp_set_col_stat(P, j, stat)
    ccall((:glp_set_col_stat, libglpk), Cvoid, (Ptr{glp_prob}, Cint, Cint), P, j, stat)
end

function glp_std_basis(P)
    ccall((:glp_std_basis, libglpk), Cvoid, (Ptr{glp_prob},), P)
end

function glp_adv_basis(P, flags)
    ccall((:glp_adv_basis, libglpk), Cvoid, (Ptr{glp_prob}, Cint), P, flags)
end

function glp_cpx_basis(P)
    ccall((:glp_cpx_basis, libglpk), Cvoid, (Ptr{glp_prob},), P)
end

function glp_simplex(P, parm)
    ccall((:glp_simplex, libglpk), Cint, (Ptr{glp_prob}, Ptr{glp_smcp}), P, parm)
end

function glp_exact(P, parm)
    ccall((:glp_exact, libglpk), Cint, (Ptr{glp_prob}, Ptr{glp_smcp}), P, parm)
end

function glp_init_smcp(parm)
    ccall((:glp_init_smcp, libglpk), Cvoid, (Ptr{glp_smcp},), parm)
end

function glp_get_status(P)
    ccall((:glp_get_status, libglpk), Cint, (Ptr{glp_prob},), P)
end

function glp_get_prim_stat(P)
    ccall((:glp_get_prim_stat, libglpk), Cint, (Ptr{glp_prob},), P)
end

function glp_get_dual_stat(P)
    ccall((:glp_get_dual_stat, libglpk), Cint, (Ptr{glp_prob},), P)
end

function glp_get_obj_val(P)
    ccall((:glp_get_obj_val, libglpk), Cdouble, (Ptr{glp_prob},), P)
end

function glp_get_row_stat(P, i)
    ccall((:glp_get_row_stat, libglpk), Cint, (Ptr{glp_prob}, Cint), P, i)
end

function glp_get_row_prim(P, i)
    ccall((:glp_get_row_prim, libglpk), Cdouble, (Ptr{glp_prob}, Cint), P, i)
end

function glp_get_row_dual(P, i)
    ccall((:glp_get_row_dual, libglpk), Cdouble, (Ptr{glp_prob}, Cint), P, i)
end

function glp_get_col_stat(P, j)
    ccall((:glp_get_col_stat, libglpk), Cint, (Ptr{glp_prob}, Cint), P, j)
end

function glp_get_col_prim(P, j)
    ccall((:glp_get_col_prim, libglpk), Cdouble, (Ptr{glp_prob}, Cint), P, j)
end

function glp_get_col_dual(P, j)
    ccall((:glp_get_col_dual, libglpk), Cdouble, (Ptr{glp_prob}, Cint), P, j)
end

function glp_get_unbnd_ray(P)
    ccall((:glp_get_unbnd_ray, libglpk), Cint, (Ptr{glp_prob},), P)
end

function glp_get_it_cnt(P)
    ccall((:glp_get_it_cnt, libglpk), Cint, (Ptr{glp_prob},), P)
end

function glp_set_it_cnt(P, it_cnt)
    ccall((:glp_set_it_cnt, libglpk), Cvoid, (Ptr{glp_prob}, Cint), P, it_cnt)
end

function glp_interior(P, parm)
    ccall((:glp_interior, libglpk), Cint, (Ptr{glp_prob}, Ptr{glp_iptcp}), P, parm)
end

function glp_init_iptcp(parm)
    ccall((:glp_init_iptcp, libglpk), Cvoid, (Ptr{glp_iptcp},), parm)
end

function glp_ipt_status(P)
    ccall((:glp_ipt_status, libglpk), Cint, (Ptr{glp_prob},), P)
end

function glp_ipt_obj_val(P)
    ccall((:glp_ipt_obj_val, libglpk), Cdouble, (Ptr{glp_prob},), P)
end

function glp_ipt_row_prim(P, i)
    ccall((:glp_ipt_row_prim, libglpk), Cdouble, (Ptr{glp_prob}, Cint), P, i)
end

function glp_ipt_row_dual(P, i)
    ccall((:glp_ipt_row_dual, libglpk), Cdouble, (Ptr{glp_prob}, Cint), P, i)
end

function glp_ipt_col_prim(P, j)
    ccall((:glp_ipt_col_prim, libglpk), Cdouble, (Ptr{glp_prob}, Cint), P, j)
end

function glp_ipt_col_dual(P, j)
    ccall((:glp_ipt_col_dual, libglpk), Cdouble, (Ptr{glp_prob}, Cint), P, j)
end

function glp_set_col_kind(P, j, kind)
    ccall((:glp_set_col_kind, libglpk), Cvoid, (Ptr{glp_prob}, Cint, Cint), P, j, kind)
end

function glp_get_col_kind(P, j)
    ccall((:glp_get_col_kind, libglpk), Cint, (Ptr{glp_prob}, Cint), P, j)
end

function glp_get_num_int(P)
    ccall((:glp_get_num_int, libglpk), Cint, (Ptr{glp_prob},), P)
end

function glp_get_num_bin(P)
    ccall((:glp_get_num_bin, libglpk), Cint, (Ptr{glp_prob},), P)
end

function glp_intopt(P, parm)
    ccall((:glp_intopt, libglpk), Cint, (Ptr{glp_prob}, Ptr{glp_iocp}), P, parm)
end

function glp_init_iocp(parm)
    ccall((:glp_init_iocp, libglpk), Cvoid, (Ptr{glp_iocp},), parm)
end

function glp_mip_status(P)
    ccall((:glp_mip_status, libglpk), Cint, (Ptr{glp_prob},), P)
end

function glp_mip_obj_val(P)
    ccall((:glp_mip_obj_val, libglpk), Cdouble, (Ptr{glp_prob},), P)
end

function glp_mip_row_val(P, i)
    ccall((:glp_mip_row_val, libglpk), Cdouble, (Ptr{glp_prob}, Cint), P, i)
end

function glp_mip_col_val(P, j)
    ccall((:glp_mip_col_val, libglpk), Cdouble, (Ptr{glp_prob}, Cint), P, j)
end

function glp_check_kkt(P, sol, cond, ae_max, ae_ind, re_max, re_ind)
    ccall((:glp_check_kkt, libglpk), Cvoid, (Ptr{glp_prob}, Cint, Cint, Ptr{Cdouble}, Ptr{Cint}, Ptr{Cdouble}, Ptr{Cint}), P, sol, cond, ae_max, ae_ind, re_max, re_ind)
end

function glp_print_sol(P, fname)
    ccall((:glp_print_sol, libglpk), Cint, (Ptr{glp_prob}, Cstring), P, fname)
end

function glp_read_sol(P, fname)
    ccall((:glp_read_sol, libglpk), Cint, (Ptr{glp_prob}, Cstring), P, fname)
end

function glp_write_sol(P, fname)
    ccall((:glp_write_sol, libglpk), Cint, (Ptr{glp_prob}, Cstring), P, fname)
end

function glp_print_ranges(P, len, list, flags, fname)
    ccall((:glp_print_ranges, libglpk), Cint, (Ptr{glp_prob}, Cint, Ptr{Cint}, Cint, Cstring), P, len, list, flags, fname)
end

function glp_print_ipt(P, fname)
    ccall((:glp_print_ipt, libglpk), Cint, (Ptr{glp_prob}, Cstring), P, fname)
end

function glp_read_ipt(P, fname)
    ccall((:glp_read_ipt, libglpk), Cint, (Ptr{glp_prob}, Cstring), P, fname)
end

function glp_write_ipt(P, fname)
    ccall((:glp_write_ipt, libglpk), Cint, (Ptr{glp_prob}, Cstring), P, fname)
end

function glp_print_mip(P, fname)
    ccall((:glp_print_mip, libglpk), Cint, (Ptr{glp_prob}, Cstring), P, fname)
end

function glp_read_mip(P, fname)
    ccall((:glp_read_mip, libglpk), Cint, (Ptr{glp_prob}, Cstring), P, fname)
end

function glp_write_mip(P, fname)
    ccall((:glp_write_mip, libglpk), Cint, (Ptr{glp_prob}, Cstring), P, fname)
end

function glp_bf_exists(P)
    ccall((:glp_bf_exists, libglpk), Cint, (Ptr{glp_prob},), P)
end

function glp_factorize(P)
    ccall((:glp_factorize, libglpk), Cint, (Ptr{glp_prob},), P)
end

function glp_bf_updated(P)
    ccall((:glp_bf_updated, libglpk), Cint, (Ptr{glp_prob},), P)
end

function glp_get_bfcp(P, parm)
    ccall((:glp_get_bfcp, libglpk), Cvoid, (Ptr{glp_prob}, Ptr{glp_bfcp}), P, parm)
end

function glp_set_bfcp(P, parm)
    ccall((:glp_set_bfcp, libglpk), Cvoid, (Ptr{glp_prob}, Ptr{glp_bfcp}), P, parm)
end

function glp_get_bhead(P, k)
    ccall((:glp_get_bhead, libglpk), Cint, (Ptr{glp_prob}, Cint), P, k)
end

function glp_get_row_bind(P, i)
    ccall((:glp_get_row_bind, libglpk), Cint, (Ptr{glp_prob}, Cint), P, i)
end

function glp_get_col_bind(P, j)
    ccall((:glp_get_col_bind, libglpk), Cint, (Ptr{glp_prob}, Cint), P, j)
end

function glp_ftran(P, x)
    ccall((:glp_ftran, libglpk), Cvoid, (Ptr{glp_prob}, Ptr{Cdouble}), P, x)
end

function glp_btran(P, x)
    ccall((:glp_btran, libglpk), Cvoid, (Ptr{glp_prob}, Ptr{Cdouble}), P, x)
end

function glp_warm_up(P)
    ccall((:glp_warm_up, libglpk), Cint, (Ptr{glp_prob},), P)
end

function glp_eval_tab_row(P, k, ind, val)
    ccall((:glp_eval_tab_row, libglpk), Cint, (Ptr{glp_prob}, Cint, Ptr{Cint}, Ptr{Cdouble}), P, k, ind, val)
end

function glp_eval_tab_col(P, k, ind, val)
    ccall((:glp_eval_tab_col, libglpk), Cint, (Ptr{glp_prob}, Cint, Ptr{Cint}, Ptr{Cdouble}), P, k, ind, val)
end

function glp_transform_row(P, len, ind, val)
    ccall((:glp_transform_row, libglpk), Cint, (Ptr{glp_prob}, Cint, Ptr{Cint}, Ptr{Cdouble}), P, len, ind, val)
end

function glp_transform_col(P, len, ind, val)
    ccall((:glp_transform_col, libglpk), Cint, (Ptr{glp_prob}, Cint, Ptr{Cint}, Ptr{Cdouble}), P, len, ind, val)
end

function glp_prim_rtest(P, len, ind, val, dir, eps)
    ccall((:glp_prim_rtest, libglpk), Cint, (Ptr{glp_prob}, Cint, Ptr{Cint}, Ptr{Cdouble}, Cint, Cdouble), P, len, ind, val, dir, eps)
end

function glp_dual_rtest(P, len, ind, val, dir, eps)
    ccall((:glp_dual_rtest, libglpk), Cint, (Ptr{glp_prob}, Cint, Ptr{Cint}, Ptr{Cdouble}, Cint, Cdouble), P, len, ind, val, dir, eps)
end

function glp_analyze_bound(P, k, value1, var1, value2, var2)
    ccall((:glp_analyze_bound, libglpk), Cvoid, (Ptr{glp_prob}, Cint, Ptr{Cdouble}, Ptr{Cint}, Ptr{Cdouble}, Ptr{Cint}), P, k, value1, var1, value2, var2)
end

function glp_analyze_coef(P, k, coef1, var1, value1, coef2, var2, value2)
    ccall((:glp_analyze_coef, libglpk), Cvoid, (Ptr{glp_prob}, Cint, Ptr{Cdouble}, Ptr{Cint}, Ptr{Cdouble}, Ptr{Cdouble}, Ptr{Cint}, Ptr{Cdouble}), P, k, coef1, var1, value1, coef2, var2, value2)
end

function glp_npp_alloc_wksp()
    ccall((:glp_npp_alloc_wksp, libglpk), Ptr{glp_prep}, ())
end

function glp_npp_load_prob(prep, P, sol, names)
    ccall((:glp_npp_load_prob, libglpk), Cvoid, (Ptr{glp_prep}, Ptr{glp_prob}, Cint, Cint), prep, P, sol, names)
end

function glp_npp_preprocess1(prep, hard)
    ccall((:glp_npp_preprocess1, libglpk), Cint, (Ptr{glp_prep}, Cint), prep, hard)
end

function glp_npp_build_prob(prep, Q)
    ccall((:glp_npp_build_prob, libglpk), Cvoid, (Ptr{glp_prep}, Ptr{glp_prob}), prep, Q)
end

function glp_npp_postprocess(prep, Q)
    ccall((:glp_npp_postprocess, libglpk), Cvoid, (Ptr{glp_prep}, Ptr{glp_prob}), prep, Q)
end

function glp_npp_obtain_sol(prep, P)
    ccall((:glp_npp_obtain_sol, libglpk), Cvoid, (Ptr{glp_prep}, Ptr{glp_prob}), prep, P)
end

function glp_npp_free_wksp(prep)
    ccall((:glp_npp_free_wksp, libglpk), Cvoid, (Ptr{glp_prep},), prep)
end

function glp_ios_reason(T)
    ccall((:glp_ios_reason, libglpk), Cint, (Ptr{glp_tree},), T)
end

function glp_ios_get_prob(T)
    ccall((:glp_ios_get_prob, libglpk), Ptr{glp_prob}, (Ptr{glp_tree},), T)
end

function glp_ios_tree_size(T, a_cnt, n_cnt, t_cnt)
    ccall((:glp_ios_tree_size, libglpk), Cvoid, (Ptr{glp_tree}, Ptr{Cint}, Ptr{Cint}, Ptr{Cint}), T, a_cnt, n_cnt, t_cnt)
end

function glp_ios_curr_node(T)
    ccall((:glp_ios_curr_node, libglpk), Cint, (Ptr{glp_tree},), T)
end

function glp_ios_next_node(T, p)
    ccall((:glp_ios_next_node, libglpk), Cint, (Ptr{glp_tree}, Cint), T, p)
end

function glp_ios_prev_node(T, p)
    ccall((:glp_ios_prev_node, libglpk), Cint, (Ptr{glp_tree}, Cint), T, p)
end

function glp_ios_up_node(T, p)
    ccall((:glp_ios_up_node, libglpk), Cint, (Ptr{glp_tree}, Cint), T, p)
end

function glp_ios_node_level(T, p)
    ccall((:glp_ios_node_level, libglpk), Cint, (Ptr{glp_tree}, Cint), T, p)
end

function glp_ios_node_bound(T, p)
    ccall((:glp_ios_node_bound, libglpk), Cdouble, (Ptr{glp_tree}, Cint), T, p)
end

function glp_ios_best_node(T)
    ccall((:glp_ios_best_node, libglpk), Cint, (Ptr{glp_tree},), T)
end

function glp_ios_mip_gap(T)
    ccall((:glp_ios_mip_gap, libglpk), Cdouble, (Ptr{glp_tree},), T)
end

function glp_ios_node_data(T, p)
    ccall((:glp_ios_node_data, libglpk), Ptr{Cvoid}, (Ptr{glp_tree}, Cint), T, p)
end

function glp_ios_row_attr(T, i, attr)
    ccall((:glp_ios_row_attr, libglpk), Cvoid, (Ptr{glp_tree}, Cint, Ptr{glp_attr}), T, i, attr)
end

function glp_ios_pool_size(T)
    ccall((:glp_ios_pool_size, libglpk), Cint, (Ptr{glp_tree},), T)
end

function glp_ios_add_row(T, name, klass, flags, len, ind, val, type, rhs)
    ccall((:glp_ios_add_row, libglpk), Cint, (Ptr{glp_tree}, Cstring, Cint, Cint, Cint, Ptr{Cint}, Ptr{Cdouble}, Cint, Cdouble), T, name, klass, flags, len, ind, val, type, rhs)
end

function glp_ios_del_row(T, i)
    ccall((:glp_ios_del_row, libglpk), Cvoid, (Ptr{glp_tree}, Cint), T, i)
end

function glp_ios_clear_pool(T)
    ccall((:glp_ios_clear_pool, libglpk), Cvoid, (Ptr{glp_tree},), T)
end

function glp_ios_can_branch(T, j)
    ccall((:glp_ios_can_branch, libglpk), Cint, (Ptr{glp_tree}, Cint), T, j)
end

function glp_ios_branch_upon(T, j, sel)
    ccall((:glp_ios_branch_upon, libglpk), Cvoid, (Ptr{glp_tree}, Cint, Cint), T, j, sel)
end

function glp_ios_select_node(T, p)
    ccall((:glp_ios_select_node, libglpk), Cvoid, (Ptr{glp_tree}, Cint), T, p)
end

function glp_ios_heur_sol(T, x)
    ccall((:glp_ios_heur_sol, libglpk), Cint, (Ptr{glp_tree}, Ptr{Cdouble}), T, x)
end

function glp_ios_terminate(T)
    ccall((:glp_ios_terminate, libglpk), Cvoid, (Ptr{glp_tree},), T)
end

function glp_init_mpscp(parm)
    ccall((:glp_init_mpscp, libglpk), Cvoid, (Ptr{glp_mpscp},), parm)
end

function glp_read_mps(P, fmt, parm, fname)
    ccall((:glp_read_mps, libglpk), Cint, (Ptr{glp_prob}, Cint, Ptr{glp_mpscp}, Cstring), P, fmt, parm, fname)
end

function glp_write_mps(P, fmt, parm, fname)
    ccall((:glp_write_mps, libglpk), Cint, (Ptr{glp_prob}, Cint, Ptr{glp_mpscp}, Cstring), P, fmt, parm, fname)
end

function glp_init_cpxcp(parm)
    ccall((:glp_init_cpxcp, libglpk), Cvoid, (Ptr{glp_cpxcp},), parm)
end

function glp_read_lp(P, parm, fname)
    ccall((:glp_read_lp, libglpk), Cint, (Ptr{glp_prob}, Ptr{glp_cpxcp}, Cstring), P, parm, fname)
end

function glp_write_lp(P, parm, fname)
    ccall((:glp_write_lp, libglpk), Cint, (Ptr{glp_prob}, Ptr{glp_cpxcp}, Cstring), P, parm, fname)
end

function glp_read_prob(P, flags, fname)
    ccall((:glp_read_prob, libglpk), Cint, (Ptr{glp_prob}, Cint, Cstring), P, flags, fname)
end

function glp_write_prob(P, flags, fname)
    ccall((:glp_write_prob, libglpk), Cint, (Ptr{glp_prob}, Cint, Cstring), P, flags, fname)
end

function glp_mpl_alloc_wksp()
    ccall((:glp_mpl_alloc_wksp, libglpk), Ptr{glp_tran}, ())
end

function glp_mpl_init_rand(tran, seed)
    ccall((:glp_mpl_init_rand, libglpk), Cvoid, (Ptr{glp_tran}, Cint), tran, seed)
end

function glp_mpl_read_model(tran, fname, skip)
    ccall((:glp_mpl_read_model, libglpk), Cint, (Ptr{glp_tran}, Cstring, Cint), tran, fname, skip)
end

function glp_mpl_read_data(tran, fname)
    ccall((:glp_mpl_read_data, libglpk), Cint, (Ptr{glp_tran}, Cstring), tran, fname)
end

function glp_mpl_generate(tran, fname)
    ccall((:glp_mpl_generate, libglpk), Cint, (Ptr{glp_tran}, Cstring), tran, fname)
end

function glp_mpl_build_prob(tran, prob)
    ccall((:glp_mpl_build_prob, libglpk), Cvoid, (Ptr{glp_tran}, Ptr{glp_prob}), tran, prob)
end

function glp_mpl_postsolve(tran, prob, sol)
    ccall((:glp_mpl_postsolve, libglpk), Cint, (Ptr{glp_tran}, Ptr{glp_prob}, Cint), tran, prob, sol)
end

function glp_mpl_free_wksp(tran)
    ccall((:glp_mpl_free_wksp, libglpk), Cvoid, (Ptr{glp_tran},), tran)
end

function glp_read_cnfsat(P, fname)
    ccall((:glp_read_cnfsat, libglpk), Cint, (Ptr{glp_prob}, Cstring), P, fname)
end

function glp_check_cnfsat(P)
    ccall((:glp_check_cnfsat, libglpk), Cint, (Ptr{glp_prob},), P)
end

function glp_write_cnfsat(P, fname)
    ccall((:glp_write_cnfsat, libglpk), Cint, (Ptr{glp_prob}, Cstring), P, fname)
end

function glp_minisat1(P)
    ccall((:glp_minisat1, libglpk), Cint, (Ptr{glp_prob},), P)
end

function glp_intfeas1(P, use_bound, obj_bound)
    ccall((:glp_intfeas1, libglpk), Cint, (Ptr{glp_prob}, Cint, Cint), P, use_bound, obj_bound)
end

function glp_init_env()
    ccall((:glp_init_env, libglpk), Cint, ())
end

function glp_version()
    ccall((:glp_version, libglpk), Cstring, ())
end

function glp_config(option)
    ccall((:glp_config, libglpk), Cstring, (Cstring,), option)
end

function glp_free_env()
    ccall((:glp_free_env, libglpk), Cint, ())
end

function glp_puts(s)
    ccall((:glp_puts, libglpk), Cvoid, (Cstring,), s)
end

function glp_vprintf(fmt, arg)
    ccall((:glp_vprintf, libglpk), Cvoid, (Cstring, Cint), fmt, arg)
end

function glp_term_out(flag)
    ccall((:glp_term_out, libglpk), Cint, (Cint,), flag)
end

function glp_term_hook(func, info)
    ccall((:glp_term_hook, libglpk), Cvoid, (Ptr{Cvoid}, Ptr{Cvoid}), func, info)
end

function glp_open_tee(name)
    ccall((:glp_open_tee, libglpk), Cint, (Cstring,), name)
end

function glp_close_tee()
    ccall((:glp_close_tee, libglpk), Cint, ())
end

function glp_error_(file, line)
    ccall((:glp_error_, libglpk), glp_errfunc, (Cstring, Cint), file, line)
end

function glp_at_error()
    ccall((:glp_at_error, libglpk), Cint, ())
end

function glp_assert_(expr, file, line)
    ccall((:glp_assert_, libglpk), Cvoid, (Cstring, Cstring, Cint), expr, file, line)
end

function glp_error_hook(func, info)
    ccall((:glp_error_hook, libglpk), Cvoid, (Ptr{Cvoid}, Ptr{Cvoid}), func, info)
end

function glp_alloc(n, size)
    ccall((:glp_alloc, libglpk), Ptr{Cvoid}, (Cint, Cint), n, size)
end

function glp_realloc(ptr, n, size)
    ccall((:glp_realloc, libglpk), Ptr{Cvoid}, (Ptr{Cvoid}, Cint, Cint), ptr, n, size)
end

function glp_free(ptr)
    ccall((:glp_free, libglpk), Cvoid, (Ptr{Cvoid},), ptr)
end

function glp_mem_limit(limit)
    ccall((:glp_mem_limit, libglpk), Cvoid, (Cint,), limit)
end

function glp_mem_usage(count, cpeak, total, tpeak)
    ccall((:glp_mem_usage, libglpk), Cvoid, (Ptr{Cint}, Ptr{Cint}, Ptr{Cint}, Ptr{Cint}), count, cpeak, total, tpeak)
end

function glp_time()
    ccall((:glp_time, libglpk), Cdouble, ())
end

function glp_difftime(t1, t0)
    ccall((:glp_difftime, libglpk), Cdouble, (Cdouble, Cdouble), t1, t0)
end

function glp_create_graph(v_size, a_size)
    ccall((:glp_create_graph, libglpk), Ptr{glp_graph}, (Cint, Cint), v_size, a_size)
end

function glp_set_graph_name(G, name)
    ccall((:glp_set_graph_name, libglpk), Cvoid, (Ptr{glp_graph}, Cstring), G, name)
end

function glp_add_vertices(G, nadd)
    ccall((:glp_add_vertices, libglpk), Cint, (Ptr{glp_graph}, Cint), G, nadd)
end

function glp_set_vertex_name(G, i, name)
    ccall((:glp_set_vertex_name, libglpk), Cvoid, (Ptr{glp_graph}, Cint, Cstring), G, i, name)
end

function glp_add_arc(G, i, j)
    ccall((:glp_add_arc, libglpk), Ptr{glp_arc}, (Ptr{glp_graph}, Cint, Cint), G, i, j)
end

function glp_del_vertices(G, ndel, num)
    ccall((:glp_del_vertices, libglpk), Cvoid, (Ptr{glp_graph}, Cint, Ptr{Cint}), G, ndel, num)
end

function glp_del_arc(G, a)
    ccall((:glp_del_arc, libglpk), Cvoid, (Ptr{glp_graph}, Ptr{glp_arc}), G, a)
end

function glp_erase_graph(G, v_size, a_size)
    ccall((:glp_erase_graph, libglpk), Cvoid, (Ptr{glp_graph}, Cint, Cint), G, v_size, a_size)
end

function glp_delete_graph(G)
    ccall((:glp_delete_graph, libglpk), Cvoid, (Ptr{glp_graph},), G)
end

function glp_create_v_index(G)
    ccall((:glp_create_v_index, libglpk), Cvoid, (Ptr{glp_graph},), G)
end

function glp_find_vertex(G, name)
    ccall((:glp_find_vertex, libglpk), Cint, (Ptr{glp_graph}, Cstring), G, name)
end

function glp_delete_v_index(G)
    ccall((:glp_delete_v_index, libglpk), Cvoid, (Ptr{glp_graph},), G)
end

function glp_read_graph(G, fname)
    ccall((:glp_read_graph, libglpk), Cint, (Ptr{glp_graph}, Cstring), G, fname)
end

function glp_write_graph(G, fname)
    ccall((:glp_write_graph, libglpk), Cint, (Ptr{glp_graph}, Cstring), G, fname)
end

function glp_mincost_lp(P, G, names, v_rhs, a_low, a_cap, a_cost)
    ccall((:glp_mincost_lp, libglpk), Cvoid, (Ptr{glp_prob}, Ptr{glp_graph}, Cint, Cint, Cint, Cint, Cint), P, G, names, v_rhs, a_low, a_cap, a_cost)
end

function glp_mincost_okalg(G, v_rhs, a_low, a_cap, a_cost, sol, a_x, v_pi)
    ccall((:glp_mincost_okalg, libglpk), Cint, (Ptr{glp_graph}, Cint, Cint, Cint, Cint, Ptr{Cdouble}, Cint, Cint), G, v_rhs, a_low, a_cap, a_cost, sol, a_x, v_pi)
end

function glp_mincost_relax4(G, v_rhs, a_low, a_cap, a_cost, crash, sol, a_x, a_rc)
    ccall((:glp_mincost_relax4, libglpk), Cint, (Ptr{glp_graph}, Cint, Cint, Cint, Cint, Cint, Ptr{Cdouble}, Cint, Cint), G, v_rhs, a_low, a_cap, a_cost, crash, sol, a_x, a_rc)
end

function glp_maxflow_lp(P, G, names, s, t, a_cap)
    ccall((:glp_maxflow_lp, libglpk), Cvoid, (Ptr{glp_prob}, Ptr{glp_graph}, Cint, Cint, Cint, Cint), P, G, names, s, t, a_cap)
end

function glp_maxflow_ffalg(G, s, t, a_cap, sol, a_x, v_cut)
    ccall((:glp_maxflow_ffalg, libglpk), Cint, (Ptr{glp_graph}, Cint, Cint, Cint, Ptr{Cdouble}, Cint, Cint), G, s, t, a_cap, sol, a_x, v_cut)
end

function glp_check_asnprob(G, v_set)
    ccall((:glp_check_asnprob, libglpk), Cint, (Ptr{glp_graph}, Cint), G, v_set)
end

function glp_asnprob_lp(P, form, G, names, v_set, a_cost)
    ccall((:glp_asnprob_lp, libglpk), Cint, (Ptr{glp_prob}, Cint, Ptr{glp_graph}, Cint, Cint, Cint), P, form, G, names, v_set, a_cost)
end

function glp_asnprob_okalg(form, G, v_set, a_cost, sol, a_x)
    ccall((:glp_asnprob_okalg, libglpk), Cint, (Cint, Ptr{glp_graph}, Cint, Cint, Ptr{Cdouble}, Cint), form, G, v_set, a_cost, sol, a_x)
end

function glp_asnprob_hall(G, v_set, a_x)
    ccall((:glp_asnprob_hall, libglpk), Cint, (Ptr{glp_graph}, Cint, Cint), G, v_set, a_x)
end

function glp_cpp(G, v_t, v_es, v_ls)
    ccall((:glp_cpp, libglpk), Cdouble, (Ptr{glp_graph}, Cint, Cint, Cint), G, v_t, v_es, v_ls)
end

function glp_read_mincost(G, v_rhs, a_low, a_cap, a_cost, fname)
    ccall((:glp_read_mincost, libglpk), Cint, (Ptr{glp_graph}, Cint, Cint, Cint, Cint, Cstring), G, v_rhs, a_low, a_cap, a_cost, fname)
end

function glp_write_mincost(G, v_rhs, a_low, a_cap, a_cost, fname)
    ccall((:glp_write_mincost, libglpk), Cint, (Ptr{glp_graph}, Cint, Cint, Cint, Cint, Cstring), G, v_rhs, a_low, a_cap, a_cost, fname)
end

function glp_read_maxflow(G, s, t, a_cap, fname)
    ccall((:glp_read_maxflow, libglpk), Cint, (Ptr{glp_graph}, Ptr{Cint}, Ptr{Cint}, Cint, Cstring), G, s, t, a_cap, fname)
end

function glp_write_maxflow(G, s, t, a_cap, fname)
    ccall((:glp_write_maxflow, libglpk), Cint, (Ptr{glp_graph}, Cint, Cint, Cint, Cstring), G, s, t, a_cap, fname)
end

function glp_read_asnprob(G, v_set, a_cost, fname)
    ccall((:glp_read_asnprob, libglpk), Cint, (Ptr{glp_graph}, Cint, Cint, Cstring), G, v_set, a_cost, fname)
end

function glp_write_asnprob(G, v_set, a_cost, fname)
    ccall((:glp_write_asnprob, libglpk), Cint, (Ptr{glp_graph}, Cint, Cint, Cstring), G, v_set, a_cost, fname)
end

function glp_read_ccdata(G, v_wgt, fname)
    ccall((:glp_read_ccdata, libglpk), Cint, (Ptr{glp_graph}, Cint, Cstring), G, v_wgt, fname)
end

function glp_write_ccdata(G, v_wgt, fname)
    ccall((:glp_write_ccdata, libglpk), Cint, (Ptr{glp_graph}, Cint, Cstring), G, v_wgt, fname)
end

function glp_netgen(G, v_rhs, a_cap, a_cost, parm)
    ccall((:glp_netgen, libglpk), Cint, (Ptr{glp_graph}, Cint, Cint, Cint, Ptr{Cint}), G, v_rhs, a_cap, a_cost, parm)
end

function glp_netgen_prob(nprob, parm)
    ccall((:glp_netgen_prob, libglpk), Cvoid, (Cint, Ptr{Cint}), nprob, parm)
end

function glp_gridgen(G, v_rhs, a_cap, a_cost, parm)
    ccall((:glp_gridgen, libglpk), Cint, (Ptr{glp_graph}, Cint, Cint, Cint, Ptr{Cint}), G, v_rhs, a_cap, a_cost, parm)
end

function glp_rmfgen(G, s, t, a_cap, parm)
    ccall((:glp_rmfgen, libglpk), Cint, (Ptr{glp_graph}, Ptr{Cint}, Ptr{Cint}, Cint, Ptr{Cint}), G, s, t, a_cap, parm)
end

function glp_weak_comp(G, v_num)
    ccall((:glp_weak_comp, libglpk), Cint, (Ptr{glp_graph}, Cint), G, v_num)
end

function glp_strong_comp(G, v_num)
    ccall((:glp_strong_comp, libglpk), Cint, (Ptr{glp_graph}, Cint), G, v_num)
end

function glp_top_sort(G, v_num)
    ccall((:glp_top_sort, libglpk), Cint, (Ptr{glp_graph}, Cint), G, v_num)
end

function glp_wclique_exact(G, v_wgt, sol, v_set)
    ccall((:glp_wclique_exact, libglpk), Cint, (Ptr{glp_graph}, Cint, Ptr{Cdouble}, Cint), G, v_wgt, sol, v_set)
end

# Copyright (c) 2012 GLPK.jl contributors
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the Licence, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

using Test
import GLPK

function cb_callback(tree::Ptr{Cvoid}, info::Ptr{Cvoid})
    reason = GLPK.glp_ios_reason(tree)
    @test reason in [
        GLPK.GLP_ISELECT,
        GLPK.GLP_IPREPRO,
        GLPK.GLP_IROWGEN,
        GLPK.GLP_IHEUR,
        GLPK.GLP_ICUTGEN,
        GLPK.GLP_IBRANCH,
        GLPK.GLP_IBINGO,
    ]

    prob = GLPK.glp_ios_get_prob(tree)

    a_cnt, n_cnt, t_cnt = Ref{Cint}(), Ref{Cint}(), Ref{Cint}()
    GLPK.glp_ios_tree_size(tree, a_cnt, n_cnt, t_cnt)
    cn = GLPK.glp_ios_curr_node(tree)
    bn = GLPK.glp_ios_best_node(tree)
    fan = GLPK.glp_ios_next_node(tree, 0)
    GLPK.glp_ios_next_node(tree, fan)
    lan = GLPK.glp_ios_prev_node(tree, 0)
    GLPK.glp_ios_prev_node(tree, lan)
    for i in 1:t_cnt[]
        try
            un = GLPK.glp_ios_up_node(tree, i)
            nl = GLPK.glp_ios_node_level(tree, i)
            nb = GLPK.glp_ios_node_bound(tree, i)
            nd = GLPK.glp_ios_node_data(tree, i)
        catch
        end
    end

    for i in 1:GLPK.glp_get_num_rows(prob)
        attr = GLPK.glp_attr(0, 0, 0, tuple(fill(0.0, 7)...))
        GLPK.glp_ios_row_attr(tree, i, attr)
    end
    for i in 1:GLPK.glp_get_num_cols(prob)
        cb = GLPK.glp_ios_can_branch(tree, i)
    end

    mg = GLPK.glp_ios_mip_gap(tree)
    if reason == GLPK.GLP_ISELECT
        @test cn == 0
        GLPK.glp_ios_select_node(tree, fan)
    elseif reason == GLPK.GLP_IPREPRO
    elseif reason == GLPK.GLP_IROWGEN
    elseif reason == GLPK.GLP_IHEUR
        #GLPK.ios_heur_sol(tree, zeros(Int, GLPK.get_num_cols(GLPK.ios_get_prob(tree))))
    elseif reason == GLPK.GLP_ICUTGEN
        ps = GLPK.glp_ios_pool_size(tree)
        indices, coefficients = Cint[], Cdouble[]
        GLPK.glp_ios_add_row(
            tree,
            "",
            0,
            0,
            Cint(length(indices)),
            GLPK.offset(indices),
            GLPK.offset(coefficients),
            GLPK.GLP_LO,
            0.0,
        )
        @test GLPK.glp_ios_pool_size(tree) == ps + 1
        indices, coefficients = Cint[1, 2, 3], Cdouble[7, 6, 5]
        GLPK.glp_ios_add_row(
            tree,
            "",
            0,
            0,
            Cint(length(indices)),
            GLPK.offset(indices),
            GLPK.offset(coefficients),
            GLPK.GLP_LO,
            0.0,
        )
        @test GLPK.glp_ios_pool_size(tree) == ps + 2
        # TODO(odow): causes segfault in GLPK 5.0 for some reason
        # GLPK.glp_ios_del_row(tree, 1)
        # @test GLPK.glp_ios_pool_size(tree) == ps + 1
        GLPK.glp_ios_clear_pool(tree)
        @test GLPK.glp_ios_pool_size(tree) == 0
    elseif reason == GLPK.GLP_IBRANCH
        for i in 1:GLPK.glp_get_num_cols(prob)
            if GLPK.glp_ios_can_branch(tree, i) != 0
                GLPK.glp_ios_branch_upon(tree, i, GLPK.GLP_NO_BRNCH)
                break
            end
        end
    elseif reason == GLPK.GLP_IBINGO
    end

    return nothing
end

function glpk_tst_6()
    datadir = joinpath(@__DIR__, "data")
    @assert isdir(datadir)

    prev_term_out = GLPK.glp_term_out(GLPK.GLP_OFF)

    mip = GLPK.glp_create_prob()
    tran = GLPK.glp_mpl_alloc_wksp()
    GLPK.glp_mpl_read_model(tran, joinpath(datadir, "sudoku.mod"), 1)
    GLPK.glp_mpl_read_data(tran, joinpath(datadir, "sudoku.dat"))
    GLPK.glp_mpl_generate(tran, C_NULL)
    GLPK.glp_mpl_build_prob(tran, mip)
    #@test GLPK.glp_simplex(mip, nothing) == 0

    params = GLPK.glp_iocp()
    GLPK.glp_init_iocp(params)
    params.presolve = GLPK.GLP_ON
    params.cb_size = 1

    params.cb_func = @cfunction(cb_callback, Cvoid, (Ptr{Cvoid}, Ptr{Cvoid}))

    @test GLPK.glp_intopt(mip, params) == 0

    GLPK.glp_mpl_postsolve(tran, mip, GLPK.GLP_MIP)

    GLPK.glp_term_out(prev_term_out)
    GLPK.glp_mpl_free_wksp(tran)
    return GLPK.glp_delete_prob(mip)
end

glpk_tst_6()

# Copyright (c) 2012 GLPK.jl contributors
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the Licence, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

using Test
import GLPK

# Test reading and writing MathProg files

function glpk_tst_3()
    prev_term_out = GLPK.glp_term_out(GLPK.GLP_OFF)

    datadir = joinpath(dirname(@__FILE__), "data")
    @assert isdir(datadir)

    lp = GLPK.glp_create_prob()
    tran = GLPK.glp_mpl_alloc_wksp()

    GLPK.glp_mpl_read_model(tran, joinpath(datadir, "queens.mod"), 0)

    outfile = tempname()
    try
        GLPK.glp_mpl_generate(tran, outfile)
        GLPK.glp_mpl_build_prob(tran, lp)
        GLPK.glp_mpl_free_wksp(tran)
    finally
        isfile(outfile) && rm(outfile)
    end

    @test GLPK.glp_simplex(lp, C_NULL) == 0

    GLPK.glp_term_out(prev_term_out)
    return GLPK.glp_delete_prob(lp)
end

glpk_tst_3()

# Copyright (c) 2012 GLPK.jl contributors
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the Licence, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

using GLPK
using Test

@testset "C API" begin
    @testset "glpk_tst_$(i).jl" for i in 1:6
        include("glpk_tst_$i.jl")
    end
end

@testset "MathOptInterface" begin
    include("MOI_wrapper.jl")
    include("MOI_callbacks.jl")
end

# Copyright (c) 2012 GLPK.jl contributors
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the Licence, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

import MathOptInterface

const MOI = MathOptInterface
const CleverDicts = MOI.Utilities.CleverDicts

const _SCALAR_SETS = Union{
    MOI.GreaterThan{Float64},
    MOI.LessThan{Float64},
    MOI.EqualTo{Float64},
    MOI.Interval{Float64},
}

@enum(_VariableType, _CONTINUOUS, _BINARY, _INTEGER)

@enum(
    _VariableBound,
    _NONE,
    _LESS_THAN,
    _GREATER_THAN,
    _LESS_AND_GREATER_THAN,
    _INTERVAL,
    _EQUAL_TO
)

@enum(
    _CallbackState,
    _CB_NONE,
    _CB_GENERIC,
    _CB_LAZY,
    _CB_USER_CUT,
    _CB_HEURISTIC,
)

@enum(MethodEnum, SIMPLEX, INTERIOR, EXACT)

mutable struct _VariableInfo
    index::MOI.VariableIndex
    column::Int
    bound::_VariableBound
    type::_VariableType
    name::String
end

function _VariableInfo(index::MOI.VariableIndex, column::Int)
    return _VariableInfo(index, column, _NONE, _CONTINUOUS, "")
end

struct _ConstraintKey
    value::Int64
end
CleverDicts.key_to_index(k::_ConstraintKey) = k.value
CleverDicts.index_to_key(::Type{_ConstraintKey}, index) = _ConstraintKey(index)

_HASH(x) = CleverDicts.key_to_index(x)
_INVERSE_HASH_V(x) = CleverDicts.index_to_key(MOI.VariableIndex, x)
_INVERSE_HASH_C(x) = CleverDicts.index_to_key(_ConstraintKey, x)

mutable struct _ConstraintInfo
    row::Int
    set::MOI.AbstractSet
    name::String
    _ConstraintInfo(set) = new(0, set, "")
    _ConstraintInfo(row, set) = new(row, set, "")
end

"""
    Optimizer(;
        want_infeasibility_certificates::Bool = true,
        method::MethodEnum = GLPK.SIMPLEX,
    )

Create a new Optimizer object.

## Arguments

 * `want_infeasibility_certificates::Bool`: flag to control whether to
   attempt to generate an infeasibility certificate in the case of primal or
   dual infeasibility. Defaults to `true`. You should set this to `false` if
   you want GLPK to report primal or dual infeasiblity, but you don't need
   a certificate.

 * `method::MethodEnum`: Solution method to use. Default is `GLPK.SIMPLEX`.
   Other options are `GLPK.EXACT` and `GLPK.INTERIOR`.
"""
mutable struct Optimizer <: MOI.AbstractOptimizer
    # The low-level GLPK problem.
    inner::Ptr{glp_prob}
    method::MethodEnum

    interior_param::glp_iptcp
    intopt_param::glp_iocp
    simplex_param::glp_smcp
    solver_status::Cint
    last_solved_by_mip::Bool
    num_binaries::Int
    num_integers::Int

    objective_bound::Float64
    relative_gap::Float64
    solve_time::Float64
    callback_data::Any

    # A flag to keep track of MOI.Silent, which over-rides the print_level
    # parameter.
    silent::Bool

    is_objective_set::Bool
    objective_sense::Union{Nothing,MOI.OptimizationSense}

    variable_info::CleverDicts.CleverDict{
        MOI.VariableIndex,
        _VariableInfo,
        typeof(_HASH),
        typeof(_INVERSE_HASH_V),
    }
    affine_constraint_info::CleverDicts.CleverDict{
        _ConstraintKey,
        _ConstraintInfo,
        typeof(_HASH),
        typeof(_INVERSE_HASH_C),
    }

    # Mappings from variable and constraint names to their indices. These are
    # lazily built on-demand, so most of the time, they are `nothing`.
    name_to_variable::Union{
        Nothing,
        Dict{String,Union{Nothing,MOI.VariableIndex}},
    }
    name_to_constraint_index::Union{
        Nothing,
        Dict{String,Union{Nothing,MOI.ConstraintIndex}},
    }

    optimize_not_called::Bool

    # These two flags allow us to distinguish between FEASIBLE_POINT and
    # INFEASIBILITY_CERTIFICATE when querying VariablePrimal and ConstraintDual.
    want_infeasibility_certificates::Bool
    unbounded_ray::Union{Vector{Float64},Nothing}
    infeasibility_cert::Union{Vector{Float64},Nothing}

    # Callback fields.
    has_generic_callback::Bool
    callback_state::_CallbackState
    lazy_callback::Union{Nothing,Function}
    user_cut_callback::Union{Nothing,Function}
    heuristic_callback::Union{Nothing,Function}

    function Optimizer(;
        want_infeasibility_certificates::Bool = true,
        method::MethodEnum = SIMPLEX,
    )
        model = new()
        model.inner = glp_create_prob()
        model.method = method
        model.want_infeasibility_certificates = want_infeasibility_certificates
        model.interior_param = glp_iptcp()
        glp_init_iptcp(model.interior_param)
        model.intopt_param = glp_iocp()
        glp_init_iocp(model.intopt_param)
        model.simplex_param = glp_smcp()
        glp_init_smcp(model.simplex_param)
        MOI.set(model, MOI.RawOptimizerAttribute("msg_lev"), GLP_MSG_ERR)
        model.silent = false
        model.variable_info =
            CleverDicts.CleverDict{MOI.VariableIndex,_VariableInfo}(
                _HASH,
                _INVERSE_HASH_V,
            )
        model.affine_constraint_info =
            CleverDicts.CleverDict{_ConstraintKey,_ConstraintInfo}(
                _HASH,
                _INVERSE_HASH_C,
            )
        MOI.empty!(model)
        finalizer(model) do m
            return glp_delete_prob(m)
        end
        return model
    end
end

Base.cconvert(::Type{Ptr{glp_prob}}, m::Optimizer) = m
Base.unsafe_convert(::Type{Ptr{glp_prob}}, m::Optimizer) = m.inner

mutable struct CallbackData
    model::Optimizer
    callback_function::Function
    tree::Ptr{Cvoid}
    exception::Union{Nothing,Exception}
end

Base.broadcastable(x::CallbackData) = Ref(x)

# Dummy callback function for internal use only. Responsible for updating the
# objective bound, saving the mip gap, and calling the user's callback.
#
# !!! Very Important Note
#
# If Julia throws an exception from within the callback, the GLPK model does not
# gracefully exit! Instead, it throws a `glp_delete_prob: operation not
# supported` error when Julia tries to finalize `prob`. This is very annoying to
# debug.
#
# As a work-around, we catch all Julia exceptions with a try-catch, terminate
# the callback with `ios_terminate`, store the exception in `cb_data.exception`,
# and then re-throw it once we have gracefully exited from the callback.
#
# See also: the note in `_solve_mip_problem`.

function _internal_callback(tree::Ptr{Cvoid}, info::Ptr{Cvoid})
    cb_data = unsafe_pointer_to_objref(info)::CallbackData
    node = glp_ios_best_node(tree)
    if node != 0
        cb_data.model.objective_bound = glp_ios_node_bound(tree, node)
        cb_data.model.relative_gap = glp_ios_mip_gap(tree)
    end
    try
        cb_data.tree = tree
        cb_data.callback_function(cb_data)
    catch ex
        glp_ios_terminate(tree)
        cb_data.exception = ex
    end
    return Cint(0)
end

function _set_callback(model::Optimizer, callback_function::Function)
    c_callback = @cfunction(_internal_callback, Cint, (Ptr{Cvoid}, Ptr{Cvoid}))
    model.callback_data =
        CallbackData(model, callback_function, C_NULL, nothing)
    model.intopt_param.cb_func = c_callback
    model.intopt_param.cb_info = pointer_from_objref(model.callback_data)
    return
end

Base.show(io::IO, ::Optimizer) = print(io, "A GLPK model")

function MOI.empty!(model::Optimizer)
    glp_erase_prob(model)
    model.solver_status = GLP_UNDEF
    model.last_solved_by_mip = false
    model.num_binaries = 0
    model.num_integers = 0
    model.objective_bound = NaN
    model.relative_gap = NaN
    model.solve_time = NaN
    model.is_objective_set = false
    model.objective_sense = nothing
    model.optimize_not_called = true
    empty!(model.variable_info)
    empty!(model.affine_constraint_info)
    model.name_to_variable = nothing
    model.name_to_constraint_index = nothing
    model.unbounded_ray = nothing
    model.infeasibility_cert = nothing
    model.has_generic_callback = false
    model.callback_state = _CB_NONE
    model.lazy_callback = nothing
    model.user_cut_callback = nothing
    model.heuristic_callback = nothing
    _set_callback(model, cb_data -> nothing)
    return
end

function MOI.is_empty(model::Optimizer)
    return !model.is_objective_set &&
           model.objective_sense === nothing &&
           isempty(model.variable_info) &&
           isempty(model.affine_constraint_info) &&
           model.name_to_variable === nothing &&
           model.name_to_constraint_index === nothing &&
           model.unbounded_ray === nothing &&
           model.infeasibility_cert === nothing &&
           !model.has_generic_callback &&
           model.callback_state == _CB_NONE &&
           model.lazy_callback === nothing &&
           model.user_cut_callback === nothing &&
           model.heuristic_callback === nothing
end

MOI.get(::Optimizer, ::MOI.SolverName) = "GLPK"

MOI.get(::Optimizer, ::MOI.SolverVersion) = unsafe_string(glp_version())

###
### MOI.RawOptimizerAttribute
###

MOI.supports(::Optimizer, ::MOI.RawOptimizerAttribute) = true

"""
    _set_parameter(param_store, key::Symbol, value)::Bool

Set the field name `key` in a `param_store` type (that is one of `InteriorParam`,
`IntoptParam`, or `SimplexParam`) to `value`.

Returns a `Bool` indicating if the parameter was set.
"""
function _set_parameter(param_store, key::Symbol, value)
    if key == :cb_func || key == :cb_info
        error(
            "Invalid option: $(string(key)). Use the MOI attribute " *
            "`GLPK.CallbackFunction` instead.",
        )
    elseif key in fieldnames(typeof(param_store))
        field_type = typeof(getfield(param_store, key))
        setfield!(param_store, key, convert(field_type, value))
        return true
    end
    return false
end

function MOI.set(model::Optimizer, param::MOI.RawOptimizerAttribute, value)
    key = Symbol(param.name)
    set_interior = _set_parameter(model.interior_param, key, value)
    set_intopt = _set_parameter(model.intopt_param, key, value)
    set_simplex = _set_parameter(model.simplex_param, key, value)
    if !set_interior && !set_intopt && !set_simplex
        throw(MOI.UnsupportedAttribute(param))
    end
    return
end

function MOI.get(model::Optimizer, param::MOI.RawOptimizerAttribute)
    name = Symbol(param.name)
    if (model.method == SIMPLEX || model.method == EXACT) &&
       name in fieldnames(glp_smcp)
        return getfield(model.simplex_param, name)
    elseif model.method == INTERIOR && name in fieldnames(glp_iptcp)
        return getfield(model.interior_param, name)
    elseif name in fieldnames(glp_iocp)
        return getfield(model.intopt_param, name)
    end
    return throw(MOI.UnsupportedAttribute(param))
end

###
### MOI.TimeLimitSec
###

MOI.supports(::Optimizer, ::MOI.TimeLimitSec) = true

_limit_sec_to_ms(::Nothing) = typemax(Int32)
# Project the timelimit onto [0, typemax(Int32)] to avoid nasty segfaults.
_limit_sec_to_ms(x::Real) = ceil(Int32, max(0, min(typemax(Int32), 1_000 * x)))

function MOI.set(
    model::Optimizer,
    ::MOI.TimeLimitSec,
    limit::Union{Nothing,Real},
)
    MOI.set(model, MOI.RawOptimizerAttribute("tm_lim"), _limit_sec_to_ms(limit))
    return
end

function MOI.get(model::Optimizer, ::MOI.TimeLimitSec)
    value = MOI.get(model, MOI.RawOptimizerAttribute("tm_lim"))
    # convert internal ms to sec
    return value == typemax(Int32) ? nothing : value / 1_000
end

MOI.supports_incremental_interface(::Optimizer) = true

function MOI.get(model::Optimizer, ::MOI.ListOfVariableAttributesSet)
    for (_, v) in model.variable_info
        if !isempty(v.name)
            return MOI.AbstractVariableAttribute[MOI.VariableName()]
        end
    end
    return MOI.AbstractVariableAttribute[]
end

function MOI.get(model::Optimizer, ::MOI.ListOfModelAttributesSet)
    attributes = MOI.AbstractModelAttribute[]
    if model.is_objective_set
        F = MOI.get(model, MOI.ObjectiveFunctionType())
        push!(attributes, MOI.ObjectiveFunction{F}())
    end
    if model.objective_sense !== nothing
        push!(attributes, MOI.ObjectiveSense())
    end
    if MOI.get(model, MOI.Name()) != ""
        push!(attributes, MOI.Name())
    end
    return attributes
end

function MOI.get(model::Optimizer, ::MOI.ListOfConstraintAttributesSet)
    for (_, v) in model.affine_constraint_info
        if !isempty(v.name)
            return MOI.AbstractConstraintAttribute[MOI.ConstraintName()]
        end
    end
    return MOI.AbstractConstraintAttribute[]
end

function MOI.get(
    ::Optimizer,
    ::MOI.ListOfConstraintAttributesSet{
        MOI.VariableIndex,
        <:MOI.AbstractScalarSet,
    },
)
    return MOI.AbstractConstraintAttribute[]
end

function _indices_and_coefficients(
    indices::Vector{Cint},
    coefficients::Vector{Float64},
    model::Optimizer,
    f::MOI.ScalarAffineFunction{Float64},
)
    i = 1
    for term in f.terms
        indices[i] = Cint(column(model, term.variable))
        coefficients[i] = term.coefficient
        i += 1
    end
    return indices, coefficients
end

function _indices_and_coefficients(
    model::Optimizer,
    f::MOI.ScalarAffineFunction{Float64},
)
    f_canon = MOI.Utilities.canonical(f)
    nnz = length(f_canon.terms)
    indices, coefficients = zeros(Cint, nnz), zeros(Cdouble, nnz)
    _indices_and_coefficients(indices, coefficients, model, f_canon)
    return indices, coefficients
end

_sense_and_rhs(s::MOI.LessThan{Float64}) = (Cchar('L'), s.upper)
_sense_and_rhs(s::MOI.GreaterThan{Float64}) = (Cchar('G'), s.lower)
_sense_and_rhs(s::MOI.EqualTo{Float64}) = (Cchar('E'), s.value)

###
### Variables
###

# Short-cuts to return the _VariableInfo associated with an index.
function _info(model::Optimizer, key::MOI.VariableIndex)
    if haskey(model.variable_info, key)
        return model.variable_info[key]
    end
    return throw(MOI.InvalidIndex(key))
end

column(model, x::MOI.VariableIndex) = _info(model, x).column

function MOI.add_variable(model::Optimizer)
    # Initialize `_VariableInfo` with a dummy `VariableIndex` and a column,
    # because we need `add_item` to tell us what the `VariableIndex` is.
    index = CleverDicts.add_item(
        model.variable_info,
        _VariableInfo(MOI.VariableIndex(0), 0),
    )
    info = _info(model, index)
    # Now, set `.index` and `.column`.
    info.index = index
    info.column = length(model.variable_info)
    glp_add_cols(model, 1)
    glp_set_col_bnds(model, info.column, GLP_FR, 0.0, 0.0)
    return index
end

function MOI.add_variables(model::Optimizer, N::Int)
    indices = Vector{MOI.VariableIndex}(undef, N)
    num_variables = length(model.variable_info)
    glp_add_cols(model, N)
    for i in 1:N
        # Initialize `_VariableInfo` with a dummy `VariableIndex` and a column,
        # because we need `add_item` to tell us what the `VariableIndex` is.
        index = CleverDicts.add_item(
            model.variable_info,
            _VariableInfo(MOI.VariableIndex(0), 0),
        )
        info = _info(model, index)
        # Now, set `.index` and `.column`.
        info.index = index
        info.column = num_variables + i
        glp_set_col_bnds(model, info.column, GLP_FR, 0.0, 0.0)
        indices[i] = index
    end
    return indices
end

function MOI.is_valid(model::Optimizer, v::MOI.VariableIndex)
    return haskey(model.variable_info, v)
end

function MOI.delete(model::Optimizer, v::MOI.VariableIndex)
    info = _info(model, v)
    glp_std_basis(model)
    c = Cint[info.column]
    glp_del_cols(model, 1, offset(c))
    delete!(model.variable_info, v)
    for other_info in values(model.variable_info)
        if other_info.column > info.column
            other_info.column -= 1
        end
    end
    model.name_to_variable = nothing
    model.name_to_constraint_index = nothing
    return
end

function MOI.get(model::Optimizer, ::Type{MOI.VariableIndex}, name::String)
    if model.name_to_variable === nothing
        _rebuild_name_to_variable(model)
    end
    if haskey(model.name_to_variable, name)
        variable = model.name_to_variable[name]
        if variable === nothing
            error("Duplicate name detected: $(name)")
        end
        return variable
    end
    return
end

function _rebuild_name_to_variable(model::Optimizer)
    model.name_to_variable = Dict{String,Union{Nothing,MOI.VariableIndex}}()
    for (index, info) in model.variable_info
        if isempty(info.name)
            continue
        elseif haskey(model.name_to_variable, info.name)
            model.name_to_variable[info.name] = nothing
        else
            model.name_to_variable[info.name] = index
        end
    end
    return
end

MOI.supports(::Optimizer, ::MOI.VariableName, ::Type{MOI.VariableIndex}) = true

function MOI.get(model::Optimizer, ::MOI.VariableName, v::MOI.VariableIndex)
    return _info(model, v).name
end

function MOI.set(
    model::Optimizer,
    ::MOI.VariableName,
    v::MOI.VariableIndex,
    name::String,
)
    info = _info(model, v)
    info.name = name
    if !isempty(name) && isascii(name)
        # Note: GLPK errors if we try to set non-ascii column names.
        glp_set_col_name(model, info.column, name)
    end
    model.name_to_variable = nothing
    return
end

###
### Objectives
###

MOI.supports(::Optimizer, ::MOI.ObjectiveSense) = true

function MOI.set(
    model::Optimizer,
    ::MOI.ObjectiveSense,
    sense::MOI.OptimizationSense,
)
    if sense == MOI.MIN_SENSE
        glp_set_obj_dir(model, GLP_MIN)
    elseif sense == MOI.MAX_SENSE
        glp_set_obj_dir(model, GLP_MAX)
    else
        @assert sense == MOI.FEASIBILITY_SENSE
        glp_set_obj_dir(model, GLP_MIN)
        for col in 0:glp_get_num_cols(model)
            glp_set_obj_coef(model, col, 0.0)
        end
    end
    model.objective_sense = sense
    return
end

function MOI.get(model::Optimizer, ::MOI.ObjectiveSense)
    return something(model.objective_sense, MOI.FEASIBILITY_SENSE)
end

function MOI.supports(
    ::Optimizer,
    ::MOI.ObjectiveFunction{MOI.ScalarAffineFunction{Float64}},
)
    return true
end

function MOI.get(model::Optimizer, ::MOI.ObjectiveFunction{F}) where {F}
    obj = MOI.get(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{Float64}}(),
    )
    return convert(F, obj)
end

function MOI.set(
    model::Optimizer,
    ::MOI.ObjectiveFunction{F},
    f::F,
) where {F<:MOI.ScalarAffineFunction{Float64}}
    num_vars = length(model.variable_info)
    obj = zeros(Float64, num_vars)
    for term in f.terms
        col = column(model, term.variable)
        obj[col] += term.coefficient
    end
    for (col, coef) in enumerate(obj)
        glp_set_obj_coef(model, col, coef)
    end
    glp_set_obj_coef(model, 0, f.constant)
    model.is_objective_set = true
    return
end

function MOI.get(
    model::Optimizer,
    ::MOI.ObjectiveFunction{MOI.ScalarAffineFunction{Float64}},
)
    dest = zeros(length(model.variable_info))
    for col in 1:length(dest)
        dest[col] = glp_get_obj_coef(model, col)
    end
    terms = MOI.ScalarAffineTerm{Float64}[]
    for (index, info) in model.variable_info
        coefficient = dest[info.column]
        if iszero(coefficient)
            continue
        end
        push!(terms, MOI.ScalarAffineTerm(coefficient, index))
    end
    constant = glp_get_obj_coef(model, 0)
    return MOI.ScalarAffineFunction(terms, constant)
end

function MOI.modify(
    model::Optimizer,
    ::MOI.ObjectiveFunction{MOI.ScalarAffineFunction{Float64}},
    chg::MOI.ScalarConstantChange{Float64},
)
    glp_set_obj_coef(model, 0, chg.new_constant)
    model.is_objective_set = true
    return
end

function MOI.modify(
    model::Optimizer,
    ::MOI.ObjectiveFunction{MOI.ScalarAffineFunction{Float64}},
    chg::MOI.ScalarCoefficientChange{Float64},
)
    glp_set_obj_coef(model, column(model, chg.variable), chg.new_coefficient)
    model.is_objective_set = true
    return
end

##
##  VariableIndex-in-Set constraints.
##

function _info(
    model::Optimizer,
    c::MOI.ConstraintIndex{MOI.VariableIndex,<:Any},
)
    var_index = MOI.VariableIndex(c.value)
    if haskey(model.variable_info, var_index)
        return _info(model, var_index)
    end
    return throw(MOI.InvalidIndex(c))
end

function column(model, c::MOI.ConstraintIndex{MOI.VariableIndex,<:Any})
    return _info(model, c).column
end

function MOI.is_valid(
    model::Optimizer,
    c::MOI.ConstraintIndex{MOI.VariableIndex,MOI.LessThan{Float64}},
)
    if !haskey(model.variable_info, MOI.VariableIndex(c.value))
        return false
    end
    info = _info(model, c)
    return info.bound == _LESS_THAN || info.bound == _LESS_AND_GREATER_THAN
end

function MOI.is_valid(
    model::Optimizer,
    c::MOI.ConstraintIndex{MOI.VariableIndex,MOI.GreaterThan{Float64}},
)
    if !haskey(model.variable_info, MOI.VariableIndex(c.value))
        return false
    end
    info = _info(model, c)
    return info.bound == _GREATER_THAN || info.bound == _LESS_AND_GREATER_THAN
end

function MOI.is_valid(
    model::Optimizer,
    c::MOI.ConstraintIndex{MOI.VariableIndex,MOI.Interval{Float64}},
)
    return haskey(model.variable_info, MOI.VariableIndex(c.value)) &&
           _info(model, c).bound == _INTERVAL
end

function MOI.is_valid(
    model::Optimizer,
    c::MOI.ConstraintIndex{MOI.VariableIndex,MOI.EqualTo{Float64}},
)
    return haskey(model.variable_info, MOI.VariableIndex(c.value)) &&
           _info(model, c).bound == _EQUAL_TO
end

function MOI.is_valid(
    model::Optimizer,
    c::MOI.ConstraintIndex{MOI.VariableIndex,MOI.ZeroOne},
)
    return haskey(model.variable_info, MOI.VariableIndex(c.value)) &&
           _info(model, c).type == _BINARY
end

function MOI.is_valid(
    model::Optimizer,
    c::MOI.ConstraintIndex{MOI.VariableIndex,MOI.Integer},
)
    return haskey(model.variable_info, MOI.VariableIndex(c.value)) &&
           _info(model, c).type == _INTEGER
end

function MOI.get(
    model::Optimizer,
    ::MOI.ConstraintFunction,
    c::MOI.ConstraintIndex{MOI.VariableIndex,<:Any},
)
    MOI.throw_if_not_valid(model, c)
    return MOI.VariableIndex(c.value)
end

function MOI.set(
    ::Optimizer,
    ::MOI.ConstraintFunction,
    c::MOI.ConstraintIndex{MOI.VariableIndex,<:Any},
    ::MOI.VariableIndex,
)
    return throw(MOI.SettingVariableIndexNotAllowed())
end

_bounds(s::MOI.GreaterThan{Float64}) = (s.lower, nothing)
_bounds(s::MOI.LessThan{Float64}) = (nothing, s.upper)
_bounds(s::MOI.EqualTo{Float64}) = (s.value, s.value)
_bounds(s::MOI.Interval{Float64}) = (s.lower, s.upper)

function _throw_if_existing_lower(
    bound::_VariableBound,
    ::_VariableType,
    ::Type{S},
    variable::MOI.VariableIndex,
) where {S<:MOI.AbstractSet}
    if bound == _LESS_AND_GREATER_THAN || bound == _GREATER_THAN
        throw(MOI.LowerBoundAlreadySet{MOI.GreaterThan{Float64},S}(variable))
    elseif bound == _INTERVAL
        throw(MOI.LowerBoundAlreadySet{MOI.Interval{Float64},S}(variable))
    elseif bound == _EQUAL_TO
        throw(MOI.LowerBoundAlreadySet{MOI.EqualTo{Float64},S}(variable))
    end
    return
end

function _throw_if_existing_upper(
    bound::_VariableBound,
    ::_VariableType,
    ::Type{S},
    variable::MOI.VariableIndex,
) where {S<:MOI.AbstractSet}
    if bound == _LESS_AND_GREATER_THAN || bound == _LESS_THAN
        throw(MOI.UpperBoundAlreadySet{MOI.LessThan{Float64},S}(variable))
    elseif bound == _INTERVAL
        throw(MOI.UpperBoundAlreadySet{MOI.Interval{Float64},S}(variable))
    elseif bound == _EQUAL_TO
        throw(MOI.UpperBoundAlreadySet{MOI.EqualTo{Float64},S}(variable))
    end
    return
end

function MOI.supports_constraint(
    ::Optimizer,
    ::Type{MOI.VariableIndex},
    ::Type{
        <:Union{
            MOI.EqualTo{Float64},
            MOI.LessThan{Float64},
            MOI.GreaterThan{Float64},
            MOI.Interval{Float64},
            MOI.ZeroOne,
            MOI.Integer,
        },
    },
)
    return true
end

function MOI.add_constraint(
    model::Optimizer,
    f::MOI.VariableIndex,
    s::S,
) where {S<:_SCALAR_SETS}
    info = _info(model, f)
    if S <: MOI.LessThan{Float64}
        _throw_if_existing_upper(info.bound, info.type, S, f)
        info.bound =
            info.bound == _GREATER_THAN ? _LESS_AND_GREATER_THAN : _LESS_THAN
    elseif S <: MOI.GreaterThan{Float64}
        _throw_if_existing_lower(info.bound, info.type, S, f)
        info.bound =
            info.bound == _LESS_THAN ? _LESS_AND_GREATER_THAN : _GREATER_THAN
    elseif S <: MOI.EqualTo{Float64}
        _throw_if_existing_lower(info.bound, info.type, S, f)
        _throw_if_existing_upper(info.bound, info.type, S, f)
        info.bound = _EQUAL_TO
    else
        @assert S <: MOI.Interval{Float64}
        _throw_if_existing_lower(info.bound, info.type, S, f)
        _throw_if_existing_upper(info.bound, info.type, S, f)
        info.bound = _INTERVAL
    end
    index = MOI.ConstraintIndex{MOI.VariableIndex,typeof(s)}(f.value)
    MOI.set(model, MOI.ConstraintSet(), index, s)
    return index
end

function _get_glp_bound_type(lower, upper)
    if lower ≈ upper
        return GLP_FX
    elseif lower <= -GLP_DBL_MAX
        return upper >= GLP_DBL_MAX ? GLP_FR : GLP_UP
    else
        return upper >= GLP_DBL_MAX ? GLP_LO : GLP_DB
    end
end

function _set_variable_bound(
    model::Optimizer,
    column::Int,
    lower::Union{Nothing,Float64},
    upper::Union{Nothing,Float64},
)
    if lower === nothing
        lower = glp_get_col_lb(model, column)
    end
    if upper === nothing
        upper = glp_get_col_ub(model, column)
    end
    bound_type = _get_glp_bound_type(lower, upper)
    glp_set_col_bnds(model, column, bound_type, lower, upper)
    return
end

function MOI.delete(
    model::Optimizer,
    c::MOI.ConstraintIndex{MOI.VariableIndex,MOI.LessThan{Float64}},
)
    MOI.throw_if_not_valid(model, c)
    info = _info(model, c)
    _set_variable_bound(model, info.column, nothing, Inf)
    if info.bound == _LESS_AND_GREATER_THAN
        info.bound = _GREATER_THAN
    else
        info.bound = _NONE
    end
    model.name_to_constraint_index = nothing
    return
end

function MOI.delete(
    model::Optimizer,
    c::MOI.ConstraintIndex{MOI.VariableIndex,MOI.GreaterThan{Float64}},
)
    MOI.throw_if_not_valid(model, c)
    info = _info(model, c)
    _set_variable_bound(model, info.column, -Inf, nothing)
    info.bound = info.bound == _LESS_AND_GREATER_THAN ? _LESS_THAN : _NONE
    model.name_to_constraint_index = nothing
    return
end

function MOI.delete(
    model::Optimizer,
    c::MOI.ConstraintIndex{MOI.VariableIndex,MOI.Interval{Float64}},
)
    MOI.throw_if_not_valid(model, c)
    info = _info(model, c)
    _set_variable_bound(model, info.column, -Inf, Inf)
    info.bound = _NONE
    model.name_to_constraint_index = nothing
    return
end

function MOI.delete(
    model::Optimizer,
    c::MOI.ConstraintIndex{MOI.VariableIndex,MOI.EqualTo{Float64}},
)
    MOI.throw_if_not_valid(model, c)
    info = _info(model, c)
    _set_variable_bound(model, info.column, -Inf, Inf)
    info.bound = _NONE
    model.name_to_constraint_index = nothing
    return
end

function MOI.get(
    model::Optimizer,
    ::MOI.ConstraintSet,
    c::MOI.ConstraintIndex{MOI.VariableIndex,MOI.GreaterThan{Float64}},
)
    MOI.throw_if_not_valid(model, c)
    lower = glp_get_col_lb(model, column(model, c))
    return MOI.GreaterThan(lower)
end

function MOI.get(
    model::Optimizer,
    ::MOI.ConstraintSet,
    c::MOI.ConstraintIndex{MOI.VariableIndex,MOI.LessThan{Float64}},
)
    MOI.throw_if_not_valid(model, c)
    upper = glp_get_col_ub(model, column(model, c))
    return MOI.LessThan(upper)
end

function MOI.get(
    model::Optimizer,
    ::MOI.ConstraintSet,
    c::MOI.ConstraintIndex{MOI.VariableIndex,MOI.EqualTo{Float64}},
)
    MOI.throw_if_not_valid(model, c)
    lower = glp_get_col_lb(model, column(model, c))
    return MOI.EqualTo(lower)
end

function MOI.get(
    model::Optimizer,
    ::MOI.ConstraintSet,
    c::MOI.ConstraintIndex{MOI.VariableIndex,MOI.Interval{Float64}},
)
    MOI.throw_if_not_valid(model, c)
    col = column(model, c)
    lower = glp_get_col_lb(model, col)
    upper = glp_get_col_ub(model, col)
    return MOI.Interval(lower, upper)
end

function MOI.set(
    model::Optimizer,
    ::MOI.ConstraintSet,
    c::MOI.ConstraintIndex{MOI.VariableIndex,S},
    s::S,
) where {S<:_SCALAR_SETS}
    MOI.throw_if_not_valid(model, c)
    lower, upper = _bounds(s)
    _set_variable_bound(model, column(model, c), lower, upper)
    return
end

function MOI.add_constraint(
    model::Optimizer,
    f::MOI.VariableIndex,
    ::MOI.ZeroOne,
)
    info = _info(model, f)
    # See https://github.com/JuliaOpt/GLPKMathProgInterface.jl/pull/15
    # for why this is necesary. GLPK interacts weirdly with binary variables and
    # bound modification. So let's set binary variables as "Integer" with [0,1]
    # bounds that we enforce just before solve.
    glp_set_col_kind(model, info.column, GLP_IV)
    info.type = _BINARY
    model.num_binaries += 1
    return MOI.ConstraintIndex{MOI.VariableIndex,MOI.ZeroOne}(f.value)
end

function MOI.delete(
    model::Optimizer,
    c::MOI.ConstraintIndex{MOI.VariableIndex,MOI.ZeroOne},
)
    MOI.throw_if_not_valid(model, c)
    info = _info(model, c)
    glp_set_col_kind(model, info.column, GLP_CV)
    info.type = _CONTINUOUS
    model.num_binaries -= 1
    model.name_to_constraint_index = nothing
    return
end

function MOI.get(
    model::Optimizer,
    ::MOI.ConstraintSet,
    c::MOI.ConstraintIndex{MOI.VariableIndex,MOI.ZeroOne},
)
    MOI.throw_if_not_valid(model, c)
    return MOI.ZeroOne()
end

function MOI.add_constraint(
    model::Optimizer,
    f::MOI.VariableIndex,
    ::MOI.Integer,
)
    info = _info(model, f)
    glp_set_col_kind(model, info.column, GLP_IV)
    info.type = _INTEGER
    model.num_integers += 1
    return MOI.ConstraintIndex{MOI.VariableIndex,MOI.Integer}(f.value)
end

function MOI.delete(
    model::Optimizer,
    c::MOI.ConstraintIndex{MOI.VariableIndex,MOI.Integer},
)
    MOI.throw_if_not_valid(model, c)
    info = _info(model, c)
    glp_set_col_kind(model, info.column, GLP_CV)
    info.type = _CONTINUOUS
    model.num_integers -= 1
    model.name_to_constraint_index = nothing
    return
end

function MOI.get(
    model::Optimizer,
    ::MOI.ConstraintSet,
    c::MOI.ConstraintIndex{MOI.VariableIndex,MOI.Integer},
)
    MOI.throw_if_not_valid(model, c)
    return MOI.Integer()
end

###
### ScalarAffineFunction-in-Set
###

function _info(
    model::Optimizer,
    c::MOI.ConstraintIndex{MOI.ScalarAffineFunction{Float64}},
)
    key = _ConstraintKey(c.value)
    if !haskey(model.affine_constraint_info, key)
        return throw(MOI.InvalidIndex(c))
    end
    return model.affine_constraint_info[key]
end

function MOI.is_valid(
    model::Optimizer,
    c::MOI.ConstraintIndex{MOI.ScalarAffineFunction{Float64},S},
) where {S}
    key = _ConstraintKey(c.value)
    if haskey(model.affine_constraint_info, key)
        info = model.affine_constraint_info[key]
        return typeof(info.set) == S
    end
    return false
end

"""
    _add_affine_constraint(
        problem::Union{Optimizer, Ptr{glp_prob}},
        columns::Vector{Cint},
        coefficients::Vector{Float64},
        sense::Cchar,
        rhs::Float64,
    )

Helper function to add a row to the problem. Sense must be one of `'E'`
(ax == b), `'G'` (ax >= b), `'L'` (ax <= b).
"""
function _add_affine_constraint(
    problem::Union{Optimizer,Ptr{glp_prob}},
    indices::Vector{Cint},
    coefficients::Vector{Float64},
    sense::Cchar,
    rhs::Float64,
)
    if length(indices) != length(coefficients)
        error("columns and coefficients have different lengths.")
    end
    glp_add_rows(problem, 1)
    row = glp_get_num_rows(problem)
    glp_set_mat_row(
        problem,
        row,
        length(indices),
        offset(indices),
        offset(coefficients),
    )
    # According to http://most.ccib.rutgers.edu/glpk.pdf page 22, the `lb`
    # argument is ignored for constraint types with no lower bound (GLP_UP) and
    # the `ub` argument is ignored for constraint types with no upper bound
    # (GLP_LO). We pass ±GLP_DBL_MAX for those unused bounds since (a) we have
    # to pass something, and (b) it is consistent with the other usages of
    # ±GLP_DBL_MAX to represent infinite bounds in the rest of the GLPK
    # interface.
    if sense == Cchar('E')
        glp_set_row_bnds(problem, row, GLP_FX, rhs, rhs)
    elseif sense == Cchar('G')
        glp_set_row_bnds(problem, row, GLP_LO, rhs, GLP_DBL_MAX)
    else
        @assert sense == Cchar('L')
        glp_set_row_bnds(problem, row, GLP_UP, -GLP_DBL_MAX, rhs)
    end
    return
end

function MOI.supports_constraint(
    ::Optimizer,
    ::Type{MOI.ScalarAffineFunction{Float64}},
    ::Type{
        <:Union{
            MOI.EqualTo{Float64},
            MOI.LessThan{Float64},
            MOI.GreaterThan{Float64},
        },
    },
)
    return true
end

function MOI.add_constraint(
    model::Optimizer,
    f::MOI.ScalarAffineFunction{Float64},
    s::Union{
        MOI.GreaterThan{Float64},
        MOI.LessThan{Float64},
        MOI.EqualTo{Float64},
    },
)
    F, S = typeof(f), typeof(s)
    if !iszero(f.constant)
        throw(MOI.ScalarFunctionConstantNotZero{Float64,F,S}(f.constant))
    end
    key = CleverDicts.add_item(model.affine_constraint_info, _ConstraintInfo(s))
    model.affine_constraint_info[key].row = length(model.affine_constraint_info)
    indices, coefficients = _indices_and_coefficients(model, f)
    sense, rhs = _sense_and_rhs(s)
    _add_affine_constraint(model, indices, coefficients, sense, rhs)
    return MOI.ConstraintIndex{F,S}(key.value)
end

function MOI.delete(
    model::Optimizer,
    c::MOI.ConstraintIndex{MOI.ScalarAffineFunction{Float64},<:Any},
)
    row = _info(model, c).row
    glp_std_basis(model)
    x = Cint[row]
    glp_del_rows(model, 1, offset(x))
    for info in values(model.affine_constraint_info)
        if info.row > row
            info.row -= 1
        end
    end
    key = _ConstraintKey(c.value)
    delete!(model.affine_constraint_info, key)
    model.name_to_constraint_index = nothing
    return
end

function MOI.get(
    model::Optimizer,
    ::MOI.ConstraintSet,
    c::MOI.ConstraintIndex{MOI.ScalarAffineFunction{Float64},S},
) where {S}
    row = _info(model, c).row
    sense = glp_get_row_type(model, row)
    if sense == GLP_LO || sense == GLP_FX || sense == GLP_DB
        return S(glp_get_row_lb(model, row))
    else
        return S(glp_get_row_ub(model, row))
    end
end

function MOI.set(
    model::Optimizer,
    ::MOI.ConstraintSet,
    c::MOI.ConstraintIndex{MOI.ScalarAffineFunction{Float64},S},
    s::S,
) where {S<:Union{MOI.LessThan,MOI.GreaterThan,MOI.EqualTo}}
    row = _info(model, c).row
    if S <: MOI.LessThan
        glp_set_row_bnds(model, row, GLP_UP, -GLP_DBL_MAX, s.upper)
    elseif S <: MOI.GreaterThan
        glp_set_row_bnds(model, row, GLP_LO, s.lower, GLP_DBL_MAX)
    else
        @assert S <: MOI.EqualTo
        glp_set_row_bnds(model, row, GLP_FX, s.value, s.value)
    end
    return
end

function MOI.get(
    model::Optimizer,
    ::MOI.ConstraintFunction,
    c::MOI.ConstraintIndex{MOI.ScalarAffineFunction{Float64},<:Any},
)
    row = Cint(_info(model, c).row)
    nnz = glp_get_mat_row(model, row, C_NULL, C_NULL)
    indices, coefficients = zeros(Cint, nnz), zeros(Cdouble, nnz)
    glp_get_mat_row(model, row, offset(indices), offset(coefficients))
    terms = MOI.ScalarAffineTerm{Float64}[]
    for (col, val) in zip(indices, coefficients)
        if iszero(val)
            continue
        end
        push!(
            terms,
            MOI.ScalarAffineTerm(
                val,
                model.variable_info[CleverDicts.LinearIndex(col)].index,
            ),
        )
    end
    return MOI.ScalarAffineFunction(terms, 0.0)
end

function MOI.supports(
    ::Optimizer,
    ::MOI.ConstraintName,
    ::Type{<:MOI.ConstraintIndex{MOI.ScalarAffineFunction{Float64}}},
)
    return true
end

function MOI.get(
    model::Optimizer,
    ::MOI.ConstraintName,
    c::MOI.ConstraintIndex{MOI.ScalarAffineFunction{Float64},<:Any},
)
    return _info(model, c).name
end

function MOI.set(
    model::Optimizer,
    ::MOI.ConstraintName,
    c::MOI.ConstraintIndex{MOI.ScalarAffineFunction{Float64},<:Any},
    name::String,
)
    info = _info(model, c)
    info.name = name
    if !isempty(name) && isascii(name)
        # Note: GLPK errors if we try to set non-ascii row names.
        glp_set_row_name(model, info.row, name)
    end
    model.name_to_constraint_index = nothing
    return
end

function MOI.get(model::Optimizer, ::Type{MOI.ConstraintIndex}, name::String)
    if model.name_to_constraint_index === nothing
        _rebuild_name_to_constraint_index(model)
    end
    if haskey(model.name_to_constraint_index, name)
        constr = model.name_to_constraint_index[name]
        if constr === nothing
            error("Duplicate constraint name detected: $(name)")
        end
        return constr
    end
    return
end

function MOI.get(
    model::Optimizer,
    ::Type{MOI.ConstraintIndex{F,S}},
    name::String,
) where {F,S}
    index = MOI.get(model, MOI.ConstraintIndex, name)
    if typeof(index) == MOI.ConstraintIndex{F,S}
        return index::MOI.ConstraintIndex{F,S}
    end
    return
end

function _rebuild_name_to_constraint_index(model::Optimizer)
    model.name_to_constraint_index =
        Dict{String,Union{Nothing,MOI.ConstraintIndex}}()
    for (key, info) in model.affine_constraint_info
        if isempty(info.name)
            continue
        end
        _set_name_to_constraint_index(
            model,
            info.name,
            MOI.ConstraintIndex{
                MOI.ScalarAffineFunction{Float64},
                typeof(info.set),
            }(
                key.value,
            ),
        )
    end
    return
end

function _set_name_to_constraint_index(
    model::Optimizer,
    name::String,
    index::MOI.ConstraintIndex,
)
    if haskey(model.name_to_constraint_index, name)
        model.name_to_constraint_index[name] = nothing
    else
        model.name_to_constraint_index[name] = index
    end
    return
end

###
### Optimize methods.
###

function _solve_linear_problem(model::Optimizer)
    model.last_solved_by_mip = false
    if model.method == SIMPLEX
        model.solver_status = glp_simplex(model, model.simplex_param)
    elseif model.method == EXACT
        model.solver_status = glp_exact(model, model.simplex_param)
    else
        @assert model.method == INTERIOR
        model.solver_status = glp_interior(model, model.interior_param)
    end
    return
end

"""
    _round_bounds_to_integer(model)

GLPK does not allow integer variables with fractional bounds. Therefore, we
round the bounds of binary and integer variables to integer values prior to
solving.

Returns a tuple `(column, lower, upper)` for the bounds that need to be reset.
"""
function _round_bounds_to_integer(model::Optimizer)
    bounds_to_reset = Tuple{Int,Float64,Float64}[]
    for (key, info) in model.variable_info
        if info.type == _BINARY || info.type == _INTEGER
            lb = glp_get_col_lb(model, info.column)
            ub = glp_get_col_ub(model, info.column)
            new_lb = ceil(lb)
            new_ub = floor(ub)
            if info.type == _BINARY
                new_lb = max(0.0, new_lb)
                new_ub = min(1.0, new_ub)
            end
            if new_lb != lb || new_ub != ub
                push!(bounds_to_reset, (info.column, lb, ub))
                _set_variable_bound(model, info.column, new_lb, new_ub)
            end
        end
    end
    return bounds_to_reset
end

function _solve_mip_problem(model::Optimizer)
    bounds_to_reset = _round_bounds_to_integer(model)
    # Because we're muddling with the presolve in this function, cache the
    # original setting so that it can be reset.
    presolve_cache = model.intopt_param.presolve
    try
        # glp_intopt requires a starting basis for the LP relaxation. There are
        # two ways to get this. If presolve=GLP_ON, then the presolve will find
        # a basis. If presolve=GLP_OFF, then we should solve the problem via
        # glp_simplex first.
        if model.intopt_param.presolve == GLP_OFF
            glp_simplex(model, model.simplex_param)
            if glp_get_status(model) != GLP_OPT
                # We didn't find an optimal solution to the LP relaxation, so
                # let's turn presolve on and let intopt figure out what the
                # problem is.
                model.intopt_param.presolve = GLP_ON
            end
        end
        model.solver_status = glp_intopt(model, model.intopt_param)
        model.last_solved_by_mip = true
        # !!! Very Important Note
        #
        #  This next bit is _very_ important! See the note associated with
        #  set_callback.
        if model.callback_data.exception isa InterruptException
            model.solver_status = GLP_ESTOP
        elseif model.callback_data.exception !== nothing
            throw(model.callback_data.exception)
        end
    finally
        for (column, lower, upper) in bounds_to_reset
            _set_variable_bound(model, column, lower, upper)
        end
        model.intopt_param.presolve = presolve_cache
    end
    return
end

include("infeasibility_certificates.jl")

function _check_moi_callback_validity(model::Optimizer)
    has_moi_callback =
        model.lazy_callback !== nothing ||
        model.user_cut_callback !== nothing ||
        model.heuristic_callback !== nothing
    if has_moi_callback && model.has_generic_callback
        error(
            "Cannot use `GLPK.CallbackFunction` as well as " *
            "`MOI.AbstractCallbackFunction`.",
        )
    end
    return has_moi_callback
end

function MOI.optimize!(model::Optimizer)
    start_time = time()
    model.optimize_not_called = false
    model.infeasibility_cert = nothing
    model.unbounded_ray = nothing

    # Initialize callbacks if necessary.
    if _check_moi_callback_validity(model)
        MOI.set(model, CallbackFunction(), _default_moi_callback(model))
        model.has_generic_callback = false
    end

    if model.num_binaries > 0 || model.num_integers > 0
        _solve_mip_problem(model)
    else
        _solve_linear_problem(model)
    end
    if _certificates_potentially_available(model)
        (status, _) = _get_status(model)
        if status == MOI.DUAL_INFEASIBLE
            ray = zeros(glp_get_num_cols(model))
            if _get_unbounded_ray(model, ray)
                model.unbounded_ray = ray
            end
        elseif status == MOI.INFEASIBLE
            ray = zeros(glp_get_num_rows(model))
            if _get_infeasibility_ray(model, ray)
                model.infeasibility_cert = ray
            end
        end
    end
    model.solve_time = time() - start_time
    return
end

function _throw_if_optimize_in_progress(model::Optimizer, attr)
    if model.callback_state != _CB_NONE
        throw(MOI.OptimizeInProgress(attr))
    end
end

# GLPK has a complicated status reporting system because it can be solved via
# multiple different solution algorithms. Regardless of the algorithm, the
# return value is stored in `model.solver_status`.
#
# Note that the first status (`Int32(0)`) should map to a `SUCCESS` status,
# because it doesn't imply anything about the solution. If `solver_status` is
# `Int32(0)`, then a solution-specific status can be queried with `_get_status`.

function _raw_simplex_string(status::Int32)
    if status == GLP_EBADB
        return (
            MOI.INVALID_MODEL,
            "Unable to start the search, because the initial basis specified in the problem object is invalid—the number of basic (auxiliary and structural) variables is not the same as the number of rows in the problem object.",
        )
    elseif status == GLP_ESING
        return (
            MOI.NUMERICAL_ERROR,
            "Unable to start the search, because the basis matrix corresponding to the initial basis is singular within the working precision.",
        )
    elseif status == GLP_ECOND
        return (
            MOI.NUMERICAL_ERROR,
            "Unable to start the search, because the basis matrix corresponding to the initial basis is ill-conditioned, i.e. its condition number is too large.",
        )
    elseif status == GLP_EBOUND
        return (
            MOI.INVALID_MODEL,
            "Unable to start the search, because some double-bounded (auxiliary or structural) variables have incorrect bounds.",
        )
    elseif status == GLP_EFAIL
        return (
            MOI.NUMERICAL_ERROR,
            "The search was prematurely terminated due to the solver failure.",
        )
    elseif status == GLP_EOBJLL
        return (
            MOI.OBJECTIVE_LIMIT,
            "The search was prematurely terminated, because the objective function being maximized has reached its lower limit and continues decreasing (the dual simplex only).",
        )
    elseif status == GLP_EOBJUL
        return (
            MOI.OBJECTIVE_LIMIT,
            "The search was prematurely terminated, because the objective function being minimized has reached its upper limit and continues increasing (the dual simplex only).",
        )
    elseif status == GLP_EITLIM
        return (
            MOI.ITERATION_LIMIT,
            "The search was prematurely terminated, because the simplex iteration limit has been exceeded.",
        )
    elseif status == GLP_ETMLIM
        return (
            MOI.TIME_LIMIT,
            "The search was prematurely terminated, because the time limit has been exceeded.",
        )
    elseif status == GLP_ENOPFS
        return (
            MOI.INFEASIBLE,
            "The LP problem instance has no primal feasible solution (only if the LP presolver is used).",
        )
    else
        @assert status == GLP_ENODFS
        return (
            MOI.DUAL_INFEASIBLE,
            "The LP problem instance has no dual feasible solution (only if the LP presolver is used).",
        )
    end
end

function _raw_exact_string(status::Int32)
    if status == GLP_EBADB
        return (
            MOI.INVALID_MODEL,
            "Unable to start the search, because the initial basis specified in the problem object is invalid—the number of basic (auxiliary and structural) variables is not the same as the number of rows in the problem object.",
        )
    elseif status == GLP_ESING
        return (
            MOI.NUMERICAL_ERROR,
            "Unable to start the search, because the basis matrix corresponding to the initial basis is exactly singular.",
        )
    elseif status == GLP_EBOUND
        return (
            MOI.INVALID_MODEL,
            "Unable to start the search, because some double-bounded (auxiliary or structural) variables have incorrect bounds.",
        )
    elseif status == GLP_EFAIL
        (MOI.INVALID_MODEL, "The problem instance has no rows/columns.")
    elseif status == GLP_EITLIM
        return (
            MOI.ITERATION_LIMIT,
            "The search was prematurely terminated, because the simplex iteration limit has been exceeded.",
        )
    else
        @assert status == GLP_ETMLIM
        return (
            MOI.TIME_LIMIT,
            "The search was prematurely terminated, because the time limit has been exceeded.",
        )
    end
end

function _raw_interior_string(status::Int32)
    if status == GLP_EFAIL
        return (MOI.INVALID_MODEL, "The problem instance has no rows/columns.")
    elseif status == GLP_ENOCVG
        return (MOI.SLOW_PROGRESS, "Very slow convergence or divergence.")
    elseif status == GLP_EITLIM
        return (MOI.ITERATION_LIMIT, "Iteration limit exceeded.")
    else
        @assert status == GLP_EINSTAB
        return (
            MOI.NUMERICAL_ERROR,
            "Numerical instability on solving Newtonian system.",
        )
    end
end

function _raw_intopt_string(status::Int32)
    if status == GLP_EBOUND
        return (
            MOI.INVALID_MODEL,
            "Unable to start the search, because some double-bounded (auxiliary or structural) variables have incorrect bounds.",
        )
    elseif status == GLP_ENOPFS
        return (
            MOI.INFEASIBLE,
            "Unable to start the search, because LP relaxation of the MIP problem instance has no primal feasible solution. (This code may appear only if the presolver is enabled.)",
        )
    elseif status == GLP_ENODFS
        return (
            MOI.DUAL_INFEASIBLE,
            "Unable to start the search, because LP relaxation of the MIP problem instance has no dual feasible solution. In other word, this code means that if the LP relaxation has at least one primal feasible solution, its optimal solution is unbounded, so if the MIP problem has at least one integer feasible solution, its (integer) optimal solution is also unbounded. (This code may appear only if the presolver is enabled.)",
        )
    elseif status == GLP_EFAIL
        return (
            MOI.INVALID_MODEL,
            "The search was prematurely terminated due to the solver failure.",
        )
    elseif status == GLP_EMIPGAP
        return (
            MOI.OPTIMAL,
            "The search was prematurely terminated, because the relative mip gap tolerance has been reached.",
        )
    elseif status == GLP_ETMLIM
        return (
            MOI.TIME_LIMIT,
            "The search was prematurely terminated, because the time limit has been exceeded.",
        )
    else
        @assert status == GLP_ESTOP
        return (
            MOI.INTERRUPTED,
            "The search was prematurely terminated by application. (This code may appear only if the advanced solver interface is used.)",
        )
    end
end

function _raw_solution_string(status::Int32)
    if status == GLP_OPT
        return (MOI.OPTIMAL, "Solution is optimal")
    elseif status == GLP_FEAS
        return (MOI.LOCALLY_SOLVED, "Solution is feasible")
    elseif status == GLP_INFEAS
        return (MOI.LOCALLY_INFEASIBLE, "Solution is infeasible")
    elseif status == GLP_NOFEAS
        return (MOI.INFEASIBLE, "No feasible primal-dual solution exists.")
    elseif status == GLP_UNBND
        return (MOI.DUAL_INFEASIBLE, "Problem has unbounded solution")
    else
        @assert status == GLP_UNDEF
        return (MOI.OTHER_ERROR, "Solution is undefined")
    end
end

function MOI.get(model::Optimizer, attr::MOI.RawStatusString)
    _throw_if_optimize_in_progress(model, attr)
    if model.solver_status == Int32(0)
        return _get_status(model)[2]
    elseif model.last_solved_by_mip
        return _raw_intopt_string(model.solver_status)[2]
    elseif model.method == SIMPLEX
        return _raw_simplex_string(model.solver_status)[2]
    elseif model.method == EXACT
        return _raw_exact_string(model.solver_status)[2]
    else
        @assert model.method == INTERIOR
        return _raw_interior_string(model.solver_status)[2]
    end
end

function _get_status(model::Optimizer)
    status_code = if model.last_solved_by_mip
        glp_mip_status(model)
    elseif model.method == SIMPLEX || model.method == EXACT
        glp_get_status(model)
    else
        @assert model.method == INTERIOR
        glp_ipt_status(model)
    end
    return _raw_solution_string(status_code)
end

"""
    _certificates_potentially_available(model::Optimizer)

Return true if an infeasiblity certificate or an unbounded ray is potentially
available (i.e., the model has been solved using either the Simplex or Exact
methods).
"""
function _certificates_potentially_available(model::Optimizer)
    if !model.want_infeasibility_certificates
        return false
    elseif model.last_solved_by_mip
        return false
    else
        return model.method == SIMPLEX || model.method == EXACT
    end
end

function MOI.get(model::Optimizer, attr::MOI.TerminationStatus)
    _throw_if_optimize_in_progress(model, attr)
    if model.optimize_not_called
        return MOI.OPTIMIZE_NOT_CALLED
    elseif model.solver_status != Int32(0)
        # The solver did not exit successfully for some reason.
        if model.last_solved_by_mip
            return _raw_intopt_string(model.solver_status)[1]
        elseif model.method == SIMPLEX
            return _raw_simplex_string(model.solver_status)[1]
        elseif model.method == INTERIOR
            return _raw_interior_string(model.solver_status)[1]
        else
            @assert model.method == EXACT
            return _raw_exact_string(model.solver_status)[1]
        end
    else
        (status, _) = _get_status(model)
        return status
    end
end

function MOI.get(model::Optimizer, attr::MOI.PrimalStatus)
    _throw_if_optimize_in_progress(model, attr)
    if attr.result_index != 1
        return MOI.NO_SOLUTION
    end
    (status, _) = _get_status(model)
    if status == MOI.OPTIMAL || status == MOI.LOCALLY_SOLVED
        return MOI.FEASIBLE_POINT
    elseif status == MOI.LOCALLY_INFEASIBLE
        return MOI.INFEASIBLE_POINT
    elseif status == MOI.DUAL_INFEASIBLE
        if model.unbounded_ray !== nothing
            return MOI.INFEASIBILITY_CERTIFICATE
        end
    else
        @assert status == MOI.INFEASIBLE || status == MOI.OTHER_ERROR
    end
    return MOI.NO_SOLUTION
end

function MOI.get(model::Optimizer, attr::MOI.DualStatus)
    _throw_if_optimize_in_progress(model, attr)
    if attr.result_index != 1 || model.last_solved_by_mip
        return MOI.NO_SOLUTION
    end
    (status, _) = _get_status(model)
    if status == MOI.OPTIMAL
        return MOI.FEASIBLE_POINT
    elseif status == MOI.INFEASIBLE
        if model.infeasibility_cert !== nothing
            return MOI.INFEASIBILITY_CERTIFICATE
        end
    end
    return MOI.NO_SOLUTION
end

function _get_col_dual(model::Optimizer, column::Int)
    @assert !model.last_solved_by_mip
    if model.method == SIMPLEX || model.method == EXACT
        return _dual_multiplier(model) * glp_get_col_dual(model, column)
    else
        @assert model.method == INTERIOR
        return _dual_multiplier(model) * glp_ipt_col_dual(model, column)
    end
end

function _get_col_primal(model::Optimizer, column::Int)
    if model.last_solved_by_mip
        return glp_mip_col_val(model, column)
    elseif model.method == SIMPLEX || model.method == EXACT
        return glp_get_col_prim(model, column)
    else
        @assert model.method == INTERIOR
        return glp_ipt_col_prim(model, column)
    end
end

function _get_row_primal(model::Optimizer, row::Int)
    if model.last_solved_by_mip
        return glp_mip_row_val(model, row)
    elseif model.method == SIMPLEX || model.method == EXACT
        return glp_get_row_prim(model, row)
    else
        @assert model.method == INTERIOR
        return glp_ipt_row_prim(model, row)
    end
end

function MOI.get(
    model::Optimizer,
    attr::MOI.VariablePrimal,
    x::MOI.VariableIndex,
)
    _throw_if_optimize_in_progress(model, attr)
    MOI.check_result_index_bounds(model, attr)
    if model.unbounded_ray !== nothing
        return model.unbounded_ray[column(model, x)]
    else
        return _get_col_primal(model, column(model, x))
    end
end

function MOI.get(
    model::Optimizer,
    attr::MOI.ConstraintPrimal,
    c::MOI.ConstraintIndex{MOI.VariableIndex,<:Any},
)
    _throw_if_optimize_in_progress(model, attr)
    MOI.check_result_index_bounds(model, attr)
    return MOI.get(model, MOI.VariablePrimal(), MOI.VariableIndex(c.value))
end

function MOI.get(
    model::Optimizer,
    attr::MOI.ConstraintPrimal,
    c::MOI.ConstraintIndex{MOI.ScalarAffineFunction{Float64},<:Any},
)
    _throw_if_optimize_in_progress(model, attr)
    MOI.check_result_index_bounds(model, attr)
    if model.unbounded_ray !== nothing
        return MOI.Utilities.get_fallback(model, attr, c)
    end
    return _get_row_primal(model, _info(model, c).row)
end

function _dual_multiplier(model::Optimizer)
    return MOI.get(model, MOI.ObjectiveSense()) == MOI.MIN_SENSE ? 1.0 : -1.0
end

function _farkas_variable_dual(model::Optimizer, col::Int)
    nnz = glp_get_mat_col(model, col, C_NULL, C_NULL)
    vind = Vector{Cint}(undef, nnz)
    vval = Vector{Cdouble}(undef, nnz)
    nnz = glp_get_mat_col(model, Cint(col), offset(vind), offset(vval))
    return sum(
        model.infeasibility_cert[row] * val for (row, val) in zip(vind, vval)
    )
end

function MOI.get(
    model::Optimizer,
    attr::MOI.ConstraintDual,
    c::MOI.ConstraintIndex{MOI.VariableIndex,MOI.LessThan{Float64}},
)
    _throw_if_optimize_in_progress(model, attr)
    MOI.check_result_index_bounds(model, attr)
    col = column(model, c)
    if model.infeasibility_cert !== nothing
        dual = _farkas_variable_dual(model, col)
        return min(dual, 0.0)
    end
    reduced_cost = if model.method == SIMPLEX || model.method == EXACT
        glp_get_col_dual(model, col)
    else
        @assert model.method == INTERIOR
        glp_ipt_col_dual(model, col)
    end
    sense = MOI.get(model, MOI.ObjectiveSense())
    # The following is a heuristic for determining whether the reduced cost
    # (i.e., the column dual) applies to the lower or upper bound. It can be
    # wrong by at most `tol_dj`.
    if sense == MOI.MIN_SENSE && reduced_cost < 0
        # If minimizing, the reduced cost must be negative (ignoring
        # tolerances).
        return reduced_cost
    elseif sense == MOI.MAX_SENSE && reduced_cost > 0
        # If minimizing, the reduced cost must be positive (ignoring
        # tolerances). However, because of the MOI dual convention, we return a
        # negative value.
        return -reduced_cost
    else
        # The reduced cost, if non-zero, must related to the lower bound.
        return 0.0
    end
end

function MOI.get(
    model::Optimizer,
    attr::MOI.ConstraintDual,
    c::MOI.ConstraintIndex{MOI.VariableIndex,MOI.GreaterThan{Float64}},
)
    _throw_if_optimize_in_progress(model, attr)
    MOI.check_result_index_bounds(model, attr)
    col = column(model, c)
    if model.infeasibility_cert !== nothing
        dual = _farkas_variable_dual(model, col)
        return max(dual, 0.0)
    end
    reduced_cost = if model.method == SIMPLEX || model.method == EXACT
        glp_get_col_dual(model, col)
    else
        @assert model.method == INTERIOR
        glp_ipt_col_dual(model, col)
    end
    sense = MOI.get(model, MOI.ObjectiveSense())
    # The following is a heuristic for determining whether the reduced cost
    # (i.e., the column dual) applies to the lower or upper bound. It can be
    # wrong by at most `tol_dj`.
    if sense == MOI.MIN_SENSE && reduced_cost > 0
        # If minimizing, the reduced cost must be negative (ignoring
        # tolerances).
        return reduced_cost
    elseif sense == MOI.MAX_SENSE && reduced_cost < 0
        # If minimizing, the reduced cost must be positive (ignoring
        # tolerances). However, because of the MOI dual convention, we return a
        # negative value.
        return -reduced_cost
    else
        # The reduced cost, if non-zero, must related to the lower bound.
        return 0.0
    end
end

function MOI.get(
    model::Optimizer,
    attr::MOI.ConstraintDual,
    c::MOI.ConstraintIndex{MOI.VariableIndex,S},
) where {S<:Union{MOI.EqualTo,MOI.Interval}}
    _throw_if_optimize_in_progress(model, attr)
    MOI.check_result_index_bounds(model, attr)
    col = column(model, c)
    if model.infeasibility_cert !== nothing
        return _farkas_variable_dual(model, col)
    end
    return _get_col_dual(model, col)
end

function MOI.get(
    model::Optimizer,
    attr::MOI.ConstraintDual,
    c::MOI.ConstraintIndex{MOI.ScalarAffineFunction{Float64},<:Any},
)
    _throw_if_optimize_in_progress(model, attr)
    MOI.check_result_index_bounds(model, attr)
    row = _info(model, c).row
    if model.infeasibility_cert !== nothing
        return -model.infeasibility_cert[row]
    else
        @assert !model.last_solved_by_mip
        if model.method == SIMPLEX || model.method == EXACT
            return _dual_multiplier(model) * glp_get_row_dual(model, row)
        else
            @assert model.method == INTERIOR
            return _dual_multiplier(model) * glp_ipt_row_dual(model, row)
        end
    end
end

function MOI.get(model::Optimizer, attr::MOI.ObjectiveValue)
    _throw_if_optimize_in_progress(model, attr)
    MOI.check_result_index_bounds(model, attr)
    if model.unbounded_ray !== nothing
        return MOI.Utilities.get_fallback(model, attr)
    elseif model.last_solved_by_mip
        return glp_mip_obj_val(model)
    elseif model.method == SIMPLEX || model.method == EXACT
        return glp_get_obj_val(model)
    else
        @assert model.method == INTERIOR
        return glp_ipt_obj_val(model)
    end
end

function MOI.get(model::Optimizer, attr::MOI.ObjectiveBound)
    _throw_if_optimize_in_progress(model, attr)
    if !model.last_solved_by_mip
        return MOI.get(model, MOI.ObjectiveSense()) == MOI.MIN_SENSE ? -Inf :
               Inf
    end
    # @mlubin and @ccoey observed some cases where mip_status == OPT and objval
    # and objbound didn't match. In that case, they return mip_obj_val, but
    # objbound may still be incorrect in cases where GLPK terminates early.
    if glp_mip_status(model) == GLP_OPT
        return glp_mip_obj_val(model)
    end
    return model.objective_bound
end

function MOI.get(model::Optimizer, attr::MOI.DualObjectiveValue)
    _throw_if_optimize_in_progress(model, attr)
    MOI.check_result_index_bounds(model, attr)
    if _check_moi_callback_validity(model) || model.has_generic_callback
        # If we've set a callback, the fallback won't work.
        return NaN
    end
    return MOI.Utilities.get_fallback(model, attr, Float64)
end

function MOI.get(model::Optimizer, attr::MOI.RelativeGap)
    _throw_if_optimize_in_progress(model, attr)
    if !model.last_solved_by_mip
        error(
            "RelativeGap is only available for models with integer variables.",
        )
    end
    return model.relative_gap
end

function MOI.get(model::Optimizer, attr::MOI.SolveTimeSec)
    _throw_if_optimize_in_progress(model, attr)
    return model.solve_time
end

function MOI.get(model::Optimizer, attr::MOI.ResultCount)
    _throw_if_optimize_in_progress(model, attr)
    (status, _) = _get_status(model)
    if status in (MOI.OPTIMAL, MOI.LOCALLY_SOLVED, MOI.LOCALLY_INFEASIBLE)
        return 1
    elseif status in
           (MOI.DUAL_INFEASIBLE, MOI.INFEASIBLE, MOI.LOCALLY_INFEASIBLE)
        if _certificates_potentially_available(model)
            return 1
        end
    end
    return 0
end

###
### MOI.Silent
###

MOI.supports(::Optimizer, ::MOI.Silent) = true

function MOI.get(model::Optimizer, ::MOI.Silent)
    return model.silent
end

function MOI.set(model::Optimizer, ::MOI.Silent, flag::Bool)
    model.silent = flag
    output_flag =
        flag ? GLP_OFF : MOI.get(model, MOI.RawOptimizerAttribute("msg_lev"))
    MOI.set(model, MOI.RawOptimizerAttribute("msg_lev"), output_flag)
    return
end

###
### MOI.Name
###

MOI.supports(::Optimizer, ::MOI.Name) = true

function MOI.get(model::Optimizer, ::MOI.Name)
    name = glp_get_prob_name(model)
    return name == C_NULL ? "" : unsafe_string(name)
end

function MOI.set(model::Optimizer, ::MOI.Name, name::String)
    glp_set_prob_name(model, name)
    return
end

function MOI.get(model::Optimizer, ::MOI.NumberOfVariables)::Int64
    return length(model.variable_info)
end

function MOI.get(model::Optimizer, ::MOI.ListOfVariableIndices)
    return sort!(collect(keys(model.variable_info)), by = x -> x.value)
end

MOI.get(model::Optimizer, ::MOI.RawSolver) = model

function MOI.get(
    model::Optimizer,
    ::MOI.NumberOfConstraints{F,S},
)::Int64 where {F,S}
    # TODO: this could be more efficient.
    return length(MOI.get(model, MOI.ListOfConstraintIndices{F,S}()))
end

_bound_enums(::Type{<:MOI.LessThan}) = (_LESS_THAN, _LESS_AND_GREATER_THAN)
function _bound_enums(::Type{<:MOI.GreaterThan})
    return (_GREATER_THAN, _LESS_AND_GREATER_THAN)
end
_bound_enums(::Type{<:MOI.Interval}) = (_INTERVAL,)
_bound_enums(::Type{<:MOI.EqualTo}) = (_EQUAL_TO,)
_bound_enums(::Any) = (nothing,)

_type_enums(::Type{MOI.ZeroOne}) = (_BINARY,)
_type_enums(::Type{MOI.Integer}) = (_INTEGER,)
_type_enums(::Any) = (nothing,)

function MOI.get(
    model::Optimizer,
    ::MOI.ListOfConstraintIndices{MOI.VariableIndex,S},
) where {S}
    indices = MOI.ConstraintIndex{MOI.VariableIndex,S}[]
    for (key, info) in model.variable_info
        if info.bound in _bound_enums(S) || info.type in _type_enums(S)
            push!(indices, MOI.ConstraintIndex{MOI.VariableIndex,S}(key.value))
        end
    end
    return sort!(indices, by = x -> x.value)
end

function MOI.get(
    model::Optimizer,
    ::MOI.ListOfConstraintIndices{MOI.ScalarAffineFunction{Float64},S},
) where {S}
    indices = MOI.ConstraintIndex{MOI.ScalarAffineFunction{Float64},S}[]
    for (key, info) in model.affine_constraint_info
        if typeof(info.set) == S
            push!(
                indices,
                MOI.ConstraintIndex{MOI.ScalarAffineFunction{Float64},S}(
                    key.value,
                ),
            )
        end
    end
    return sort!(indices, by = x -> x.value)
end

function MOI.get(model::Optimizer, ::MOI.ListOfConstraintTypesPresent)
    constraints = Set{Tuple{Type,Type}}()
    for info in values(model.variable_info)
        if info.bound == _NONE
        elseif info.bound == _LESS_THAN
            push!(constraints, (MOI.VariableIndex, MOI.LessThan{Float64}))
        elseif info.bound == _GREATER_THAN
            push!(constraints, (MOI.VariableIndex, MOI.GreaterThan{Float64}))
        elseif info.bound == _LESS_AND_GREATER_THAN
            push!(constraints, (MOI.VariableIndex, MOI.LessThan{Float64}))
            push!(constraints, (MOI.VariableIndex, MOI.GreaterThan{Float64}))
        elseif info.bound == _EQUAL_TO
            push!(constraints, (MOI.VariableIndex, MOI.EqualTo{Float64}))
        elseif info.bound == _INTERVAL
            push!(constraints, (MOI.VariableIndex, MOI.Interval{Float64}))
        end
        if info.type == _CONTINUOUS
        elseif info.type == _BINARY
            push!(constraints, (MOI.VariableIndex, MOI.ZeroOne))
        elseif info.type == _INTEGER
            push!(constraints, (MOI.VariableIndex, MOI.Integer))
        end
    end
    for info in values(model.affine_constraint_info)
        push!(
            constraints,
            (MOI.ScalarAffineFunction{Float64}, typeof(info.set)),
        )
    end
    return collect(constraints)
end

function MOI.get(::Optimizer, ::MOI.ObjectiveFunctionType)
    return MOI.ScalarAffineFunction{Float64}
end

# TODO(odow): is there a way to modify a single element, rather than the whole
# row?
function MOI.modify(
    model::Optimizer,
    c::MOI.ConstraintIndex{MOI.ScalarAffineFunction{Float64},<:Any},
    chg::MOI.ScalarCoefficientChange{Float64},
)
    row = Cint(_info(model, c).row)
    col = column(model, chg.variable)
    nnz = glp_get_mat_row(model, row, C_NULL, C_NULL)
    indices, coefficients = zeros(Cint, nnz), zeros(Cdouble, nnz)
    glp_get_mat_row(model, row, offset(indices), offset(coefficients))
    index = something(findfirst(isequal(col), indices), 0)
    if index > 0
        coefficients[index] = chg.new_coefficient
    else
        push!(indices, col)
        push!(coefficients, chg.new_coefficient)
    end
    glp_set_mat_row(
        model,
        row,
        length(indices),
        offset(indices),
        offset(coefficients),
    )
    return
end

function MOI.modify(
    model::Optimizer,
    cis::Vector{MOI.ConstraintIndex{MOI.ScalarAffineFunction{Float64},S}},
    changes::Vector{MOI.ScalarCoefficientChange{Float64}},
) where {S}
    nels = length(cis)
    @assert nels == length(changes)
    rows = Vector{Cint}(undef, nels)
    cols = Vector{Cint}(undef, nels)
    coefs = Vector{Cdouble}(undef, nels)
    for i in 1:nels
        rows[i] = Cint(_info(model, cis[i]).row)
        cols[i] = column(model, changes[i].variable)
        coefs[i] = changes[i].new_coefficient
    end
    for row in unique(rows)
        nnz = glp_get_mat_row(model, row, C_NULL, C_NULL)
        indices, coefficients = zeros(Cint, nnz), zeros(Cdouble, nnz)
        glp_get_mat_row(model, row, offset(indices), offset(coefficients))
        idxs_changed_in_row = findall(x -> x == row, rows)
        for i in idxs_changed_in_row
            index = something(findfirst(isequal(cols[i]), indices), 0)
            if index > 0
                coefficients[index] = coefs[i]
            else
                push!(indices, cols[i])
                push!(coefficients, coefs[i])
            end
        end
        glp_set_mat_row(
            model,
            row,
            length(indices),
            offset(indices),
            offset(coefficients),
        )
    end
    return
end

function MOI.set(
    model::Optimizer,
    ::MOI.ConstraintFunction,
    c::MOI.ConstraintIndex{MOI.ScalarAffineFunction{Float64},<:_SCALAR_SETS},
    f::MOI.ScalarAffineFunction{Float64},
)
    if !iszero(f.constant)
        throw(MOI.ScalarFunctionConstantNotZero(f.constant))
    end
    row = Cint(_info(model, c).row)
    indices, coefficients = _indices_and_coefficients(model, f)
    glp_set_mat_row(
        model,
        row,
        length(indices),
        offset(indices),
        offset(coefficients),
    )
    return
end

function MOI.get(
    model::Optimizer,
    attr::MOI.ConstraintBasisStatus,
    c::MOI.ConstraintIndex{MOI.ScalarAffineFunction{Float64},<:_SCALAR_SETS},
)
    _throw_if_optimize_in_progress(model, attr)
    row = _info(model, c).row
    cbasis = glp_get_row_stat(model, row)
    if cbasis == GLP_BS
        return MOI.BASIC
    else
        return MOI.NONBASIC
    end
end

function MOI.get(
    model::Optimizer,
    attr::MOI.VariableBasisStatus,
    x::MOI.VariableIndex,
)
    _throw_if_optimize_in_progress(model, attr)
    col = column(model, x)
    vbasis = glp_get_col_stat(model, col)
    if vbasis == GLP_BS  # basic variable
        return MOI.BASIC
    elseif vbasis == GLP_NL  # non-basic variable having active lower bound
        return MOI.NONBASIC_AT_LOWER
    elseif vbasis == GLP_NU  # non-basic variable having active upper bound
        return MOI.NONBASIC_AT_UPPER
    elseif vbasis == GLP_NF  # non-basic free variable
        return MOI.SUPER_BASIC
    else
        @assert vbasis == GLP_NS  # nonbasic fixed variable
        return MOI.NONBASIC
    end
end

# Copyright (c) 2012 GLPK.jl contributors
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the Licence, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

struct _OptimizerCache
    "Column lower bounds"
    cl::Vector{Float64}
    "Column upper bounds"
    cu::Vector{Float64}
    "Column bound types"
    bounds::Vector{_VariableBound}
    "Column types"
    types::Vector{_VariableType}
    "Row lower bounds"
    rl::Vector{Float64}
    "Row upper bounds"
    ru::Vector{Float64}
    "A matrix in 1-indexed sparse triplet form"
    I::Vector{Cint}
    J::Vector{Cint}
    V::Vector{Float64}
    function _OptimizerCache(N::Int)
        return new(
            fill(-Inf, N),
            fill(Inf, N),
            fill(_NONE, N),
            fill(_CONTINUOUS, N),
            Float64[],
            Float64[],
            Cint[],
            Cint[],
            Float64[],
        )
    end
end

"""
    _validate_constraint_types(dest::Optimizer, src::MOI.ModelLike)

Throw an error if unsupported constraint or objective types are present in
`src`.
"""
function _validate_constraint_types(dest::Optimizer, src::MOI.ModelLike)
    for (F, S) in MOI.get(src, MOI.ListOfConstraintTypesPresent())
        if !MOI.supports_constraint(dest, F, S)
            throw(
                MOI.UnsupportedConstraint{F,S}(
                    "GLPK.Optimizer does not support constraints of type $F-in-$S.",
                ),
            )
        end
        for attr in MOI.get(src, MOI.ListOfConstraintAttributesSet{F,S}())
            if !MOI.supports(dest, attr, MOI.ConstraintIndex{F,S})
                throw(MOI.UnsupportedAttribute(attr))
            end
        end
    end
    for attr in MOI.get(src, MOI.ListOfModelAttributesSet())
        if !MOI.supports(dest, attr)
            throw(MOI.UnsupportedAttribute(attr))
        end
    end
    for attr in MOI.get(src, MOI.ListOfVariableAttributesSet())
        if !MOI.supports(dest, attr, MOI.VariableIndex)
            throw(MOI.UnsupportedAttribute(attr))
        end
    end
    return
end

function _init_index_map(src::MOI.ModelLike)
    variables = MOI.get(src, MOI.ListOfVariableIndices())
    map = MOI.Utilities.IndexMap()
    N = 0
    for x in variables
        N += 1
        map[x] = MOI.VariableIndex(N)
    end
    return variables, map
end

_add_set_data(cache, i, s::MOI.LessThan{Float64}) = (cache.cu[i] = s.upper)
_add_set_data(cache, i, s::MOI.GreaterThan{Float64}) = (cache.cl[i] = s.lower)

function _add_set_data(cache, i, s::MOI.EqualTo{Float64})
    cache.cl[i] = s.value
    cache.cu[i] = s.value
    cache.bounds[i] = _EQUAL_TO
    return
end

function _add_set_data(cache, i, s::MOI.Interval{Float64})
    cache.cl[i] = s.lower
    cache.cu[i] = s.upper
    cache.bounds[i] = _INTERVAL
    return
end

_add_set_data(cache, i, ::MOI.Integer) = (cache.types[i] = _INTEGER)

_add_set_data(cache, i, ::MOI.ZeroOne) = (cache.types[i] = _BINARY)

function _extract_variable_data(src, map, cache, ::Type{S}) where {S}
    ci_map = map.con_map[MOI.VariableIndex, S]
    for ci in MOI.get(src, MOI.ListOfConstraintIndices{MOI.VariableIndex,S}())
        f = MOI.get(src, MOI.ConstraintFunction(), ci)
        s = MOI.get(src, MOI.ConstraintSet(), ci)
        column = map[f].value
        _add_set_data(cache, column, s)
        ci_map[ci] = MOI.ConstraintIndex{MOI.VariableIndex,S}(column)
    end
    return
end

function _extract_row_data(src, map, cache, ::Type{S}) where {S}
    F = MOI.ScalarAffineFunction{Float64}
    ci_map = map.con_map[F, S]
    nnz = length(cache.I)
    row = length(cache.rl) + 1
    for ci in MOI.get(src, MOI.ListOfConstraintIndices{F,S}())
        f = MOI.get(src, MOI.ConstraintFunction(), ci)
        if !MOI.Utilities.is_canonical(f)
            f = MOI.Utilities.canonical(f)
        end
        l, u = _bounds(MOI.get(src, MOI.ConstraintSet(), ci))
        push!(cache.rl, l === nothing ? -Inf : l - f.constant)
        push!(cache.ru, u === nothing ? Inf : u - f.constant)
        resize!(cache.I, nnz + length(f.terms))
        resize!(cache.J, nnz + length(f.terms))
        resize!(cache.V, nnz + length(f.terms))
        for term in f.terms
            nnz += 1
            cache.I[nnz] = row
            cache.J[nnz] = Cint(map[term.variable].value::Int64)
            cache.V[nnz] = term.coefficient
        end
        ci_map[ci] = MOI.ConstraintIndex{F,S}(row)
        row += 1
    end
    return
end

function _get_moi_bound_type(lower, upper, type)
    if type == _INTERVAL
        return _INTERVAL
    elseif type == _EQUAL_TO
        return _EQUAL_TO
    elseif lower == upper
        return _LESS_AND_GREATER_THAN
    elseif lower <= -GLP_DBL_MAX
        return upper >= GLP_DBL_MAX ? _NONE : _LESS_THAN
    else
        return upper >= GLP_DBL_MAX ? _GREATER_THAN : _LESS_AND_GREATER_THAN
    end
end

function _add_all_variables(model::Optimizer, cache::_OptimizerCache)
    N = length(cache.cl)
    glp_add_cols(model, N)
    sizehint!(model.variable_info, N)
    @inbounds for i in 1:N
        bound = _get_moi_bound_type(cache.cl[i], cache.cu[i], cache.bounds[i])
        CleverDicts.add_item(
            model.variable_info,
            _VariableInfo(MOI.VariableIndex(i), i, bound, cache.types[i], ""),
        )
        glp_bound_type = _get_glp_bound_type(cache.cl[i], cache.cu[i])
        glp_set_col_bnds(model, i, glp_bound_type, cache.cl[i], cache.cu[i])
        if cache.types[i] == _BINARY
            model.num_binaries += 1
            glp_set_col_kind(model, i, GLP_IV)
        elseif cache.types[i] == _INTEGER
            model.num_integers += 1
            glp_set_col_kind(model, i, GLP_IV)
        end
    end
    return
end

function _add_all_constraints(dest::Optimizer, cache::_OptimizerCache)
    N = length(cache.rl)
    if N == 0
        return  # GLPK doesn't like it if we add 0 rows...
    end
    glp_add_rows(dest, N)
    glp_load_matrix(
        dest,
        length(cache.I),
        offset(cache.I),
        offset(cache.J),
        offset(cache.V),
    )
    sizehint!(dest.affine_constraint_info, N)
    @inbounds for i in 1:N
        l, u = cache.rl[i], cache.ru[i]
        if l == -Inf
            glp_set_row_bnds(dest, i, GLP_UP, -GLP_DBL_MAX, u)
            CleverDicts.add_item(
                dest.affine_constraint_info,
                _ConstraintInfo(i, MOI.LessThan{Float64}(u)),
            )
        elseif u == Inf
            glp_set_row_bnds(dest, i, GLP_LO, l, GLP_DBL_MAX)
            CleverDicts.add_item(
                dest.affine_constraint_info,
                _ConstraintInfo(i, MOI.GreaterThan{Float64}(l)),
            )
        else
            @assert l ≈ u  # Must be an equal-to constraint!
            glp_set_row_bnds(dest, i, GLP_FX, l, u)
            CleverDicts.add_item(
                dest.affine_constraint_info,
                _ConstraintInfo(i, MOI.EqualTo{Float64}(l)),
            )
        end
    end
    return
end

function MOI.copy_to(dest::Optimizer, src::MOI.ModelLike)
    @assert MOI.is_empty(dest)
    _validate_constraint_types(dest, src)
    # Initialize the problem storage
    variables, map = _init_index_map(src)
    cache = _OptimizerCache(length(variables))
    # Extract the problem data
    #   Variable bounds:
    _extract_variable_data(src, map, cache, MOI.GreaterThan{Float64})
    _extract_variable_data(src, map, cache, MOI.LessThan{Float64})
    _extract_variable_data(src, map, cache, MOI.EqualTo{Float64})
    _extract_variable_data(src, map, cache, MOI.Interval{Float64})
    #   Variable types:
    _extract_variable_data(src, map, cache, MOI.Integer)
    _extract_variable_data(src, map, cache, MOI.ZeroOne)
    #   Affine constraints:
    _extract_row_data(src, map, cache, MOI.GreaterThan{Float64})
    _extract_row_data(src, map, cache, MOI.LessThan{Float64})
    _extract_row_data(src, map, cache, MOI.EqualTo{Float64})
    # Add the problem data
    _add_all_variables(dest, cache)
    _add_all_constraints(dest, cache)
    # Copy model attributes:
    MOI.Utilities.pass_attributes(dest, src, map)
    MOI.Utilities.pass_attributes(dest, src, map, variables)
    for (F, S) in MOI.get(src, MOI.ListOfConstraintTypesPresent())
        indices = MOI.get(src, MOI.ListOfConstraintIndices{F,S}())
        MOI.Utilities.pass_attributes(dest, src, map, indices)
    end
    return map
end

# The functions _get_infeasibility_ray and _get_unbounded_ray are adapted from
# code taken from the LEMON C++ optimization library. This is the copyright
# notice:
#
# Copyright (C) 2003-2010
# Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
# (Egervary Research Group on Combinatorial Optimization, EGRES).
#
# Permission to use, modify and distribute this software is granted
# provided that this copyright notice appears in all copies. For
# precise terms see the accompanying LICENSE file.
#
# This software is provided "AS IS" with no warranty of any kind,
# express or implied, and with no claim as to its suitability for any
# purpose.

"""
    _get_infeasibility_ray(model::Optimizer, ray::Vector{Float64})

Compute a Farkas certificate of primal infeasibility (unbounded dual ray) and
store in `ray`. Returns `true` if successful, and `false` if a ray cannot be
found.

Assumes `ray` has been initialized to all `0.0`s.
"""
function _get_infeasibility_ray(model::Optimizer, ray::Vector{Float64})
    if glp_get_num_nz(model) == 0
        return false  # GLPK aborts if you try to factorize an empty problem.
    end
    m = glp_get_num_rows(model)
    n = glp_get_num_cols(model)
    @assert length(ray) == m
    # Solve with dual simplex to find unbounded ray.
    param = glp_smcp()
    glp_init_smcp(param)
    param.msg_lev = GLP_MSG_ERR
    param.meth = GLP_DUAL
    status = glp_simplex(model, param)
    if status != 0 || glp_get_status(model) != GLP_NOFEAS
        return false  # Something went wrong finding an unbounded ray.
    end
    unbounded_index = glp_get_unbnd_ray(model)
    if unbounded_index == 0
        return false  # Something went wrong finding an unbounded ray.
    elseif glp_bf_exists(model) == 0
        return false  # No basis factorization
    end
    # If the primal value exceeds the upper bound, then the unbounded_index
    # wants to increase. Otherwise, it must want to decrease.
    scale = if unbounded_index <= m
        primal = glp_get_row_prim(model, unbounded_index)
        primal > glp_get_row_ub(model, unbounded_index) ? 1 : -1
    else
        primal = glp_get_col_prim(model, unbounded_index - m)
        primal > glp_get_col_ub(model, unbounded_index - m) ? 1 : -1
    end
    if unbounded_index <= m
        ray[unbounded_index] = scale
    end
    nnz = m + n
    vind = Vector{Cint}(undef, nnz)
    vval = Vector{Cdouble}(undef, nnz)
    len = glp_eval_tab_row(model, unbounded_index, offset(vind), offset(vval))
    for i in 1:len
        if vind[i] <= m
            ray[vind[i]] = -scale * vval[i]
        end
    end
    return true
end

"""
    _get_unbounded_ray(model::Optimizer, ray::Vector{Float64})::Bool

Compute an unbounded primal ray and store in `ray`. Returns `true` if
successful, and `false` if a ray cannot be found.

Assumes the primal has been solved with primal simplex and is proven unbounded.
Assumes `ray` has been initialized to all `0.0`s.
"""
function _get_unbounded_ray(model::Optimizer, ray::Vector{Float64})
    if glp_get_num_nz(model) == 0
        return false  # GLPK aborts if you try to factorize an empty problem.
    end
    m = glp_get_num_rows(model)
    n = glp_get_num_cols(model)
    @assert length(ray) == n
    unbounded_index = glp_get_unbnd_ray(model)
    if unbounded_index == 0
        return false  # Something went wrong finding an unbounded ray.
    elseif glp_bf_exists(model) == 0
        return false  # No basis factorization exists
    end
    dual = if unbounded_index <= m
        glp_get_row_dual(model, unbounded_index)
    else
        glp_get_col_dual(model, unbounded_index - m)
    end
    scale = xor(glp_get_obj_dir(model) == GLP_MAX, dual > 0) ? -1 : 1
    if unbounded_index > m
        ray[unbounded_index-m] = scale
    end
    nnz = m + n
    vind = Vector{Cint}(undef, nnz)
    vval = Vector{Cdouble}(undef, nnz)
    len = glp_eval_tab_col(model, unbounded_index, offset(vind), offset(vval))
    for i in 1:len
        if vind[i] > m
            ray[vind[i]-m] = scale * vval[i]
        end
    end
    return true
end

# Copyright (c) 2012 GLPK.jl contributors
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the Licence, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

module TestMOIWrapper

using GLPK
using Test

const MOI = GLPK.MathOptInterface

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

function test_runtests()
    MOI.Test.runtests(
        MOI.Bridges.full_bridge_optimizer(GLPK.Optimizer(), Float64),
        MOI.Test.Config();
        exclude = [
            # GLPK returns INVALID_MODEL instead of INFEASIBLE
            "test_constraint_ZeroOne_bounds_3",
            # Upstream issue: https://github.com/jump-dev/MathOptInterface.jl/issues/1431
            "test_model_LowerBoundAlreadySet",
            "test_model_UpperBoundAlreadySet",
        ],
    )
    return
end

function test_runtests_cache()
    MOI.Test.runtests(
        MOI.Utilities.CachingOptimizer(
            MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
            MOI.Bridges.full_bridge_optimizer(GLPK.Optimizer(), Float64),
        ),
        MOI.Test.Config();
        exclude = [
            # GLPK returns INVALID_MODEL instead of INFEASIBLE
            "test_constraint_ZeroOne_bounds_3",
            # Upstream issue: https://github.com/jump-dev/MathOptInterface.jl/issues/1431
            "test_model_LowerBoundAlreadySet",
            "test_model_UpperBoundAlreadySet",
            # ZerosBridge does not support ConstraintDual
            "test_conic_linear_VectorOfVariables_2",
            # CachingOptimizer does not throw if solver not attached
            "test_model_copy_to_UnsupportedAttribute",
            "test_model_copy_to_UnsupportedConstraint",
        ],
    )
    return
end

function test_parameter_setting()
    solver = GLPK.Optimizer()
    MOI.set(solver, MOI.RawOptimizerAttribute("tm_lim"), 1)
    MOI.set(solver, MOI.RawOptimizerAttribute("ord_alg"), 2)
    MOI.set(solver, MOI.RawOptimizerAttribute("alien"), 3)
    @test solver.simplex_param.tm_lim == 1
    @test solver.intopt_param.tm_lim == 1
    @test solver.interior_param.ord_alg == 2
    @test solver.intopt_param.alien == 3
    return
end

function test_unbounded_integer_model()
    model = GLPK.Optimizer()
    MOI.Utilities.loadfromstring!(
        model,
        """
variables: x, y
minobjective: -5.0x + y
x in Integer()
x in LessThan(1.0)
""",
    )
    MOI.optimize!(model)
    @test MOI.get(model, MOI.TerminationStatus()) == MOI.DUAL_INFEASIBLE
    return
end

function test_infeasible_integer_model()
    model = GLPK.Optimizer()
    MOI.Utilities.loadfromstring!(
        model,
        """
variables: x
minobjective: -5.0x
x in Integer()
x in LessThan(1.0)
c3: 1.0x in GreaterThan(2.0)
""",
    )
    MOI.optimize!(model)
    @test MOI.get(model, MOI.TerminationStatus()) == MOI.INFEASIBLE
    return
end

function test_issue_70()
    model = GLPK.Optimizer()
    x = MOI.add_variable(model)
    f = MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.([1.0], [x]), 0.0)
    s = MOI.LessThan(2.0)
    c = MOI.add_constraint(model, f, s)
    row = GLPK._info(model, c).row
    @test GLPK.glp_get_row_type(model.inner, row) == GLPK.GLP_UP
    @test GLPK.glp_get_row_lb(model.inner, row) == -GLPK.GLP_DBL_MAX
    @test GLPK.glp_get_row_ub(model.inner, row) == 2.0
    # Modify the constraint set and verify that the internal constraint
    # has the correct bounds afterwards
    MOI.set(model, MOI.ConstraintSet(), c, MOI.LessThan(1.0))
    @test GLPK.glp_get_row_type(model.inner, row) == GLPK.GLP_UP
    @test GLPK.glp_get_row_lb(model.inner, row) == -GLPK.GLP_DBL_MAX
    @test GLPK.glp_get_row_ub(model.inner, row) == 1.0
    return
end

function test_infeasible_bounds()
    model = GLPK.Optimizer()
    x = MOI.add_variable(model)
    MOI.add_constraint(model, x, MOI.Interval(1.0, -1.0))
    MOI.optimize!(model)
    @test MOI.get(model, MOI.TerminationStatus()) == MOI.INVALID_MODEL
    return
end

function test_RawOptimizerAttribute()
    model = GLPK.Optimizer(method = GLPK.SIMPLEX)
    exception = ErrorException(
        "Invalid option: cb_func. Use the MOI attribute `GLPK.CallbackFunction` instead.",
    )
    @test_throws exception MOI.set(
        model,
        MOI.RawOptimizerAttribute("cb_func"),
        (cb) -> nothing,
    )
    MOI.set(model, MOI.RawOptimizerAttribute("tm_lim"), 100)
    @test MOI.get(model, MOI.RawOptimizerAttribute("tm_lim")) == 100
    param = MOI.RawOptimizerAttribute("bad")
    @test_throws MOI.UnsupportedAttribute(param) MOI.set(model, param, 1)
    @test_throws MOI.UnsupportedAttribute(param) MOI.get(model, param)

    model = GLPK.Optimizer(method = GLPK.INTERIOR)
    exception = ErrorException(
        "Invalid option: cb_func. Use the MOI attribute `GLPK.CallbackFunction` instead.",
    )
    @test_throws exception MOI.set(
        model,
        MOI.RawOptimizerAttribute("cb_func"),
        (cb) -> nothing,
    )
    MOI.set(model, MOI.RawOptimizerAttribute("tm_lim"), 100)
    @test MOI.get(model, MOI.RawOptimizerAttribute("tm_lim")) == 100
    @test_throws MOI.UnsupportedAttribute(param) MOI.set(
        model,
        MOI.RawOptimizerAttribute("bad"),
        1,
    )
    @test_throws MOI.UnsupportedAttribute(param) MOI.get(
        model,
        MOI.RawOptimizerAttribute("bad"),
    )

    model = GLPK.Optimizer(method = GLPK.EXACT)
    exception = ErrorException(
        "Invalid option: cb_func. Use the MOI attribute `GLPK.CallbackFunction` instead.",
    )
    @test_throws exception MOI.set(
        model,
        MOI.RawOptimizerAttribute("cb_func"),
        (cb) -> nothing,
    )
    MOI.set(model, MOI.RawOptimizerAttribute("tm_lim"), 100)
    @test MOI.get(model, MOI.RawOptimizerAttribute("tm_lim")) == 100
    @test_throws MOI.UnsupportedAttribute(param) MOI.set(
        model,
        MOI.RawOptimizerAttribute("bad"),
        1,
    )
    @test_throws MOI.UnsupportedAttribute(param) MOI.get(
        model,
        MOI.RawOptimizerAttribute("bad"),
    )

    model = GLPK.Optimizer()
    MOI.set(model, MOI.RawOptimizerAttribute("mip_gap"), 0.001)
    @test MOI.get(model, MOI.RawOptimizerAttribute("mip_gap")) == 0.001
    return
end

function test_TimeLimitSec_issue_110()
    model = GLPK.Optimizer(method = GLPK.SIMPLEX)
    MOI.set(model, MOI.TimeLimitSec(), nothing)
    @test MOI.get(model, MOI.RawOptimizerAttribute("tm_lim")) == typemax(Int32)
    MOI.set(model, MOI.TimeLimitSec(), 100)
    @test MOI.get(model, MOI.RawOptimizerAttribute("tm_lim")) == 100000
    @test MOI.get(model, MOI.TimeLimitSec()) == 100
    # conversion between ms and sec
    MOI.set(model, MOI.RawOptimizerAttribute("tm_lim"), 100)
    @test isapprox(MOI.get(model, MOI.TimeLimitSec()), 0.1)
    return
end

function test_RelativeGap()
    model = GLPK.Optimizer()
    MOI.Utilities.loadfromstring!(
        model,
        """
    variables: x
    minobjective: 1.0x
    x in Integer()
    x in GreaterThan(1.5)
""",
    )
    MOI.optimize!(model)
    @test MOI.get(model, MOI.RelativeGap()) == 0.0

    model = GLPK.Optimizer()
    MOI.Utilities.loadfromstring!(
        model,
        """
    variables: x
    minobjective: 1.0x
    x in GreaterThan(1.5)
""",
    )
    MOI.optimize!(model)
    @test_throws ErrorException MOI.get(model, MOI.RelativeGap())
    return
end

function test_issue_102()
    model = GLPK.Optimizer()
    x = MOI.add_variable(model)
    MOI.add_constraint(model, x, MOI.GreaterThan(0.0))
    MOI.add_constraint(model, x, MOI.Integer())
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    MOI.set(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{Float64}}(),
        MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(1.0, x)], 3.0),
    )
    MOI.optimize!(model)
    @test MOI.get(model, MOI.ObjectiveValue()) == 3.0
    @test MOI.get(model, MOI.ObjectiveBound()) == 3.0
    return
end

function test_issue_116()
    model = GLPK.Optimizer(method = GLPK.EXACT)
    x = MOI.add_variables(model, 2)
    c1 = MOI.add_constraint(
        model,
        MOI.ScalarAffineFunction(
            [MOI.ScalarAffineTerm(1.0, x[1]), MOI.ScalarAffineTerm(1.0, x[2])],
            0.0,
        ),
        MOI.LessThan(1.0),
    )
    c2 = MOI.add_constraint(model, x[1], MOI.EqualTo(1.0))
    c3 = MOI.add_constraint(model, x[2], MOI.EqualTo(1.0))
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    MOI.set(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{Float64}}(),
        MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.(1.0, x), 0.0),
    )
    MOI.optimize!(model)
    @test MOI.get(model, MOI.TerminationStatus()) == MOI.INFEASIBLE
    @test MOI.get(model, MOI.DualStatus()) == MOI.INFEASIBILITY_CERTIFICATE
    cd1 = MOI.get(model, MOI.ConstraintDual(), c1)
    @test cd1 <= 1e-6
    @test MOI.get(model, MOI.ConstraintDual(), c2) ≈ -cd1 atol = 1e-6
    @test MOI.get(model, MOI.ConstraintDual(), c3) ≈ -cd1 atol = 1e-6
    return
end

function test_default_parameters()
    model = GLPK.Optimizer()
    @test MOI.get(model, MOI.RawOptimizerAttribute("msg_lev")) ==
          GLPK.GLP_MSG_ERR
    @test MOI.get(model, MOI.RawOptimizerAttribute("presolve")) == GLPK.GLP_OFF
    model = GLPK.Optimizer()
    MOI.set(model, MOI.RawOptimizerAttribute("msg_lev"), GLPK.GLP_MSG_ALL)
    MOI.set(model, MOI.RawOptimizerAttribute("presolve"), true)
    @test MOI.get(model, MOI.RawOptimizerAttribute("msg_lev")) ==
          GLPK.GLP_MSG_ALL
    @test MOI.get(model, MOI.RawOptimizerAttribute("presolve")) == GLPK.GLP_ON
    return
end

function test_duals_with_equal_bounds()
    model = GLPK.Optimizer()
    x = MOI.add_variable(model)
    xl = MOI.add_constraint(model, x, MOI.GreaterThan(1.0))
    xu = MOI.add_constraint(model, x, MOI.LessThan(1.0))
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    MOI.set(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{Float64}}(),
        MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(1.0, x)], 0.0),
    )
    MOI.optimize!(model)
    @test MOI.get(model, MOI.ConstraintDual(), xl) == 1.0
    @test MOI.get(model, MOI.ConstraintDual(), xu) == 0.0
    return
end

function test_pr_121()
    model = GLPK.Optimizer()
    ci = MOI.ConstraintIndex{
        MOI.ScalarAffineFunction{Float64},
        MOI.LessThan{Float64},
    }(
        1,
    )
    @test_throws MOI.InvalidIndex(ci) MOI.get(model, MOI.ConstraintSet(), ci)
    @test_throws MOI.InvalidIndex(ci) MOI.get(
        model,
        MOI.ConstraintFunction(),
        ci,
    )
    @test_throws MOI.InvalidIndex(ci) MOI.delete(model, ci)
    return
end

function test_nonascii_names()
    model = GLPK.Optimizer()
    x = MOI.add_variable(model)
    MOI.set(model, MOI.VariableName(), x, "ω")
    @test MOI.get(model, MOI.VariableName(), x) == "ω"
    c = MOI.add_constraint(
        model,
        MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(1.0, x)], 0.0),
        MOI.GreaterThan(0.0),
    )
    MOI.set(model, MOI.ConstraintName(), c, "ω")
    @test MOI.get(model, MOI.ConstraintName(), c) == "ω"
    return
end

function test_copy_to()
    dest = GLPK.Optimizer()
    src = MOI.Utilities.Model{Float64}()
    MOI.Utilities.loadfromstring!(
        src,
        """
    variables: a, b, c, d
    minobjective: a + b + c + d
    a >= 1.0
    b <= 2.0
    c == 3.0
    d in Interval(-4.0, 4.0)
    a in Integer()
    b in ZeroOne()
    c7: a + b >= -1.1
    c8: a + b <= 2.2
    c8: c + d == 2.2
""",
    )
    index_map = MOI.copy_to(dest, src)
    @test length(index_map) == 13
    for (k, v) in index_map
        if v isa MOI.VariableIndex
            @test k == v
        elseif v isa MOI.ConstraintIndex{MOI.VariableIndex}
            @test k == v
        else
            # The order of the linear constraints may change. But they should be
            # ordered from 1 to 3.
            @test typeof(k) == typeof(v)
            @test 1 <= v.value <= 3
        end
    end
    v = MOI.get(dest, MOI.ListOfVariableIndices())
    @test length(v) == 4
    names = MOI.get.(dest, MOI.VariableName(), v)
    @test names == ["a", "b", "c", "d"]
    return
end

function test_want_infeasibility_certificates()
    model = GLPK.Optimizer(want_infeasibility_certificates = false)
    x = MOI.add_variables(model, 2)
    MOI.add_constraint.(model, x, MOI.LessThan(0.0))
    MOI.add_constraint(
        model,
        MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.([-2.0, -1.0], x), 0.0),
        MOI.LessThan(-1.0),
    )
    MOI.optimize!(model)
    @test MOI.get(model, MOI.TerminationStatus()) == MOI.INFEASIBLE
    @test MOI.get(model, MOI.DualStatus()) == MOI.NO_SOLUTION
    return
end

function test_large_time_limits()
    model = GLPK.Optimizer()
    MOI.set(model, MOI.TimeLimitSec(), 1e9)
    @test MOI.get(model, MOI.TimeLimitSec()) == nothing
    return
end

function test_fractional_time_limits()
    model = GLPK.Optimizer()
    MOI.set(model, MOI.TimeLimitSec(), 1.2345)
    @test MOI.get(model, MOI.TimeLimitSec()) == 1.235
    return
end

function test_empty_problem()
    model = MOI.Utilities.CachingOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
        GLPK.Optimizer(),
    )
    MOI.Utilities.reset_optimizer(model)
    MOI.add_variable(model)
    MOI.optimize!(model)
    @test MOI.get(model, MOI.TerminationStatus()) == MOI.OPTIMAL
    return
end

function test_empty_problem_infeasible()
    model = GLPK.Optimizer()
    x = MOI.add_variable(model)
    MOI.add_constraint(
        model,
        MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(0.0, x)], 0.0),
        MOI.GreaterThan(1.0),
    )
    MOI.add_constraint(
        model,
        MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(0.0, x)], 0.0),
        MOI.EqualTo(0.0),
    )
    MOI.optimize!(model)
    @test MOI.get(model, MOI.TerminationStatus()) == MOI.INFEASIBLE
    @test MOI.get(model, MOI.PrimalStatus()) == MOI.NO_SOLUTION
    @test MOI.get(model, MOI.DualStatus()) == MOI.NO_SOLUTION
    return
end

function test_empty_problem_unbounded()
    model = GLPK.Optimizer()
    x = MOI.add_variable(model)
    MOI.add_constraint(
        model,
        MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(0.0, x)], 0.0),
        MOI.EqualTo(0.0),
    )
    f = MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(1.0, x)], 0.0)
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    MOI.optimize!(model)
    @test MOI.get(model, MOI.TerminationStatus()) == MOI.DUAL_INFEASIBLE
    @test MOI.get(model, MOI.PrimalStatus()) == MOI.NO_SOLUTION
    @test MOI.get(model, MOI.DualStatus()) == MOI.NO_SOLUTION
    return
end

function test_negative_timelimitsec()
    model = GLPK.Optimizer()
    MOI.set(model, MOI.TimeLimitSec(), -1.23)
    @test MOI.get(model, MOI.TimeLimitSec()) == 0.0
    return
end

function test_unbounded_ray()
    model = GLPK.Optimizer(; method = GLPK.EXACT)
    c = [-1.0, 0.0]
    A = [1.0 1.0; -1.0 -1.0]
    b = [1.0, -1.0]
    x = MOI.add_variables(model, 2)
    MOI.set(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{Float64}}(),
        MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.(c, x), 0.0),
    )
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    for i in 1:2
        MOI.add_constraint(
            model,
            MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.(A[i, :], x), 0.0),
            MOI.LessThan(b[i]),
        )
    end
    MOI.optimize!(model)
    @test MOI.get(model, MOI.TerminationStatus()) == MOI.DUAL_INFEASIBLE
    return
end

"""
    test_variable_basis_status()

This  is a specially crafted linear program to expose the different variable
basis behavior of GLPK. Because the problem is degenerate, this test might break
in a future update of GLPK, but it works with GLPK_jll@5.0.0.

Example constructed from a model provided by @guimarqu in
https://github.com/jump-dev/GLPK.jl/pull/213.
"""
function test_variable_basis_status()
    str = """
    variables: x1, x2, x3, x4, x5, x6, x7, x8, x9
    minobjective: 1.0 * x9
    c1: x1 + x2 + x4 <= 1.0
    c4: x8 + x3 + x5 <= 1.0
    c7: x1 + x2 + x4 >= 1.0
    c8: x3 + x5 >= 1.0
    c9: -1.0*x1 >= 0.0
    c10: x5 + x3 >= 0.0
    c11: x6 + -1.0*x2 >= 0.0
    c17: x9 + -72.0*x1 + -108.0*x2 + -26.0*x3 + -144.0*x4 + -130.0*x5 + -18.0*x6 >= -202.0
    x1 in Interval(0.0, 1.0)
    x2 in Interval(0.0, 1.0)
    x3 in Interval(0.0, 1.0)
    x4 in Interval(0.0, 1.0)
    x5 in Interval(0.0, 1.0)
    x6 in Interval(0.0, 1.0)
    x7 in Interval(0.0, 0.0)
    x9 >= 0.0
    """
    model = GLPK.Optimizer()
    MOI.Utilities.loadfromstring!(model, str)
    MOI.optimize!(model)
    x = MOI.get(model, MOI.ListOfVariableIndices())
    status = MOI.get.(model, MOI.VariableBasisStatus(), x)
    x_val = MOI.get.(model, MOI.VariablePrimal(), x)
    @test x_val == [0, 0, 1, 1, 0, 0, 0, 0, 0]
    @test status == [
        MOI.BASIC,              # x1 is [0, 1] at 0 but in basis => degenerate
        MOI.BASIC,              # x2 is [0, 1] at 0 but in basis => degenerate
        MOI.NONBASIC_AT_UPPER,  # x3 is [0, 1] at 1
        MOI.NONBASIC_AT_UPPER,  # x4 is [0, 1] at 1
        MOI.NONBASIC_AT_LOWER,  # x5 is [0, 1] at 0
        MOI.NONBASIC_AT_LOWER,  # x6 is [0, 1] at 0
        MOI.NONBASIC,           # x7 is fixed variable
        MOI.SUPER_BASIC,        # x8 is a free variable at 0
        MOI.NONBASIC_AT_LOWER,  # x9 is >= 0 at 0
    ]
    return
end

function test_multiple_modifications()
    model = GLPK.Optimizer()

    x = MOI.add_variables(model, 3)

    saf = MOI.ScalarAffineFunction(
        [
            MOI.ScalarAffineTerm(1.0, x[1]),
            MOI.ScalarAffineTerm(1.0, x[2]),
            MOI.ScalarAffineTerm(1.0, x[3]),
        ],
        0.0,
    )
    ci1 = MOI.add_constraint(model, saf, MOI.LessThan(1.0))
    ci2 = MOI.add_constraint(model, saf, MOI.LessThan(2.0))

    MOI.set(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{Float64}}(),
        saf,
    )

    fc1 = MOI.get(model, MOI.ConstraintFunction(), ci1)
    @test MOI.coefficient.(fc1.terms) == [1.0, 1.0, 1.0]
    fc2 = MOI.get(model, MOI.ConstraintFunction(), ci2)
    @test MOI.coefficient.(fc2.terms) == [1.0, 1.0, 1.0]
    obj = MOI.get(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{Float64}}(),
    )
    @test MOI.coefficient.(obj.terms) == [1.0, 1.0, 1.0]

    changes_cis = [
        MOI.ScalarCoefficientChange(MOI.VariableIndex(1), 4.0)
        MOI.ScalarCoefficientChange(MOI.VariableIndex(1), 0.5)
        MOI.ScalarCoefficientChange(MOI.VariableIndex(3), 2.0)
    ]
    MOI.modify(model, [ci1, ci2, ci2], changes_cis)

    fc1 = MOI.get(model, MOI.ConstraintFunction(), ci1)
    @test MOI.coefficient.(fc1.terms) == [4.0, 1.0, 1.0]
    fc2 = MOI.get(model, MOI.ConstraintFunction(), ci2)
    @test MOI.coefficient.(fc2.terms) == [0.5, 1.0, 2.0]
end

function test_pr_220()
    for method in (GLPK.EXACT, GLPK.INTERIOR)
        model = GLPK.Optimizer(; method = GLPK.EXACT)
        MOI.optimize!(model)
        @test MOI.get(model, MOI.TerminationStatus()) == MOI.INVALID_MODEL
        @test MOI.get(model, MOI.RawStatusString()) ==
              "The problem instance has no rows/columns."
    end
    model = GLPK.Optimizer(; method = GLPK.SIMPLEX)
    MOI.optimize!(model)
    @test MOI.get(model, MOI.TerminationStatus()) == MOI.OPTIMAL
    @test MOI.get(model, MOI.RawStatusString()) == "Solution is optimal"
    return
end

function test_attribute_TimeLimitSec()
    model = GLPK.Optimizer()
    @test MOI.supports(model, MOI.TimeLimitSec())
    @test MOI.get(model, MOI.TimeLimitSec()) === nothing
    MOI.set(model, MOI.TimeLimitSec(), 0.0)
    @test MOI.get(model, MOI.TimeLimitSec()) == 0.0
    MOI.set(model, MOI.TimeLimitSec(), nothing)
    @test MOI.get(model, MOI.TimeLimitSec()) === nothing
    MOI.set(model, MOI.TimeLimitSec(), 1.0)
    @test MOI.get(model, MOI.TimeLimitSec()) == 1.0
    return
end

function test_copy_to_bug_HiGHS_172()
    model = MOI.Utilities.Model{Float64}()
    x = MOI.add_variable(model)
    F = MOI.ScalarAffineFunction{Float64}
    c1 = MOI.add_constraint(model, 2.0 * x, MOI.GreaterThan(0.0))
    c2 = MOI.add_constraint(model, zero(F), MOI.GreaterThan(0.0))
    c3 = MOI.add_constraint(model, 1.0 * x, MOI.EqualTo(1.0))
    h = GLPK.Optimizer()
    MOI.set(h, MOI.Silent(), true)
    index_map = MOI.copy_to(h, model)
    y = index_map[x]
    @test MOI.get(h, MOI.ConstraintFunction(), index_map[c1]) ≈ 2.0 * y
    @test MOI.get(h, MOI.ConstraintFunction(), index_map[c2]) ≈ zero(F)
    @test MOI.get(h, MOI.ConstraintFunction(), index_map[c3]) ≈ 1.0 * y
    @test MOI.get(h, MOI.ConstraintSet(), index_map[c1]) == MOI.GreaterThan(0.0)
    @test MOI.get(h, MOI.ConstraintSet(), index_map[c2]) == MOI.GreaterThan(0.0)
    @test MOI.get(h, MOI.ConstraintSet(), index_map[c3]) == MOI.EqualTo(1.0)
    MOI.optimize!(h)
    @test MOI.get(h, MOI.TerminationStatus()) == MOI.OPTIMAL
    return
end

end  # module

TestMOIWrapper.runtests()

# Copyright (c) 2012 GLPK.jl contributors
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the Licence, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

import GLPK
import SparseArrays
using Test

# Basically, same example as in the GLPK manual
# but using many more functions just to test them out

function glpk_tst_1()

    # suppress output
    prev_term_out = GLPK.glp_term_out(GLPK.GLP_OFF)

    # define the problem as in the original GLPK manual example
    lp = GLPK.glp_create_prob()
    GLPK.glp_set_prob_name(lp, "sample")
    GLPK.glp_set_obj_name(lp, "OBJECTIVE")
    GLPK.glp_set_obj_dir(lp, GLPK.GLP_MAX)
    GLPK.glp_add_rows(lp, 3)
    GLPK.glp_set_row_name(lp, 1, "p")
    GLPK.glp_set_row_bnds(lp, 1, GLPK.GLP_UP, 0.0, 100.0)
    GLPK.glp_set_row_name(lp, 2, "q")
    GLPK.glp_set_row_bnds(lp, 2, GLPK.GLP_UP, 0.0, 600.0)
    GLPK.glp_set_row_name(lp, 3, "r")
    GLPK.glp_set_row_bnds(lp, 3, GLPK.GLP_UP, 0.0, 300.0)
    GLPK.glp_add_cols(lp, 3)
    GLPK.glp_set_col_name(lp, 1, "x1")
    GLPK.glp_set_col_bnds(lp, 1, GLPK.GLP_LO, 0.0, 0.0)
    GLPK.glp_set_obj_coef(lp, 1, 10.0)
    GLPK.glp_set_col_name(lp, 2, "x2")
    GLPK.glp_set_col_bnds(lp, 2, GLPK.GLP_LO, 0.0, 0.0)
    GLPK.glp_set_obj_coef(lp, 2, 6.0)
    GLPK.glp_set_col_name(lp, 3, "x3")
    GLPK.glp_set_col_bnds(lp, 3, GLPK.GLP_LO, 0.0, 0.0)
    GLPK.glp_set_obj_coef(lp, 3, 4.0)
    ia = zeros(Cint, 9)
    ja = zeros(Cint, 9)
    ar = zeros(Float64, 9)
    ia[1] = 1
    ja[1] = 1
    ar[1] = 1.0
    ia[2] = 1
    ja[2] = 2
    ar[2] = 1.0
    ia[3] = 1
    ja[3] = 3
    ar[3] = 1.0
    ia[4] = 2
    ja[4] = 1
    ar[4] = 10.0
    ia[5] = 2
    ja[5] = 2
    ar[5] = 4.0
    ia[6] = 2
    ja[6] = 3
    ar[6] = 5.0
    ia[7] = 3
    ja[7] = 1
    ar[7] = 2.0
    ia[8] = 3
    ja[8] = 2
    ar[8] = 2.0
    ia[9] = 3
    ja[9] = 3
    ar[9] = 6.0
    @test GLPK.glp_check_dup(
        3,
        3,
        length(ia),
        GLPK.offset(ia),
        GLPK.offset(ja),
    ) == 0
    GLPK.glp_load_matrix(
        lp,
        9,
        GLPK.offset(ia),
        GLPK.offset(ja),
        GLPK.offset(ar),
    )

    # mess up with the problem definition, test
    # alternative way to set rows and columns
    r = Cint[3]
    GLPK.glp_del_rows(lp, length(r), GLPK.offset(r))
    GLPK.glp_add_rows(lp, 1)
    GLPK.glp_set_row_name(lp, 3, "r")
    GLPK.glp_set_row_bnds(lp, 3, GLPK.GLP_UP, 0.0, 300.0)

    GLPK.glp_set_mat_row(lp, 1, 0, C_NULL, C_NULL)
    GLPK.glp_set_mat_col(lp, 1, 0, C_NULL, C_NULL)

    indices = Cint[1, 2, 3]
    indices_p = GLPK.offset(indices)
    row1 = [1.0, 1.0, 1.0]
    row2 = [10.0, 4.0, 5.0]
    row3 = [2.0, 2.0, 6.0]
    GLPK.glp_set_mat_row(lp, 1, 3, indices_p, GLPK.offset(row1))
    GLPK.glp_set_mat_row(lp, 2, 3, indices_p, GLPK.offset(row2))
    GLPK.glp_set_mat_row(lp, 3, 3, indices_p, GLPK.offset(row3))
    col1 = [1.0, 10.0, 2.0]
    col2 = [1.0, 4.0, 2.0]
    col3 = [1.0, 5.0, 6.0]
    GLPK.glp_set_mat_col(lp, 1, 3, indices_p, GLPK.offset(col1))
    GLPK.glp_set_mat_col(lp, 2, 3, indices_p, GLPK.offset(col2))
    GLPK.glp_set_mat_col(lp, 3, 3, indices_p, GLPK.offset(col3))

    # test random scaling of the coefficients and
    # letting the library figure out the scaling
    # and order by itself
    for i in 1:GLPK.glp_get_num_rows(lp)
        GLPK.glp_set_rii(lp, i, rand())
    end
    for i in 1:GLPK.glp_get_num_cols(lp)
        GLPK.glp_set_sjj(lp, i, rand())
    end
    GLPK.glp_scale_prob(lp, GLPK.GLP_SF_AUTO)
    GLPK.glp_unscale_prob(lp)
    GLPK.glp_sort_matrix(lp)

    # test general problem properties
    @test unsafe_string(GLPK.glp_get_prob_name(lp)) == "sample"
    @test unsafe_string(GLPK.glp_get_obj_name(lp)) == "OBJECTIVE"
    @test GLPK.glp_get_obj_dir(lp) == GLPK.GLP_MAX
    @test GLPK.glp_get_num_rows(lp) == 3
    @test GLPK.glp_get_num_cols(lp) == 3
    @test GLPK.glp_get_obj_coef(lp, 0) == 0.0
    @test GLPK.glp_get_num_nz(lp) == 9

    # test rows properties
    @test unsafe_string(GLPK.glp_get_row_name(lp, 1)) == "p"
    @test GLPK.glp_get_row_type(lp, 1) == GLPK.GLP_UP
    @test GLPK.glp_get_row_lb(lp, 1) == -floatmax(Float64)
    @test GLPK.glp_get_row_ub(lp, 1) == 100.0
    indices = zeros(Cint, 3)
    coefficients = zeros(Cdouble, 3)
    @test GLPK.glp_get_mat_row(
        lp,
        1,
        GLPK.offset(indices),
        GLPK.offset(coefficients),
    ) == 3
    @test indices == [1, 2, 3]
    @test coefficients == [1.0, 1.0, 1.0]
    @test GLPK.glp_get_rii(lp, 1) == 1.0

    @test unsafe_string(GLPK.glp_get_row_name(lp, 2)) == "q"
    @test GLPK.glp_get_row_type(lp, 2) == GLPK.GLP_UP
    @test GLPK.glp_get_row_lb(lp, 2) == -floatmax(Float64)
    @test GLPK.glp_get_row_ub(lp, 2) == 600.0
    @test GLPK.glp_get_mat_row(
        lp,
        2,
        GLPK.offset(indices),
        GLPK.offset(coefficients),
    ) == 3
    @test indices == [1, 2, 3]
    @test coefficients == [10.0, 4.0, 5.0]
    @test GLPK.glp_get_rii(lp, 2) == 1.0

    @test unsafe_string(GLPK.glp_get_row_name(lp, 3)) == "r"
    @test GLPK.glp_get_row_type(lp, 3) == GLPK.GLP_UP
    @test GLPK.glp_get_row_lb(lp, 3) == -floatmax(Float64)
    @test GLPK.glp_get_row_ub(lp, 3) == 300.0
    @test GLPK.glp_get_mat_row(
        lp,
        3,
        GLPK.offset(indices),
        GLPK.offset(coefficients),
    ) == 3
    @test indices == [1, 2, 3]
    @test coefficients == [2.0, 2.0, 6.0]
    @test GLPK.glp_get_rii(lp, 3) == 1.0

    # test columns properties
    @test unsafe_string(GLPK.glp_get_col_name(lp, 1)) == "x1"
    @test GLPK.glp_get_col_type(lp, 1) == GLPK.GLP_LO
    @test GLPK.glp_get_col_lb(lp, 1) == 0.0
    @test GLPK.glp_get_col_ub(lp, 1) == floatmax(Float64)
    @test GLPK.glp_get_obj_coef(lp, 1) == 10.0

    @test unsafe_string(GLPK.glp_get_col_name(lp, 2)) == "x2"
    @test GLPK.glp_get_col_type(lp, 2) == GLPK.GLP_LO
    @test GLPK.glp_get_col_lb(lp, 2) == 0.0
    @test GLPK.glp_get_col_ub(lp, 2) == floatmax(Float64)
    @test GLPK.glp_get_obj_coef(lp, 2) == 6.0

    @test unsafe_string(GLPK.glp_get_col_name(lp, 3)) == "x3"
    @test GLPK.glp_get_col_type(lp, 3) == GLPK.GLP_LO
    @test GLPK.glp_get_col_lb(lp, 3) == 0.0
    @test GLPK.glp_get_col_ub(lp, 3) == floatmax(Float64)
    @test GLPK.glp_get_obj_coef(lp, 3) == 4.0

    # test index creation for retreiving row/column indices
    # by name
    GLPK.glp_create_index(lp)
    for (ri, rn) in enumerate(["p", "q", "r"])
        @test GLPK.glp_find_row(lp, rn) == ri
    end
    @test GLPK.glp_find_row(lp, "?") == 0
    for (ci, cn) in enumerate(["x1", "x2", "x3"])
        @test GLPK.glp_find_col(lp, cn) == ci
    end
    @test GLPK.glp_find_col(lp, "?") == 0
    GLPK.glp_delete_index(lp)

    # mess up the status of rows and columns, and
    # test various basis-generation algorithms
    for i in 1:GLPK.glp_get_num_rows(lp)
        GLPK.glp_set_row_stat(lp, i, GLPK.GLP_BS)
    end
    for i in 1:GLPK.glp_get_num_cols(lp)
        GLPK.glp_set_col_stat(lp, i, GLPK.GLP_NF)
    end

    GLPK.glp_std_basis(lp)
    GLPK.glp_cpx_basis(lp)
    GLPK.glp_adv_basis(lp, 0)

    # # set parameters, reset them, set again
    param = GLPK.glp_smcp()
    GLPK.glp_init_smcp(param)
    param.msg_lev = GLPK.GLP_MSG_ERR
    param.presolve = GLPK.GLP_ON

    # verify status before solving
    @test GLPK.glp_get_status(lp) == GLPK.GLP_UNDEF
    @test GLPK.glp_get_prim_stat(lp) == GLPK.GLP_UNDEF
    @test GLPK.glp_get_dual_stat(lp) == GLPK.GLP_UNDEF

    # now solve, simplex algorithm
    flag = GLPK.glp_simplex(lp, param)

    # verify status after solving
    @test flag == 0
    @test GLPK.glp_get_status(lp) == GLPK.GLP_OPT
    @test GLPK.glp_get_prim_stat(lp) == GLPK.GLP_FEAS
    @test GLPK.glp_get_dual_stat(lp) == GLPK.GLP_FEAS
    @test GLPK.glp_get_unbnd_ray(lp) == 0

    ae_max = Ref{Cdouble}()
    ae_ind = Ref{Cint}()
    re_max = Ref{Cdouble}()
    re_ind = Ref{Cint}()
    GLPK.glp_check_kkt(
        lp,
        GLPK.GLP_SOL,
        GLPK.GLP_KKT_PE,
        ae_max,
        ae_ind,
        re_max,
        re_ind,
    )
    @test ae_max[] == 0 ? (ae_ind[] == 0) :
          (1 <= ae_ind[] <= GLPK.glp_get_num_rows(lp))
    @test re_max[] == 0 ? (re_ind[] == 0) :
          (1 <= re_ind[] <= GLPK.glp_get_num_rows(lp))
    GLPK.glp_check_kkt(
        lp,
        GLPK.GLP_SOL,
        GLPK.GLP_KKT_PB,
        ae_max,
        ae_ind,
        re_max,
        re_ind,
    )
    @test ae_max[] == 0 ? (ae_ind[] == 0) :
          (
        1 <= ae_ind[] <= GLPK.glp_get_num_rows(lp) + GLPK.glp_get_num_cols(lp)
    )
    @test re_max[] == 0 ? (re_ind[] == 0) :
          (
        1 <= re_ind[] <= GLPK.glp_get_num_rows(lp) + GLPK.glp_get_num_cols(lp)
    )

    # solve again, using simplex with exact arithmetics
    flag = GLPK.glp_exact(lp, param)

    # verify status after solving
    @test flag == 0
    @test GLPK.glp_get_status(lp) == GLPK.GLP_OPT
    @test GLPK.glp_get_prim_stat(lp) == GLPK.GLP_FEAS
    @test GLPK.glp_get_dual_stat(lp) == GLPK.GLP_FEAS
    @test GLPK.glp_get_unbnd_ray(lp) == 0

    ae_max = Ref{Cdouble}()
    ae_ind = Ref{Cint}()
    re_max = Ref{Cdouble}()
    re_ind = Ref{Cint}()
    GLPK.glp_check_kkt(
        lp,
        GLPK.GLP_SOL,
        GLPK.GLP_KKT_PE,
        ae_max,
        ae_ind,
        re_max,
        re_ind,
    )
    @test ae_max[] == 0 ? (ae_ind[] == 0) :
          (1 <= ae_ind[] <= GLPK.glp_get_num_rows(lp))
    @test re_max[] == 0 ? (re_ind[] == 0) :
          (1 <= re_ind[] <= GLPK.glp_get_num_rows(lp))
    GLPK.glp_check_kkt(
        lp,
        GLPK.GLP_SOL,
        GLPK.GLP_KKT_PB,
        ae_max,
        ae_ind,
        re_max,
        re_ind,
    )
    @test ae_max[] == 0 ? (ae_ind[] == 0) :
          (
        1 <= ae_ind[] <= GLPK.glp_get_num_rows(lp) + GLPK.glp_get_num_cols(lp)
    )
    @test re_max[] == 0 ? (re_ind[] == 0) :
          (
        1 <= re_ind[] <= GLPK.glp_get_num_rows(lp) + GLPK.glp_get_num_cols(lp)
    )

    # verify results
    tol = 1e-10
    @test GLPK.glp_get_row_stat(lp, 1) == GLPK.GLP_NU
    @test GLPK.glp_get_row_prim(lp, 1) == 100.0
    @test abs(GLPK.glp_get_row_dual(lp, 1) - 10.0 / 3) < tol

    @test GLPK.glp_get_row_stat(lp, 2) == GLPK.GLP_NU
    @test GLPK.glp_get_row_prim(lp, 2) == 600.0
    @test abs(GLPK.glp_get_row_dual(lp, 2) - 2.0 / 3) < tol

    @test GLPK.glp_get_row_stat(lp, 3) == GLPK.GLP_BS
    @test GLPK.glp_get_row_prim(lp, 3) == 200.0
    @test abs(GLPK.glp_get_row_dual(lp, 3) - 0.0) < tol

    @test GLPK.glp_get_col_stat(lp, 1) == GLPK.GLP_BS
    @test abs(GLPK.glp_get_col_prim(lp, 1) - 100.0 / 3) < tol
    @test abs(GLPK.glp_get_col_dual(lp, 1) - 0.0) < tol

    @test GLPK.glp_get_col_stat(lp, 2) == GLPK.GLP_BS
    @test abs(GLPK.glp_get_col_prim(lp, 2) - 200.0 / 3) < tol
    @test abs(GLPK.glp_get_col_dual(lp, 2) - 0.0) < tol

    @test GLPK.glp_get_col_stat(lp, 3) == GLPK.GLP_NL
    @test abs(GLPK.glp_get_col_prim(lp, 3) - 0.0) < tol
    @test abs(GLPK.glp_get_col_dual(lp, 3) - (-8.0 / 3)) < tol

    @test abs(GLPK.glp_get_obj_val(lp) - 2200.0 / 3) < tol

    # solve again, using interior point method
    param = GLPK.glp_iptcp()
    GLPK.glp_init_iptcp(param)
    param.msg_lev = GLPK.GLP_MSG_ERR
    flag = GLPK.glp_interior(lp, param)

    # verify status after solving
    @test flag == 0
    @test GLPK.glp_get_status(lp) == GLPK.GLP_OPT
    @test GLPK.glp_get_prim_stat(lp) == GLPK.GLP_FEAS
    @test GLPK.glp_get_dual_stat(lp) == GLPK.GLP_FEAS
    @test GLPK.glp_get_unbnd_ray(lp) == 0

    ae_max = Ref{Cdouble}()
    ae_ind = Ref{Cint}()
    re_max = Ref{Cdouble}()
    re_ind = Ref{Cint}()
    GLPK.glp_check_kkt(
        lp,
        GLPK.GLP_IPT,
        GLPK.GLP_KKT_PE,
        ae_max,
        ae_ind,
        re_max,
        re_ind,
    )
    @test ae_max[] == 0 ? (ae_ind[] == 0) :
          (1 <= ae_ind[] <= GLPK.glp_get_num_rows(lp))
    @test re_max[] == 0 ? (re_ind[] == 0) :
          (1 <= re_ind[] <= GLPK.glp_get_num_rows(lp))
    GLPK.glp_check_kkt(
        lp,
        GLPK.GLP_IPT,
        GLPK.GLP_KKT_PB,
        ae_max,
        ae_ind,
        re_max,
        re_ind,
    )
    @test ae_max[] == 0 ? (ae_ind[] == 0) :
          (
        1 <= ae_ind[] <= GLPK.glp_get_num_rows(lp) + GLPK.glp_get_num_cols(lp)
    )
    @test re_max[] == 0 ? (re_ind[] == 0) :
          (
        1 <= re_ind[] <= GLPK.glp_get_num_rows(lp) + GLPK.glp_get_num_cols(lp)
    )
    GLPK.glp_check_kkt(
        lp,
        GLPK.GLP_IPT,
        GLPK.GLP_KKT_DE,
        ae_max,
        ae_ind,
        re_max,
        re_ind,
    )
    @test ae_max[] == 0 ? (ae_ind[] == 0) :
          (
        1 <= ae_ind[] - GLPK.glp_get_num_rows(lp) <= GLPK.glp_get_num_cols(lp)
    )
    @test re_max[] == 0 ? (re_ind[] == 0) :
          (
        1 <= re_ind[] - GLPK.glp_get_num_rows(lp) <= GLPK.glp_get_num_cols(lp)
    )
    GLPK.glp_check_kkt(
        lp,
        GLPK.GLP_IPT,
        GLPK.GLP_KKT_DB,
        ae_max,
        ae_ind,
        re_max,
        re_ind,
    )
    @test ae_max[] == 0 ? (ae_ind[] == 0) :
          (
        1 <= ae_ind[] <= GLPK.glp_get_num_rows(lp) + GLPK.glp_get_num_cols(lp)
    )
    @test re_max[] == 0 ? (re_ind[] == 0) :
          (
        1 <= re_ind[] <= GLPK.glp_get_num_rows(lp) + GLPK.glp_get_num_cols(lp)
    )

    # verify results
    tol = 1e-10
    @test GLPK.glp_get_row_stat(lp, 1) == GLPK.GLP_NU
    @test GLPK.glp_get_row_prim(lp, 1) == 100.0
    @test abs(GLPK.glp_get_row_dual(lp, 1) - 10.0 / 3) < tol

    @test GLPK.glp_get_row_stat(lp, 2) == GLPK.GLP_NU
    @test GLPK.glp_get_row_prim(lp, 2) == 600.0
    @test abs(GLPK.glp_get_row_dual(lp, 2) - 2.0 / 3) < tol

    @test GLPK.glp_get_row_stat(lp, 3) == GLPK.GLP_BS
    @test GLPK.glp_get_row_prim(lp, 3) == 200.0
    @test abs(GLPK.glp_get_row_dual(lp, 3) - 0.0) < tol

    @test GLPK.glp_get_col_stat(lp, 1) == GLPK.GLP_BS
    @test abs(GLPK.glp_get_col_prim(lp, 1) - 100.0 / 3) < tol
    @test abs(GLPK.glp_get_col_dual(lp, 1) - 0.0) < tol

    @test GLPK.glp_get_col_stat(lp, 2) == GLPK.GLP_BS
    @test abs(GLPK.glp_get_col_prim(lp, 2) - 200.0 / 3) < tol
    @test abs(GLPK.glp_get_col_dual(lp, 2) - 0.0) < tol

    @test GLPK.glp_get_col_stat(lp, 3) == GLPK.GLP_NL
    @test abs(GLPK.glp_get_col_prim(lp, 3) - 0.0) < tol
    @test abs(GLPK.glp_get_col_dual(lp, 3) - (-8.0 / 3)) < tol

    @test abs(GLPK.glp_get_obj_val(lp) - 2200.0 / 3) < tol

    # reset terminal output status
    return GLPK.glp_term_out(prev_term_out)
end

glpk_tst_1()

# Copyright (c) 2012 GLPK.jl contributors
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the Licence, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

using Test
import GLPK

# Testing reading and writing problem files

function glpk_tst_2()
    prev_term_out = GLPK.glp_term_out(GLPK.GLP_OFF)

    datadir = joinpath(dirname(@__FILE__), "data")
    @assert isdir(datadir)

    lp = GLPK.glp_create_prob()

    # test GLPK native format
    GLPK.glp_read_prob(lp, 0, joinpath(datadir, "sample.prob"))
    @test GLPK.glp_simplex(lp, C_NULL) == 0

    @test GLPK.glp_read_prob(lp, 0, joinpath(datadir, "plan.lp")) != 0
    @test GLPK.glp_write_prob(lp, 0, "") != 0

    mktemp() do path, _
        return GLPK.glp_write_prob(lp, 0, path)
    end

    # test MPS format
    @test GLPK.glp_read_mps(
        lp,
        GLPK.GLP_MPS_FILE,
        C_NULL,
        "nonexisting_file",
    ) != 0

    GLPK.glp_read_mps(
        lp,
        GLPK.GLP_MPS_DECK,
        C_NULL,
        joinpath(datadir, "plan.mps"),
    )
    @test GLPK.glp_simplex(lp, C_NULL) == 0

    @test GLPK.glp_read_mps(
        lp,
        GLPK.GLP_MPS_DECK,
        C_NULL,
        joinpath(datadir, "plan.lp"),
    ) != 0
    @test GLPK.glp_write_mps(lp, GLPK.GLP_MPS_FILE, C_NULL, "") != 0

    mktemp() do path, _
        return GLPK.glp_write_mps(lp, GLPK.GLP_MPS_FILE, C_NULL, path)
    end

    # Test LP format
    @test GLPK.glp_read_lp(lp, C_NULL, "nonexisting_file") != 0

    GLPK.glp_read_lp(lp, C_NULL, joinpath(datadir, "plan.lp"))
    @test GLPK.glp_simplex(lp, C_NULL) == 0

    @test GLPK.glp_read_lp(lp, C_NULL, joinpath(datadir, "plan.mps")) != 0
    @test GLPK.glp_write_lp(lp, C_NULL, "") != 0

    mktemp() do path, _
        return GLPK.glp_write_lp(lp, C_NULL, path)
    end

    GLPK.glp_term_out(prev_term_out)
    return GLPK.glp_delete_prob(lp)
end

glpk_tst_2()

# Copyright (c) 2012 GLPK.jl contributors
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the Licence, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

module GLPK

import GLPK_jll

function __init__()
    global libglpk = GLPK_jll.libglpk
    p = glp_version()
    version = VersionNumber(parse.(Int, split(unsafe_string(p), "."))...)
    if !(v"4.64.0" <= version <= v"5.0.0")
        error(
            """
            You have installed version $version of GLPK, which is not supported
            by GLPK.jl. We prefer GLPK version 5.0, but this may also work on
            versions 4.64 and newer.

            After installing GLPK 5.0, run:

                import Pkg
                Pkg.rm("GLPK")
                Pkg.add("GLPK")

            If you have a newer version of GLPK installed, changes may need to
            be made to the Julia code. Please open an issue at
            https://github.com/jump-dev/GLPK.jl.
            """,
        )
    end
    return
end

include("gen/libglpk_common.jl")
include("gen/libglpk_api.jl")

const GLP_DBL_MAX = prevfloat(Inf)

"""
    offset(x::Vector)

GLPK uses 1-based indexing for its arrays. But since C has 0-based indexing, all
1-based vectors passed to GLPK need to be padded with a "0'th" element that will
never be accessed. To avoid doing this padding in Julia, we convert the vector
to a reference, and use the optional second argument to ensure the reference
points to the "0'th" element of the array. This is safe to do, provided C never
accesses `x[0]`.

See the GLPK manual for more details.
"""
offset(x::Vector) = Ref(x, 0)

include("MOI_wrapper/MOI_wrapper.jl")
include("MOI_wrapper/MOI_copy.jl")
include("MOI_wrapper/MOI_callbacks.jl")

# GLPK exports all `GLP_XXX` and `glp_xxx` symbols. If you don't want all of
# these symbols in your environment, then use `import GLPK` instead of
# `using GLPK`.

for sym in names(@__MODULE__, all = true)
    sym_string = string(sym)
    if startswith(sym_string, "GLP_") || startswith(sym_string, "glp_")
        @eval export $sym
    end
end

include("precompile.jl")
_precompile_()

end
